	PROGRAM POLY
**************************************************************
*  Space division on the polyhedra and printing sphere radii *
*  By brothers Savrasov.                                     *
**************************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
        INCLUDE 'PARAM.DAT'
	CHARACTER*60 INIFILE,STRFILE
        PARAMETER (NTRMAX=NENVMAX)
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,NTR(NENVMAX),IREFAT(0:NVCMAX),NRAD(NSORTMAX)
     &    ,LISTTR(3,NTRMAX,NENVMAX),NSHE(NSORTMAX),NPOL(0:NSORTMAX)
        DIMENSION WR(NPAT),RMT(NPAT),POLIST(3,NVCMAX),SASA(NSORTMAX)
     &    ,WS(NVCMAX),POLI(3,NVCMAX),RMT0(NPAT)
     &    ,TAU(3,NPAT),TAU0(3,NPAT)
	CHARACTER*10 TXTEL(NSORTMAX)
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM
        COMMON /LATTICE/A(3,3)
        COMMON /BASIS/  TAU
        COMMON /BASIS0/ TAU0
        COMMON /POTCOM/ SWZ,SMT(NSORTMAX)
        COMMON /LATPAR/ PAR
        COMMON /STORE1/ NP0,POLIST,NTR,LISTTR
        COMMON /SRFINP/ NDIV1,NDIV2
    	COMMON /ASASPH/ SASA
    	COMMON /INTMESH/NSHE,NPOL,SROU(NSORTMAX)
	COMMON /RADMESH/NRAD
    	COMMON /TXTEL/  TXTEL
    	DATA PI/3.141592653589793D0/,IUN/6/
    	SQPI43=SQRT(4.D0*PI/3.D0)
*  GET INPUT DATA
        PRINT1000,'INIFILE? '
        READ(5,1001)INIFILE
        PRINT1000,'STRFILE? '
        READ(5,1001)STRFILE
        CALL READINI(INIFILE)
        CALL READSTR(STRFILE)
        CALL RADMSH
*  SET BLOWING SPHERE RADII
        DO 10 I=1,NATOM
        WR(I)=SASA(IS(I))
  10    CONTINUE
        CALL NASOS(WR,RMT ,A(1,1),A(1,2),A(1,3),TAU ,NATOM)
        CALL NASOS(WR,RMT0,A(1,1),A(1,2),A(1,3),TAU0,NATOM)
*  DETERMINE POLYHEDRA
        OMEGI=0.D0
        DO 40 IATOM=1,NATOM                   !!! over atoms
	ISORT=IS(IATOM)
        CALL POLISRCH(RMT0,IATOM,NDIV1,NGR,RMIN,RMAX
     &      ,VOL,RV,POLI,WS,IREFAT)
	OMEGI=OMEGI+VOL*PAR**3
	RLOC=0.D0
	DO 20 IPL=1,NGR
	RT=SQRT(POLI(1,IPL)**2+POLI(2,IPL)**2+POLI(3,IPL)**2)
	RLOC=MAX(RT,RLOC)
  20    CONTINUE
        SASA(IS(IATOM))=(3.D0/4.D0/PI*VOL)**(1.D0/3.D0)*PAR
        WRITE(IUN,1010)(TAU(I,IATOM),I=1,3),TXTEL(IS(IATOM))
*  PRINT SPHERE RADII
        WRITE(IUN,1020)SMT(IS(IATOM)),SROU(IS(IATOM))
        WRITE(IUN,1030)RMIN*PAR,RMAX*PAR
        WRITE(IUN,1040)RMT(IATOM)*PAR,RV*PAR
        WRITE(IUN,1050)SASA(IS(IATOM)),NGR,NRAD(IS(IATOM)),NSHE(ISORT)
        WRITE(IUN,1055)RLOC,NGR
  40	CONTINUE                              !!! over atoms
        OMEGA=4.D0*PI/3.D0*SWZ**3*NATOM
        IF(ABS(OMEGI-OMEGA).GE.1.D-06)WRITE(IUN,1060)OMEGA,OMEGI
1000    FORMAT($,1X,A)
1001	FORMAT(A)
1010	FORMAT(1X,'Position : (',G12.5,',',G12.5,',',G12.5,') ',A10)
1020	FORMAT(1X,'input mt-sphere is ',G14.7,' ; input rou-sphere is ',
     &  G14.7)
1030	FORMAT(1X,'exact mt-sphere is ',G14.7,' ; exact rou-sphere is ',
     &  G14.7)
1040	FORMAT(1X,'blowing  sphere is ',G14.7,' ; validity  radius is ',
     &  G14.7)
1050    FORMAT(1X,'input as-sphere is ',G14.7,' ; ncel=',I3,',nrad=',
     &  I3,',nshe=',I3)
1055    FORMAT(1X,'localiz. sphere is ',G14.7,' ; npln=',I3)
1060	FORMAT(1X,'Error in volume definition : exact value is ',G14.7,' ,
     &  value found is ',G14.7)
	END


        SUBROUTINE READINI(INIFILE)
************************************************************
*  <READINI> reads control parameters,atomic stucture data *
*  iterative procedures limits and accuracy parameters     *
************************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
        INCLUDE 'PARAM.DAT'
        INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &         ,LR(NSORTMAX),NSHE(NSORTMAX),NPOL(0:NSORTMAX)
        DIMENSION Z(NSORTMAX),ZCORE(NSORTMAX),SROU(NSORTMAX)
        CHARACTER*60 INIFILE,TXTEL(NSORTMAX)*10
        COMMON /PARAM/   NSORT,IS,ILST,ILSB,ILSV,NATOM
        COMMON /POTCOM/  SWZ,SMT(NSORTMAX)
	COMMON /DENS/    Z,ZCORE
        COMMON /LATPAR/  PAR
        COMMON /INTMESH/ NSHE,NPOL,SROU
        COMMON /ASASPH/  SW(NSORTMAX)
	COMMON /RELATIV/ LR
        COMMON /TXTEL/   TXTEL
        DATA PI/3.141592653589793D0/
        OPEN(1,FILE=INIFILE,STATUS='OLD')
        DO 10 I=1,13
        READ(1,*)
  10	CONTINUE
        READ(1,*)NATOM,NSORT
	IF(NATOM.GT.NPAT)STOP'NATOM > NPAT, INCREASE NPAT IN PARAM.DAT'
	IF(NSORT.GT.NSORTMAX)STOP'NSORT > NSORTMAX, 
     &  INCREASE NSORTMAX IN PARAM.DAT'
        READ(1,*)PAR
        READ(1,*)(IS(I),I=1,NATOM)
        READ(1,*)NKAP
        DO 50 ISORT=1,NSORT
        READ(1,1000)TXTEL(ISORT)
        READ(1,*)Z(ISORT),ZCORE(ISORT),LR(ISORT)
        READ(1,*)SMT(ISORT),SROU(ISORT),SW(ISORT)
        READ(1,*)ILST(ISORT),ILSB(ISORT),ILSV(ISORT)
	READ(1,*)
	NSHE(ISORT)=NSHEMAX
	NPOL(ISORT)=NPOLMAX
        DO 30 IKAP=1,NKAP
        READ(1,*)
        READ(1,*)
        READ(1,*)
        READ(1,*)
        READ(1,*)
        READ(1,*)
  30	CONTINUE
	READ(1,*)
        READ(1,*)NC
        DO 40 IC=1,NC
        READ(1,*)
  40	CONTINUE
  50	CONTINUE
	DO 60 I=1,13
	READ(1,*)
  60	CONTINUE
	READ(1,*)N1,N2,N3
        CLOSE(1)
1000    FORMAT(A)
        END

        SUBROUTINE READSTR(STRFILE)
        IMPLICIT REAL*8 (A-H,O-Z)
        INCLUDE 'PARAM.DAT'
        CHARACTER STRFILE*60,KOVFILE*60,SYS*1,TXT*72,STRING(80)*1
        INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
        DIMENSION RBASR(3,3),TAUR(3,NPAT),BASR(3),BBASR(3,3),ORTH(2:3)
     &    ,GBAS(3,3),RBAS(3,3),BBAS(3,3),TAU(3,NPAT),STRAIN(3,3,2)
     &    ,RSTN(3,3),TAU0(3,NPAT),TAU0R(3,NPAT)
        COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM   !!! from init
        COMMON /LATTICE/RBAS,GBAS                       !!! from init
        COMMON /MANSTR/ ISTRAIN,IBAS,IBZ,ICALC          !!! from init
        COMMON /BASIS/  TAU                             !!! from init
        COMMON /BASIS0/ TAU0                            !!! from init
        COMMON /SRFINP/ NDIV1,NDIV2
        COMMON /LATPAR/ PAR,ORTH,OMEGAC,STRAIN          !!! from init
        COMMON /GROUPOUT/NGROUP                         !!! from group
        COMMON /UNIT/   IUN                             !!! from init
        DATA PI/3.141592653589793D0/
        OPEN(UNIT=1,FILE=STRFILE,STATUS='OLD')
        READ(1,*)
        READ(1,1001)TXT
        READ(1,*) NATOM0,ORTH
        READ(1,*) IBAS,IBZ,ICALC,ISTRAIN
        READ(1,*) NDIV1,NDIV2
        READ(1,*) NVECMX,ALPHA
        IF(NATOM0.NE.NATOM)STOP'<READSTR>: # OF ATOMS MISMATCHES
     &  IN STRFILE, CHECK IT'
        READ(1,1000)TXT
        DO 10 IVEC=1,3
        IF(ICALC.NE.1)THEN
        READ(1,*)(RBASR(I,IVEC),I=1,3)
        ELSEIF(ICALC.EQ.1)THEN
        READ(1,1020)STRING
        CALL COMPVEC(STRING,RBASR(1,IVEC),3)
        ENDIF
  10    CONTINUE
        READ(1,1000)TXT
        DO 15 IATOM=1,NATOM
        IF(IBAS.EQ.1)THEN     !!! basis in Cartesian coordinates
        IF(ICALC.NE.1)THEN
        READ(1,*)(TAU0R(I,IATOM),I=1,3)
        ELSEIF(ICALC.EQ.1)THEN!!! using calculator
        READ(1,1020)STRING
        CALL COMPVEC(STRING,TAU0R(1,IATOM),3)
        ENDIF
        ELSEIF(IBAS.NE.1)THEN !!! basis in units of RBAS
        IF(ICALC.NE.1)THEN
        READ(1,*)(BASR(I),I=1,3)
        ELSEIF(ICALC.EQ.1)THEN!!! using calculator
        READ(1,1020)STRING
        CALL COMPVEC(STRING,BASR(1),3)
        ENDIF
        TAU0R(1,IATOM)=BASR(1)*RBASR(1,1)
     &                +BASR(2)*RBASR(1,2)
     &                +BASR(3)*RBASR(1,3)
        TAU0R(2,IATOM)=BASR(1)*RBASR(2,1)
     &                +BASR(2)*RBASR(2,2)
     &                +BASR(3)*RBASR(2,3)
        TAU0R(3,IATOM)=BASR(1)*RBASR(3,1)
     &                +BASR(2)*RBASR(3,2)
     &                +BASR(3)*RBASR(3,3)
        ENDIF
  15    CONTINUE
        READ(1,1000)TXT
        DO 20 IATOM=1,NATOM
        IF(IBAS.EQ.1)THEN     !!! basis in Cartesian coordinates
        IF(ICALC.NE.1)THEN
        READ(1,*)(TAUR(I,IATOM),I=1,3)
        ELSEIF(ICALC.EQ.1)THEN!!! using calculator
        READ(1,1020)STRING
        CALL COMPVEC(STRING,TAUR(1,IATOM),3)
        ENDIF
        ELSEIF(IBAS.NE.1)THEN !!! basis in units of RBAS
        IF(ICALC.NE.1)THEN
        READ(1,*)(BASR(I),I=1,3)
        ELSEIF(ICALC.EQ.1)THEN!!! using calculator
        READ(1,1020)STRING
        CALL COMPVEC(STRING,BASR(1),3)
        ENDIF
        TAUR(1,IATOM)=BASR(1)*RBASR(1,1)
     &               +BASR(2)*RBASR(1,2)
     &               +BASR(3)*RBASR(1,3)
        TAUR(2,IATOM)=BASR(1)*RBASR(2,1)
     &               +BASR(2)*RBASR(2,2)
     &               +BASR(3)*RBASR(2,3)
        TAUR(3,IATOM)=BASR(1)*RBASR(3,1)
     &               +BASR(2)*RBASR(3,2)
     &               +BASR(3)*RBASR(3,3)
        ENDIF
  20    CONTINUE
        READ(1,1000)TXT
        DO 30 I=1,3
        IF(ICALC.NE.1)THEN
        READ(1,*)(STRAIN(I,J,1),J=1,3)
        ELSEIF(ICALC.EQ.1)THEN
        READ(1,1020)STRING
        CALL COMPVEC(STRING,BASR(1),3)
        STRAIN(I,1,1)=BASR(1)
        STRAIN(I,2,1)=BASR(2)
        STRAIN(I,3,1)=BASR(3)
        ENDIF
  30    CONTINUE
C  SET RECIPROCAL STRAIN MATRIX: S*S^(-1)=1
        CALL CROSS(RSTN(1,1),STRAIN(1,2,1),STRAIN(1,3,1))
        CALL CROSS(RSTN(1,2),STRAIN(1,3,1),STRAIN(1,1,1))
        CALL CROSS(RSTN(1,3),STRAIN(1,1,1),STRAIN(1,2,1))
        W=STRAIN(1,1,1)*RSTN(1,1)
     &   +STRAIN(2,1,1)*RSTN(2,1)
     &   +STRAIN(3,1,1)*RSTN(3,1)
        IF(ABS(W).LE.1.D-10)STOP'<READSTR>:: WRONG STRAIN, DET=0'
        DO 40 I=1,3
        STRAIN(1,I,2)=RSTN(I,1)/W
        STRAIN(2,I,2)=RSTN(I,2)/W
        STRAIN(3,I,2)=RSTN(I,3)/W
  40    CONTINUE
        READ(1,*)
        READ(1,*)SYS
        READ(1,1000)TXT
        DO 50 IVEC=1,3
        IF(ICALC.NE.1)THEN
        READ(1,*)(BBASR(I,IVEC),I=1,3)
        ELSEIF(ICALC.EQ.1)THEN
        READ(1,1020)STRING
        CALL COMPVEC(STRING,BBASR(1,IVEC),3)
        ENDIF
  50    CONTINUE
C  ACCOUNT FOR ORTHOROMBICITY PARAMETERS
        DO 90 I=2,3
        DO 70 IVEC=1,3
        RBASR(I,IVEC)=RBASR(I,IVEC)*ORTH(I)
        BBASR(I,IVEC)=BBASR(I,IVEC)/ORTH(I)
  70    CONTINUE
        DO 80 IATOM=1,NATOM
        TAU0R(I,IATOM)=TAU0R(I,IATOM)*ORTH(I)
        TAU R(I,IATOM)=TAU R(I,IATOM)*ORTH(I)
  80    CONTINUE
  90    CONTINUE
C  APPLY STRAIN MATRIX FOR TRANSLATIONS:  R'=S*R
        DO 150 IVEC=1,3
        DO 150 I=1,3
        RBAS(I,IVEC)=0.D0
        DO 140 J=1,3
        RBAS(I,IVEC)=RBAS(I,IVEC)+STRAIN(I,J,1)*RBASR(J,IVEC)
 140    CONTINUE
 150    CONTINUE
C  APPLY STRAIN FOR BASIS VECTORS:  T'=S*T
        DO 170 IATOM=1,NATOM
        DO 170 I=1,3
        TAU (I,IATOM)=0.D0
        TAU0(I,IATOM)=0.D0
        DO 160 J=1,3
        TAU (I,IATOM)=TAU (I,IATOM)+STRAIN(I,J,1)*TAU R(J,IATOM)
        TAU0(I,IATOM)=TAU0(I,IATOM)+STRAIN(I,J,1)*TAU0R(J,IATOM)
 160    CONTINUE
 170    CONTINUE
C  APPLY INVERSE STRAIN FOR BRILLOUIN ZONE: BZ'=BZ*S^(-1)
        DO 190 IVEC=1,3
        DO 190 I=1,3
        BBAS(I,IVEC)=0.D0
        DO 180 J=1,3
        BBAS(I,IVEC)=BBAS(I,IVEC)+BBASR(J,IVEC)*STRAIN(J,I,2)
 180    CONTINUE
 190    CONTINUE
C  SET RECIPROCAL LATTICE VECTORS WITHOUT 2*PI
        CALL CROSS(GBAS(1,1),RBAS(1,2),RBAS(1,3))
        CALL CROSS(GBAS(1,2),RBAS(1,3),RBAS(1,1))
        CALL CROSS(GBAS(1,3),RBAS(1,1),RBAS(1,2))
        W=RBAS(1,1)*GBAS(1,1)
     &   +RBAS(2,1)*GBAS(2,1)
     &   +RBAS(3,1)*GBAS(3,1)
        DO 230 I=1,3
        GBAS(I,1)=GBAS(I,1)/W
        GBAS(I,2)=GBAS(I,2)/W
        GBAS(I,3)=GBAS(I,3)/W
 230    CONTINUE
        OMEGAC=ABS(W)*PAR**3
C  SET BRILLOUIN ZONE TO GBAS IF REQUIRED
        IF(IBZ.EQ.1)THEN
        DO 240 I=1,3
        BBAS(I,1)=GBAS(I,1)
        BBAS(I,2)=GBAS(I,2)
        BBAS(I,3)=GBAS(I,3)
 240    CONTINUE
        ENDIF
1000    FORMAT(A)
1001    FORMAT(/A)
1010    FORMAT(2(1X,A1))
1020    FORMAT(80A1)
        END




        SUBROUTINE RADMSH
*************************************************************
*   Module prepares radial mesh in each  MT-sphere          *
*************************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
        INCLUDE 'PARAM.DAT'
        INTEGER   IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &           ,NRAD(NSORTMAX)
        DIMENSION H(NSORTMAX),R(0:NRADMAX,NSORTMAX),SMT(NSORTMAX)
     &           ,GL(3),WEIGHT(0:NRADMAX,NSORTMAX),Z(NSORTMAX),AS(NPAT)
     &           ,RL(0:NRADMAX,0:LMAXV,NSORTMAX),ZCOR(NSORTMAX)
     &           ,DR(0:NRADMAX,NSORTMAX),SASA(NSORTMAX)
        COMMON /PARAM/   NSORT,IS,ILST,ILSB,ILSV,NATOM
        COMMON /LATTICE/ A(3),B(3),C(3)              
        COMMON /RADMESH/ NRAD,H,R,DR,WEIGHT,RL
        COMMON /DENS/    Z,ZCOR
        COMMON /POTCOM/  SWZ,SMT
        COMMON /ASASPH/  SASA
        COMMON /RELATIV/ LR(NSORTMAX)
        COMMON /LATPAR/  PAR
        DATA PI/3.141592653589793D0/,DELTANR/0.03D0/,DELTAR/0.03D0/
C  DEFINE WIGNER-ZEITS SPHERE
        CALL CROSS(GL,B,C)
        OMEGA=ABS(A(1)*GL(1)+A(2)*GL(2)+A(3)*GL(3))   !!! volume of unit-cell
        DO 1 IATOM=1,NATOM
    1   AS(IATOM)=SASA(IS(IATOM))
        CALL SCASW(NATOM,OMEGA,AS,S0,AS)              !!! ASA sphere radii
        SWZ=PAR*S0                                    !!! WZ sphere radius
        DO 5 IATOM=1,NATOM
    5   SASA(IS(IATOM))=PAR*AS(IATOM)
        DO 30 ISORT=1,NSORT
C  DEFINE STEP
        IF(LR(ISORT).EQ.0)H(ISORT)=DELTANR
        IF(LR(ISORT).EQ.1)H(ISORT)=DELTA R
C  DEFINE MESH PARAMETERS
        BETTA=1.D0/(2.D0*Z(ISORT)+1.D0)
        NRAD(ISORT)=2*LOG(SMT(ISORT)/BETTA+1.D0)/H(ISORT)
        NRAD(ISORT)=MIN(NRAD(ISORT),NRADMAX)
        NRAD(ISORT)=MAX(NRAD(ISORT),100)
        NRAD(ISORT)=((NRAD(ISORT)-1)/2)*2  !!! must be odd number
        BETTA=SMT(ISORT)/(EXP(H(ISORT)*NRAD(ISORT))-1.D0)
C  DEFINE RADIAL MESH ARRAYS
        DO 20 IRAD=0,NRAD(ISORT)
        R(IRAD,ISORT)=BETTA*(EXP(H(ISORT)*IRAD)-1.D0)
        DR(IRAD,ISORT)=BETTA*EXP(H(ISORT)*IRAD)
        WEIGHT(IRAD,ISORT)=4.D0*PI*R(IRAD,ISORT)**2*DR(IRAD,ISORT)
        RL(IRAD,0,ISORT)=1.D0
        DO 10 L=1,LMAXV
        RL(IRAD,L,ISORT)=R(IRAD,ISORT)**L
  10    CONTINUE
  20    CONTINUE
  30    CONTINUE
        END

        SUBROUTINE SCASW(NATOM,OMEGA,R,S0,S)
*********************************************************
*  Scale ASA sphere radii according to the numbers R(I) *
*********************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
        DIMENSION R(NATOM),S(NATOM)
        DATA PI/3.141592653589793D0/
        S0=(OMEGA/NATOM/(4.*PI)*3.)**0.33333333333333D0
        OMEGAR=0.0
        DO 10 I=1,NATOM
  10    OMEGAR=OMEGAR+4.D0/3.D0*PI*R(I)**3
        A=(OMEGA/OMEGAR)**0.333333333333333D0
        DO 20 I=1,NATOM
  20    S(I)=A*R(I)
        END


        SUBROUTINE CROSS(A,B,C)
**********************************************************
*    Cross product (AX,AY,AZ)=(BX,BY,BZ)*(CX,CY,CZ)      *
**********************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
        DIMENSION A(3),B(3),C(3)
        A(1)=B(2)*C(3)-B(3)*C(2)
        A(2)=B(3)*C(1)-B(1)*C(3)
        A(3)=B(1)*C(2)-B(2)*C(1)
        RETURN
        END
