	SUBROUTINE ALPCON
******************************************************************* 
*  Calculates screened constants alpha using logarithimic deriv.  *
*  S.Savrasov, MPI,Stuttgart. Created 04.03.93, Revised 01.05.93. *
*******************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX)
     &   ,NKAP(NPANMAX),ILSV(NSORTMAX)
	COMPLEX*16 EK(NKAPMAX,NPANMAX),EKAP(NKAPMAX,NPANMAX)
     &   ,ALPHA(0:LMAXT,0:NSORTMAX,NKAPMAX,NPANMAX),HAN(3,-1:LMAXB) 
     &   ,ALPDOT(0:LMAXT,0:NSORTMAX,NKAPMAX,NPANMAX),BES(3,0:LMAXB+1)
     &   ,DLOG(0:LMAXT,0:NSORTMAX,NKAPMAX,NPANMAX),EWZ,BN,BD,HN,HD
     &   ,DDOT(0:LMAXB),BESDOT(3,0:LMAXB),HANDOT(3,0:LMAXB)
	DIMENSION RBAS(3,3),TAU(3,NPAT),RLOC(NSORTMAX)
     &    ,SASA(NSORTMAX),SMT(NSORTMAX),DDAT(0:3,0:3)
     &    ,DDER(0:3,0:3)
	CHARACTER TXTEL(NSORTMAX)*10
	LOGICAL FIRST
	COMMON /CONTROL/LIFT,LMTO                           !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM       !!! from init
	COMMON /LATTICE/RBAS                                !!! from init
	COMMON /BASIS/  TAU                                 !!! from init
	COMMON /LATPAR/ PAR                                 !!! from init
	COMMON /POTCOM/ SWZ,SMT                             !!! from init
	COMMON /ASASPH/ SASA                                !!! from srfmsh
	COMMON /SCRINP/ RLOC,ALPHA,ALPDOT,DLOG              !!! from init
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                   !!! from init
	COMMON /TXTEL/  TXTEL                               !!! from init
	COMMON /UNIT/   IUN                                 !!! from init
	DATA PI/3.141592653589793D0/,FIRST/.TRUE./
	DATA DDAT/0.75D0,0.00D0,0.00D0,0.00D0   !!! screening Dlog for s-el.
     &           ,1.35D0,1.55D0,0.00D0,0.00D0   !!! screening Dlog for sp-el.
     &           ,2.30D0,2.40D0,2.60D0,0.00D0   !!! screening Dlog for spd-el.
     &           ,3.35D0,3.35D0,3.45D0,3.65D0/  !!! screening Dlog for spdf-el.
	DATA DDER/0.10D0,0.00D0,0.00D0,0.00D0   !!! screening Ddot for s-el.
     &           ,0.10D0,0.10D0,0.00D0,0.00D0   !!! screening Ddot for sp-el.
     &           ,0.10D0,0.10D0,0.10D0,0.00D0   !!! screening Ddot for spd-el.
     &           ,0.10D0,0.10D0,0.10D0,0.10D0/  !!! screening Ddot for spdf-el.
	DATA ELIM/-1.3D0/                       !!! energy limit for screening
C ****  DO GLOBALLY OVER PANELS, ENERGIES AND ATOMS ****
	DO 1300 IPAN=1,NPAN                       !!! over panels
	DO 1200 IKAP=1,NKAP(IPAN)                 !!! over energies
	DO 1100 ISORT=1,NSORT                     !!! over atoms
	ST=SASA(ISORT)/PAR
	SM=SMT (ISORT)/PAR
	EWZ=EK(IKAP,IPAN)*ST**2
	IF(DREAL(EKAP(IKAP,IPAN)).GT.ELIM.AND.LMTO.GT.1)THEN
C  USE UNIVERSAL FIT FOUND BY POSTNIKOV
	ISC=ILSB(ISORT)
	IF(ISC.GT.3)STOP'<ALPCON>:: SCREENING PARAMETERS ARE
     &  NOT AVAILABLE FOR LMAXB>3'
	DO L=0,ILSB(ISORT)
	DLOG(L,ISORT,IKAP,IPAN)=DDAT(L,ISC)-EWZ*DDER(L,ISC)
	DDOT(L)=-DDER(L,ISC)*ST**2
	ENDDO
C  CALCULATE BESSEL AND HANKEL FUNCTIONS AT SCREENING RADIUS (ATOMIC SPHERE)
	CALL BESSEL(ST,EK(IKAP,IPAN),SM,BES(1,0),ILSB(ISORT)+1)
	CALL HANKEL(ST,EK(IKAP,IPAN),SM,HAN(1,0),ILSB(ISORT))
	IF(DREAL(EK(IKAP,IPAN)).LT.0.D0)THEN
	HAN(1,-1)=-(0.D0,1.D0)/SQRT(EK(IKAP,IPAN))/SM*HAN(1,0)
	HAN(2,-1)=-(0.D0,1.D0)/SQRT(EK(IKAP,IPAN))/SM*HAN(2,0)
	ELSEIF(ABS(EK(IKAP,IPAN)).LE.1.D-10)THEN
	HAN(1,-1)=(1.D0,0.D0)
	HAN(2,-1)=(0.D0,0.D0)
	ELSEIF(DREAL(EK(IKAP,IPAN)).GT.0.D0)THEN
	HAN(1,-1)=BES(1,0)
	HAN(2,-1)=BES(2,0)
	ENDIF
C  SET ENERGY DERIVATIVES OF THE BESSEL AND HANKEL FUNCTIONS
	DO L=0,ILSB(ISORT)
	BESDOT(1,L)=-0.5D0*ST*SM/(2.D0*L+3)*BES(1,L+1)
	BESDOT(2,L)=-0.5D0*SM/(2.D0*L+3)*(BES(1,L+1)+ST*BES(2,L+1))
	HANDOT(1,L)=0.5D0*ST*SM/(2.D0*L-1.D0)*HAN(1,L-1)
	HANDOT(2,L)=0.5D0*SM/(2.D0*L-1.D0)*(HAN(1,L-1)+ST*HAN(2,L-1))
	ENDDO
C  FIND SCREENING CONSTANTS ALPHA AND THEIR ENERGY DERIVATIVES
	DO L=0,ILSB(ISORT)
	GAM=1.D0/(SMT(ISORT)/PAR*DBLE(2*L+1))
	BN=DLOG(L,ISORT,IKAP,IPAN)*BES(1,L)-SASA(ISORT)/PAR*BES(2,L)
	HN=DLOG(L,ISORT,IKAP,IPAN)*HAN(1,L)-SASA(ISORT)/PAR*HAN(2,L)
	ALPHA(L,ISORT,IKAP,IPAN)=BN/HN*GAM
	BD=DDOT(L)*BES(1,L)+DLOG(L,ISORT,IKAP,IPAN)*BESDOT(1,L)-
     &  SASA(ISORT)/PAR*BESDOT(2,L)
	HD=DDOT(L)*HAN(1,L)+DLOG(L,ISORT,IKAP,IPAN)*HANDOT(1,L)-
     &  SASA(ISORT)/PAR*HANDOT(2,L)
   	ALPDOT(L,ISORT,IKAP,IPAN)=(BD*HN-BN*HD)/(HN*HN)*GAM
C	ALPDOT(L,ISORT,IKAP,IPAN)=(0.D0,0.D0)
	ENDDO
	DO L=ILSB(ISORT)+1,ILST(ISORT)
	ALPHA(L,ISORT,IKAP,IPAN)=(0.D0,0.D0)
	ALPDOT(L,ISORT,IKAP,IPAN)=(0.D0,0.D0)
	DLOG(L,ISORT,IKAP,IPAN)=(0.D0,0.D0)
	ENDDO
C  NO SCREENING FOR NEGATIVE ENERGIES OR FOR BARE LMTO
	ELSE
	DO L=0,ILST(ISORT)
	ALPHA(L,ISORT,IKAP,IPAN)=(0.D0,0.D0)
	ALPDOT(L,ISORT,IKAP,IPAN)=(0.D0,0.D0)
	DLOG(L,ISORT,IKAP,IPAN)=(0.D0,0.D0)
	ENDDO
	ENDIF
1100    CONTINUE                                 !!! over atoms
1200    CONTINUE                                 !!! over energies
1300    CONTINUE                                 !!! over panels
	END
