	SUBROUTINE SDERIV2(FUN,DFUNDR,NSHE,RINT,S,SR)
****************************************************************
*   Calculates radial derivative. REAL*8 version.              *
****************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	DIMENSION FUN(0:NSHEMAX),DFUNDR(0:NSHEMAX)
	DIMENSION RINT(0:NSHEMAX)
C PARABOLIC INTERPOLATION FORMULA
        F3FUN(X,F1,F2,F3,X1,X2,X3)=
     &  (X-X2)*(X-X3)/(X1-X2)/(X1-X3)*F1+
     &  (X-X1)*(X-X3)/(X2-X1)/(X2-X3)*F2+
     &  (X-X1)*(X-X2)/(X3-X1)/(X3-X2)*F3
C CORRESPONDING FIRST-ORDER DERIVATIVE
        F3DER(X,F1,F2,F3,X1,X2,X3)=
     &  ((X-X2)+(X-X3))/(X1-X2)/(X1-X3)*F1+
     &  ((X-X1)+(X-X3))/(X2-X1)/(X2-X3)*F2+
     &  ((X-X1)+(X-X2))/(X3-X1)/(X3-X2)*F3
	DATA PI/3.141592653589793D0/
	IF(NSHE.LT.7)STOP'<SDERIV2> # of int.points is too small'
C DEFINE MESH PARAMETERS
	AT=0.5D0*(SR+S)
	BT=0.5D0*(SR-S)
	STEPRAD=1.D0
	DO IRAD=1,NSHE+1                      !!! over rad.points
	IF(IRAD.EQ.1)THEN
	DFUNDR(IRAD)=F3DER(RINT(IRAD),
     &  FUN (IRAD+0),FUN (IRAD+1),FUN (IRAD+2),
     &  RINT(IRAD+0),RINT(IRAD+1),RINT(IRAD+2))
	ELSEIF(IRAD.GT.1.AND.IRAD.LT.NSHE+1)THEN
	DFUNDR(IRAD)=F3DER(RINT(IRAD),
     &  FUN (IRAD-1),FUN (IRAD+0),FUN (IRAD+1),
     &  RINT(IRAD-1),RINT(IRAD+0),RINT(IRAD+1))
	ELSEIF(IRAD.EQ.NSHE+1)THEN
	DFUNDR(IRAD)=F3DER(RINT(IRAD),
     &  FUN (IRAD-2),FUN (IRAD-1),FUN (IRAD-0),
     &  RINT(IRAD-2),RINT(IRAD-1),RINT(IRAD-0))
	ENDIF
        ENDDO                                 !!! over rad.points
	DFUNDR(0)=DFUNDR(1)
	END


	SUBROUTINE CDERIV2(FUN,DFUNDR,NSHE,RINT,S,SR)
****************************************************************
*   Calculates radial derivative. Complex*16 version.          *
****************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	COMPLEX*16 FUN(0:NSHEMAX),DFUNDR(0:NSHEMAX)
     &    ,F3FUN,F3DER,F1,F2,F3
	DIMENSION RINT(0:NSHEMAX)
C PARABOLIC INTERPOLATION FORMULA
        F3FUN(X,F1,F2,F3,X1,X2,X3)=
     &  (X-X2)*(X-X3)/(X1-X2)/(X1-X3)*F1+
     &  (X-X1)*(X-X3)/(X2-X1)/(X2-X3)*F2+
     &  (X-X1)*(X-X2)/(X3-X1)/(X3-X2)*F3
C CORRESPONDING FIRST-ORDER DERIVATIVE
        F3DER(X,F1,F2,F3,X1,X2,X3)=
     &  ((X-X2)+(X-X3))/(X1-X2)/(X1-X3)*F1+
     &  ((X-X1)+(X-X3))/(X2-X1)/(X2-X3)*F2+
     &  ((X-X1)+(X-X2))/(X3-X1)/(X3-X2)*F3
	DATA PI/3.141592653589793D0/
	IF(NSHE.LT.7)STOP'<CDERIV2> # of int.points is too small'
C DEFINE MESH PARAMETERS
	AT=0.5D0*(SR+S)
	BT=0.5D0*(SR-S)
	STEPRAD=1.D0
	DO IRAD=1,NSHE+1                      !!! over rad.points
	IF(IRAD.EQ.1)THEN
	DFUNDR(IRAD)=F3DER(RINT(IRAD),
     &  FUN (IRAD+0),FUN (IRAD+1),FUN (IRAD+2),
     &  RINT(IRAD+0),RINT(IRAD+1),RINT(IRAD+2))
	ELSEIF(IRAD.GT.1.AND.IRAD.LT.NSHE+1)THEN
	DFUNDR(IRAD)=F3DER(RINT(IRAD),
     &  FUN (IRAD-1),FUN (IRAD+0),FUN (IRAD+1),
     &  RINT(IRAD-1),RINT(IRAD+0),RINT(IRAD+1))
	ELSEIF(IRAD.EQ.NSHE+1)THEN
	DFUNDR(IRAD)=F3DER(RINT(IRAD),
     &  FUN (IRAD-2),FUN (IRAD-1),FUN (IRAD-0),
     &  RINT(IRAD-2),RINT(IRAD-1),RINT(IRAD-0))
	ENDIF
        ENDDO                                 !!! over rad.points
	DFUNDR(0)=DFUNDR(1)
	END

