	SUBROUTINE ENVMSH
******************************************************************* 
*  Finds cluster sites for every atom                             *
*  Essential input:                                               *
*    Rloc(isort) - cluster sphere radius for every SORT.          *
*  Outputs:                                                       *
*    Nenv(iatom) - # of nearest neighbors                         *
*    Tenv(1:3)   - vectors pointing to neighbors                  *
*    ISenv       - shows particular neighbor atoms                *
*    IPenv       - shows to which position atom will move         *
*                  after applying a group operation               *
*    IRenv       - shows irreducible connections                  *
*******************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX)
     &    ,ILSV(NSORTMAX),NENV(NPAT),ISENV(0:NENVMAX,NPAT)
     &    ,ISVEC(0:NVCMAX),NSHL(NPAT),NATS(0:NENVMAX,NPAT)
     &    ,ISSHL(NENVMAX,0:NENVMAX,NPAT),IP(NPAT,NOPRMAX)
     &    ,IPENV(0:NENVMAX,NPAT,NOPRMAX),IKOV(NOPRMAX)
     &    ,IRENV(0:NENVMAX,NPAT)
	DIMENSION RBAS(3,3),TAU(3,NPAT),TENV(3,0:NENVMAX,NPAT)
     &    ,RLOC(NSORTMAX),SMT(NSORTMAX),TAUT(3,NPAT)
     &    ,AD(3,3),RD(3,3),G1(3),TVEC(3,0:NVCMAX)
     &    ,RSHL(0:NENVMAX,NPAT),RDC(3,NPAT,NOPRMAX)
     &    ,SHIFT(3,NOPRMAX),ORTH(2:3)
	COMPLEX*16 U(NWIGMAX,48)
	CHARACTER TXTEL(NSORTMAX)*10,TXTSP(2)*2
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM       !!! from init
	COMMON /POTCOM/ SWZ,SMT                             !!! from init
	COMMON /BASIS/  TAU                                 !!! from init
	COMMON /SCRINP/ RLOC                                !!! from init
	COMMON /LATPAR/ PAR,ORTH,OMEGAC                     !!! from init
	COMMON /LATTICE/RBAS                                !!! from init
	COMMON /ENVSITE/NENV,TENV,ISENV,IPENV,IRENV         !!! from envmesh
        COMMON /ENVSHEL/NSHL,NATS,ISSHL                     !!! from envmesh
        COMMON /INVERS/ INV,IKOV                            !!! from groups
        COMMON /GROUPOUT/NGROUP,U,IP,RDC,SHIFT              !!! from groups
	COMMON /UNIT/   IUN                                 !!! from init
        COMMON /TXTEL/  TXTEL,TXTSP                         !!! from init
	COMMON /WORD/   NVAL                                !!! from nmtdata
	DATA PI/3.141592653589793D0/
C ***** FIND CLUSTER SITES FOR ATOMS IN CELL *******
	DO IATOM=1,NATOM                   !!! over atoms
	ISORT=IS(IATOM)
	DO JATOM=1,NATOM
	TAUT(1,JATOM)=TAU(1,JATOM)-TAU(1,IATOM)
	TAUT(2,JATOM)=TAU(2,JATOM)-TAU(2,IATOM)
	TAUT(3,JATOM)=TAU(3,JATOM)-TAU(3,IATOM)
	ENDDO 
C  GENERATE LATTICE SITES SURROUNDING ATOM "IATOM"
	CALL SITEGEN(RLOC(ISORT),RBAS(1,1),RBAS(1,2),RBAS(1,3),
     &  TAUT,NATOM,NVEC,TVEC(1,0),ISVEC(0))
	NVEC=NVEC-1
	TX=TVEC(1,0)
	TY=TVEC(2,0)
	TZ=TVEC(3,0)
	IM=ISVEC(0)
	DO IVEC=0,NVEC
	TT=SQRT(TVEC(1,IVEC)**2+TVEC(2,IVEC)**2+TVEC(3,IVEC)**2)
	IF(ABS(TT).LE.1.D-10)THEN
	TVEC(1,0)=0.D0
	TVEC(2,0)=0.D0
	TVEC(3,0)=0.D0
	ISVEC(0)=IATOM
	TVEC(1,IVEC)=TX
	TVEC(2,IVEC)=TY
	TVEC(3,IVEC)=TZ
	ISVEC(IVEC)=IM
	ENDIF
	ENDDO
C  FIND ENVIRONMENT VECTORS
	IENV=-1
	DO IVEC=0,NVEC
	ABST=SQRT(TVEC(1,IVEC)**2+TVEC(2,IVEC)**2+TVEC(3,IVEC)**2)
	IF(ABST.LE.RLOC(ISORT))THEN
	IENV=IENV+1
	IF(IENV.GT.NENVMAX)STOP'<ENVMSH>: NENVMAX MUST BE 
     &  INCREASED IN PARAM.DAT'
	TENV(1,IENV,IATOM)=TVEC(1,IVEC)
	TENV(2,IENV,IATOM)=TVEC(2,IVEC)
	TENV(3,IENV,IATOM)=TVEC(3,IVEC)
	ISENV(IENV,IATOM)=ISVEC(IVEC)
	ENDIF
	ENDDO
	NENV(IATOM)=IENV
        ENDDO                                        !!! over atoms
C  ORDER VECTORS BY INCREASING LENGTH
	DO IATOM=1,NATOM                             !!! over atoms
        DO IENV=0,NENV(IATOM)
        ABSI=SQRT(TENV(1,IENV,IATOM)**2+TENV(2,IENV,IATOM)**2+
     &  TENV(3,IENV,IATOM)**2)
        DO JENV=IENV+1,NENV(IATOM)
        ABSJ=SQRT(TENV(1,JENV,IATOM)**2+TENV(2,JENV,IATOM)**2+
     &  TENV(3,JENV,IATOM)**2)
        IF(ABSJ.LT.ABSI)THEN
        XJ=TENV(1,JENV,IATOM)
        YJ=TENV(2,JENV,IATOM)
        ZJ=TENV(3,JENV,IATOM)
	ISENVJ=ISENV(JENV,IATOM)
        TENV(1,JENV,IATOM)=TENV(1,IENV,IATOM)
        TENV(2,JENV,IATOM)=TENV(2,IENV,IATOM)
        TENV(3,JENV,IATOM)=TENV(3,IENV,IATOM)
	ISENV(JENV,IATOM)=ISENV(IENV,IATOM)
        TENV(1,IENV,IATOM)=XJ
        TENV(2,IENV,IATOM)=YJ
        TENV(3,IENV,IATOM)=ZJ
	ISENV(IENV,IATOM)=ISENVJ
        ABSI=ABSJ
        ENDIF
	ENDDO
	ENDDO
	ENDDO
C  FIND SHELLS
	DO IATOM=1,NATOM                         !!! over atoms
	ISORT=IS(IATOM)
	NSHL(IATOM)=0
	RSHL(0,IATOM)=0.D0
	DO IENV=1,NENV(IATOM)
        ABSI=SQRT(TENV(1,IENV,IATOM)**2+TENV(2,IENV,IATOM)**2+
     &  TENV(3,IENV,IATOM)**2)
	ISHL=NSHL(IATOM)
	IF(ABSI.GT.RSHL(ISHL,IATOM)+1.D-10)THEN
     	NSHL(IATOM)=NSHL(IATOM)+1
	RSHL(NSHL(IATOM),IATOM)=ABSI
	ENDIF
	ENDDO
	DO ISHL=0,NSHL(IATOM)
	NATS(ISHL,IATOM)=0
	DO IENV=0,NENV(IATOM)
        ABSI=SQRT(TENV(1,IENV,IATOM)**2+TENV(2,IENV,IATOM)**2+
     &  TENV(3,IENV,IATOM)**2)
	IF(ABS(RSHL(ISHL,IATOM)-ABSI).LE.1.D-10)THEN
        NATS(ISHL,IATOM)=NATS(ISHL,IATOM)+1
	ISSHL(NATS(ISHL,IATOM),ISHL,IATOM)=IENV
	ENDIF
	ENDDO
	ENDDO
	ENDDO
C  *** FIND SYMMETRY OF THE CLUSTER SITES ****
	DO IATOM=1,NATOM                   !!! over atoms
	DO IENV=0,NENV(IATOM)              !!! over n.neigbors
C  APPLY INVERSIONAL GROUP OPERATION g^{-1}*T=r^{-1}*T-r^{-1}*shift
	DO IR=1,NGROUP
	IG=IKOV(IR)
C  Rotate shift vector if group is non-symmorfical
        SX=SHIFT(1,IR)
        SY=SHIFT(2,IR)
        SZ=SHIFT(3,IR)
        CALL ROTATE(SX,SY,SZ,XS,YS,ZS,U(2,IG),1)
C  Rotate basis vector
	TX=TAU(1,IATOM)
	TY=TAU(2,IATOM)
	TZ=TAU(3,IATOM)
        CALL ROTATE(TX,TY,TZ,XT,YT,ZT,U(2,IG),1)
        TXR=XT-XS
        TYR=YT-YS
        TZR=ZT-ZS
C  Rotate neighbor
	UX=TENV(1,IENV,IATOM)+TAU(1,IATOM)
	UY=TENV(2,IENV,IATOM)+TAU(2,IATOM)
	UZ=TENV(3,IENV,IATOM)+TAU(3,IATOM)
        CALL ROTATE(UX,UY,UZ,XU,YU,ZU,U(2,IG),1)
        UXR=XU-XS
        UYR=YU-YS
        UZR=ZU-ZS
C  NOW, ROTATED NEIGHBOR IS
	EXR=UXR-TXR
	EYR=UYR-TYR
	EZR=UZR-TZR
C  FIND IT IN THE ARRAY TENV:::
	IATOM1=IP(IATOM,IR)
	DO IENV1=0,NENV(IATOM1)
	DIFF=(EXR-TENV(1,IENV1,IATOM1))**2+
     &       (EYR-TENV(2,IENV1,IATOM1))**2+
     &       (EZR-TENV(3,IENV1,IATOM1))**2
	IF(DIFF.LE.1.D-10)EXIT
	ENDDO
	IF(IENV1.EQ.NENV(IATOM1)+1)STOP'<ENVSYM> ERROR IN ROTATION'
	IPENV(IENV,IATOM,IR)=IENV1
C  CHECK FINDING
	JATOM=ISENV(IENV,IATOM)
	JATOMG=IP(JATOM,IR)
	JATOM1=ISENV(IENV1,IATOM1)
	IF(JATOM1.NE.JATOMG)STOP'<ENVSYM> ATOMS MISMATCH'
	ENDDO                              !!! over group
	ENDDO                              !!! over n.neighbors
	ENDDO                              !!! over atoms
C  SET IRREDUCIBLE VECTORS
	DO IATOM=1,NATOM
	DO IENV=0,NENV(IATOM)
	IRENV(IENV,IATOM)=0
	ENDDO
	ENDDO
	DO IATOM=1,NATOM                   !!! over atoms
	DO IENV=0,NENV(IATOM)              !!! over n.neigbors
	IF(IRENV(IENV,IATOM).EQ.0)THEN
	IRENV(IENV,IATOM)=1
	DO IR=1,NGROUP
	IENV1=IPENV(IENV,IATOM,IR)
	IATOM1=IP(IATOM,IR)
	IF(.NOT.(IENV1.EQ.IENV.AND.IATOM1.EQ.IATOM))
     &  IRENV(IENV1,IATOM1)=-1
	ENDDO
	ENDIF
	ENDDO
	ENDDO
C  CHECK OUT GENERATION AND PRINT DATA
C	WRITE(IUN,1000)
C	DO IATOM=1,NATOM
C	ISORT=IS(IATOM)
C       WRITE(IUN,1010)(TAU(I,IATOM),I=1,3),TXTEL(ISORT)
C	WRITE(IUN,1020)NSHL(IATOM),RLOC(ISORT)
C	NENV0=0
C	DO ISHL=1,NSHL(IATOM)
C	WRITE(IUN,1030)ISHL,NATS(ISHL,IATOM)
C	DO IATS=1,NATS(ISHL,IATOM)
C	IENV=ISSHL(IATS,ISHL,IATOM)
C	IATOMI=ISENV(IENV,IATOM)
C	ISORTI=IS(IATOMI)
C	DIST=SQRT(TENV(1,IENV,IATOM)**2+TENV(2,IENV,IATOM)**2+
C    &  TENV(3,IENV,IATOM)**2)
C	WRITE(IUN,1040)(TENV(I,IENV,IATOM),I=1,3),DIST,
C    &  TXTEL(ISORTI),IATOMI
C	NENV0=NENV0+1
C	ENDDO
C	ENDDO
C	IF(NENV0.NE.NENV(IATOM))
C    &  STOP'<ENVMESH>:: WRONG GENERATION OF SHELLS'
C	ENDDO
1000  FORMAT(1X,'Result from ENVMSH for the nearest neighbors    --->')
1010  FORMAT(1X,'Position : (',G12.5,',',G12.5,',',G12.5,') ',A10)
1020  FORMAT(1X,'# of shells found ',I3,' for loc. radius ',G12.5)
1030  FORMAT(1X,'# of atoms in shell ',I3,' is ',I3,'. Neighbors::')
1040  FORMAT(1X,'(',G12.5,',',G12.5,',',G12.5,') ',
     &'d=',G12.5,1X,A10,1X,I3)
C  PRINT IRREDUCIBLE CONNECTIONS ONSITE
	NB=1
	DO ISORT=1,NSORT
        DO I=10,5,-1
        IF(TXTEL(ISORT)(I:I).NE.' ')EXIT
        ENDDO
        NB=MAX(NB,I)
	ENDDO
C	WRITE(IUN,1100)
	ISITE=0
	DO IATOM=1,NATOM
	DO IENV=0,0          
	IF(IRENV(IENV,IATOM).EQ.1)ISITE=ISITE+1
	ENDDO
	ENDDO
	WRITE(IUN,1110)ISITE
	WRITE(IUN,1130)
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	DO IENV=0,0          
	IATOM1=ISENV(IENV,IATOM)
	ISORT1=IS(IATOM1)
	IF(IRENV(IENV,IATOM).EQ.1)WRITE(IUN,1140)
     &  TXTEL(ISORT)(5:NB),IATOM,TXTEL(ISORT1)(5:NB),IATOM1,
     &  TENV(1,IENV,IATOM),TENV(2,IENV,IATOM)/ORTH(2),
     &  TENV(3,IENV,IATOM)/ORTH(3)
	ENDDO
	ENDDO
C  PRINT IRREDUCIBLE CONNECTIONS BETWEEN SITES
	IHOPP=0
	DO IATOM=1,NATOM
	DO IENV=1,NENV(IATOM)
	IF(IRENV(IENV,IATOM).EQ.1)IHOPP=IHOPP+1
	ENDDO
	ENDDO
	WRITE(IUN,1120)IHOPP
	WRITE(IUN,1130)
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	DO IENV=1,NENV(IATOM)
	IATOM1=ISENV(IENV,IATOM)
	ISORT1=IS(IATOM1)
	IF(IRENV(IENV,IATOM).EQ.1)WRITE(IUN,1140)
     &  TXTEL(ISORT)(5:NB),IATOM,TXTEL(ISORT1)(5:NB),IATOM1,
     &  TENV(1,IENV,IATOM),TENV(2,IENV,IATOM)/ORTH(2),
     &  TENV(3,IENV,IATOM)/ORTH(3)
	ENDDO
	ENDDO
1100  FORMAT(1X,'Result from ENVMSH for irreducible connections  --->')
1110  FORMAT(1X,'Intrasite irreducible connections found:',I4)
1120  FORMAT(1X,'Intersite irreducible connections found:',I4)
1130  FORMAT(1X,'From:',10X,'to:',12X,'via vector:')
1140  FORMAT(1X,A,'#',I2,10X,A,'#',I2,10X,'(',G12.5,',',G12.5,
     &',',G12.5,')')
	END
