	FUNCTION TCP(C,EPS)
************************************************************
*  Converts complex number to character string of the type *
*  C=( 0.1234567,-0.7654321)                               *
************************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 C,C0,CNUM0P
	CHARACTER TCP*23,TDP*10,TREAL*10,TIMAG*10,SIGNR*1,SIGNI*1
	C0=CNUM0P(C)
	DRC=DREAL(C0)
	DIC=DIMAG(C0)
	TREAL=TDP(ABS(DRC),EPS)
	TIMAG=TDP(ABS(DIC),EPS)
	IF(DRC.LT.0.D0)SIGNR='-'
	IF(DRC.GE.0.D0)SIGNR=' '
	IF(DIC.LT.0.D0)SIGNI='-'
	IF(DIC.GE.0.D0)SIGNI=' '
	TREAL(1:1)=SIGNR
	TIMAG(1:1)=SIGNI
C ANSWER
	TCP='('//TREAL//','//TIMAG//')'
	END

	FUNCTION TCW(C,EPS)
************************************************************
*  Converts complex number to character string of the type *
*  C=( 0.1234567-i0.7654321)                               *
************************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 C,C0,CNUM0P
	CHARACTER TCW*23,TDP*10,TREAL*10,TIMAG*10,SIGNR*1,SIGNI*1
	C0=CNUM0P(C)
	DRC=DREAL(C0)
	DIC=DIMAG(C0)
	TREAL=TDP(ABS(DRC),EPS)
	TIMAG=TDP(ABS(DIC),EPS)
	IF(DRC.LT.0.D0)SIGNR='-'
	IF(DRC.GE.0.D0)SIGNR=' '
	IF(DIC.LT.0.D0)SIGNI='-'
	IF(DIC.GE.0.D0)SIGNI='+'
	TREAL(1:1)=SIGNR
	TIMAG(1:1)='i'
C ANSWER
	TCW='('//TREAL//SIGNI//TIMAG//')'
	END

	FUNCTION TCPS(C,EPS)
************************************************************
*  Converts complex number to character string of the type *
*  C=( 0.12345,-0.76543)                                   *
************************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 C,C0,CNUM0P
	CHARACTER TCPS*19,TDP*8,TREAL*8,TIMAG*8,SIGNR*1,SIGNI*1
	C0=CNUM0P(C)
	DRC=DREAL(C0)
	DIC=DIMAG(C0)
	TREAL=TDP(ABS(DRC),EPS)
	TIMAG=TDP(ABS(DIC),EPS)
	IF(DRC.LT.0.D0)SIGNR='-'
	IF(DRC.GE.0.D0)SIGNR=' '
	IF(DIC.LT.0.D0)SIGNI='-'
	IF(DIC.GE.0.D0)SIGNI=' '
	TREAL(1:1)=SIGNR
	TIMAG(1:1)=SIGNI
C ANSWER
	TCPS='('//TREAL//','//TIMAG//')'
	END

	FUNCTION TDP(D,EPS)
************************************************************
*  Converts real*8  number to character string of the type *
*  D=+0.1234567 for E-07<D<E+07 and D=1.230E-XX otherwise. *
************************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER TDP*10,RS*10,SIGN*1
	D0=DNUM0P(D,EPS)
	AD=ABS(D0)
C  GET SIGN
	IF(D0.LT.0.D0)SIGN='-'
	IF(D0.GE.0.D0)SIGN=' '
C  GET VALUE FORMATTED
	    IF(AD.EQ.0.D+00)THEN
	RS=' 0.0000000'
	ELSEIF(AD.LT.1.D-07)THEN
	WRITE(RS,FMT='(G10.4)')AD
	ELSEIF(AD.LE.9.9999999D0)THEN
	WRITE(RS,FMT='(F10.7)')AD
	ELSEIF(AD.LE.99.999999D0)THEN
	WRITE(RS,FMT='(F10.6)')AD
	ELSEIF(AD.LE.999.99999D0)THEN
	WRITE(RS,FMT='(F10.5)')AD
	ELSEIF(AD.LE.9999.9999D0)THEN
	WRITE(RS,FMT='(F10.4)')AD
	ELSEIF(AD.LE.99999.999D0)THEN
	WRITE(RS,FMT='(F10.3)')AD
	ELSEIF(AD.LE.999999.99D0)THEN
	WRITE(RS,FMT='(F10.2)')AD
	ELSEIF(AD.LE.9999999.9D0)THEN
	WRITE(RS,FMT='(F10.1)')AD
	ELSEIF(AD.LE.99999999.D0)THEN
	WRITE(RS,FMT='(F10.0)')AD
	ELSE
	WRITE(RS,FMT='(G10.4)')AD
	ENDIF
C  CHECK ERROR
 	IF(RS(1:1).NE.' ')THEN
	WRITE(RS,FMT='(G10.4)')D0
	RETURN
 	ENDIF
C  SET SIGN
	RS(1:1)=SIGN
C  SET ZERO
	IF(RS(2:2).EQ.' '.AND.RS(3:3).EQ.'.')RS(2:2)='0'
C  SET ANSWER
	TDP=RS
	END
	

	FUNCTION TDPS(D,EPS)
************************************************************
*  Converts real*8  number to character string of the type *
*  D=+0.12345   for E-05<D<E+05 and D=+1.2E-XX otherwise.  *
************************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER TDPS*8,RS*8,SIGN*1
	D0=DNUM0P(D,EPS)
	AD=ABS(D0)
C  GET SIGN
	IF(D0.LT.0.D0)SIGN='-'
	IF(D0.GE.0.D0)SIGN=' '
C  GET VALUE FORMATTED
	    IF(AD.EQ.0.D+00)THEN
	RS=' 0.00000'
	ELSEIF(AD.LT.1.D-05)THEN
	WRITE(RS,FMT='(G8.2)')AD
	ELSEIF(AD.LE.9.99999D0)THEN
	WRITE(RS,FMT='(F8.5)')AD
	ELSEIF(AD.LE.99.9999D0)THEN
	WRITE(RS,FMT='(F8.4)')AD
	ELSEIF(AD.LE.999.999D0)THEN
	WRITE(RS,FMT='(F8.3)')AD
	ELSEIF(AD.LE.9999.99D0)THEN
	WRITE(RS,FMT='(F8.2)')AD
	ELSEIF(AD.LE.99999.9D0)THEN
	WRITE(RS,FMT='(F8.1)')AD
	ELSEIF(AD.LE.999999.D0)THEN
	WRITE(RS,FMT='(F8.0)')AD
	ELSE
	WRITE(RS,FMT='(G8.2)')AD
	ENDIF
C  CHECK ERROR
 	IF(RS(1:1).NE.' ')THEN
	WRITE(RS,FMT='(G8.2)')D0
	RETURN
 	ENDIF
C  SET SIGN
	RS(1:1)=SIGN
C  SET ZERO
	IF(RS(2:2).EQ.' '.AND.RS(3:3).EQ.'.')RS(2:2)='0'
C  SET ANSWER
	TDPS=RS
	END




        FUNCTION CNUM0P(C,EPS)
********************************************************
*  Sets Re(C),Im(C) to zero if Re(C),Im(C)<eps         *
********************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
        COMPLEX*16 C,CNUM0P
        DRC=DREAL(C)
        DMC=DIMAG(C)
        IF(ABS(DRC).LE.EPS)DRC=0.D0
        IF(ABS(DMC).LE.EPS)DMC=0.D0
        CNUM0P=DCMPLX(DRC,DMC)
        RETURN
        END



        FUNCTION DNUM0P(D,EPS)
********************************************************
*  Sets D to zero if D<eps                             *
********************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
        IF(ABS(D).LE.EPS)D=0.D0
        DNUM0P=D
        RETURN
        END





	SUBROUTINE CONVLOW(TEXT,LENGHT)
*****************************************************
*  Converts upper case letters to lower case.       *
*****************************************************
	CHARACTER TEXT*(*),LET(26,2)*1
	LET(1 ,1)='A'
	LET(2 ,1)='B'
	LET(3 ,1)='C'
	LET(4 ,1)='D'
	LET(5 ,1)='E'
	LET(6 ,1)='F'
	LET(7 ,1)='G'
	LET(8 ,1)='H'
	LET(9 ,1)='I'
	LET(10,1)='K'
	LET(11,1)='J'
	LET(12,1)='L'
	LET(13,1)='M'
	LET(14,1)='N'
	LET(15,1)='O'
	LET(16,1)='P'
	LET(17,1)='Q'
	LET(18,1)='R'
	LET(19,1)='S'
	LET(20,1)='T'
	LET(21,1)='U'
	LET(22,1)='V'
	LET(23,1)='W'
	LET(24,1)='X'
	LET(25,1)='Y'
	LET(26,1)='Z'
	LET(1 ,2)='a'
	LET(2 ,2)='b'
	LET(3 ,2)='c'
	LET(4 ,2)='d'
	LET(5 ,2)='e'
	LET(6 ,2)='f'
	LET(7 ,2)='g'
	LET(8 ,2)='h'
	LET(9 ,2)='i'
	LET(10,2)='k'
	LET(11,2)='j'
	LET(12,2)='l'
	LET(13,2)='m'
	LET(14,2)='n'
	LET(15,2)='o'
	LET(16,2)='p'
	LET(17,2)='q'
	LET(18,2)='r'
	LET(19,2)='s'
	LET(20,2)='t'
	LET(21,2)='u'
	LET(22,2)='v'
	LET(23,2)='w'
	LET(24,2)='x'
	LET(25,2)='y'
	LET(26,2)='z'
	DO I=1,LENGHT
	DO J=1,26
	IF(TEXT(I:I).EQ.LET(J,1))TEXT(I:I)=LET(J,2)
    	ENDDO
	ENDDO
	END


        SUBROUTINE RMBLANK(TEXT,LENGHT)
*****************************************************
*  Removes blanck records in the file TEXT.         *
*****************************************************
        CHARACTER TEXT*(*),LBLANCK*1
        LBLANCK=' '
C  REMOVE BLANKS
        NEWL=LENGHT
        DO 40 I=1,LENGHT
        NBLANCK=0
        DO 10 J=I,NEWL
        IF(TEXT(J:J).EQ.LBLANCK)THEN
        NBLANCK=NBLANCK+1
        ELSE
        GOTO20
        ENDIF
  10    CONTINUE
  20    DO 30 J=I+NBLANCK,NEWL
        TEXT(J-NBLANCK:J-NBLANCK)=TEXT(J:J)
  30    CONTINUE
        NEWL=NEWL-NBLANCK
  40    CONTINUE
        DO 50 I=NEWL+1,LENGHT
        TEXT(I:I)=LBLANCK
  50    CONTINUE
        END






