	SUBROUTINE GETHTB(IPNT,IPAN)
*********************************************************
* TB-hopping integrals are calculated                   *
* by integrating over Brillouin zone.                   *
*********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX),NENV(NPAT)
     &    ,NBNDF(NPANMAX),NBNDE(NPANMAX),NBNDT(NPANMAX)
     &    ,ISENV(0:NENVMAX,NPAT),IRENV(0:NENVMAX,NPAT)
     &    ,IPENV(0:NENVMAX,NPAT,NOPRMAX),NPNT(NPANMAX)
     &    ,INBAS(LIMLMB,NPAT),IS(NPAT),NKAP(NPANMAX)
     &    ,IND(LIMLMB,NPAT,NKAPMAX,NSPINMAX,NPANMAX)
     &    ,NDIV(3),NDIC(3),IKOV(NOPRMAX),IP(NPAT,NOPRMAX)
	COMPLEX*16 EK(NKAPMAX,NPANMAX),EKAP(NKAPMAX,NPANMAX) 
     &    ,THOP(LIMLMB,LIMLMB,NPAT,0:NENVMAX,NSPINMAX)
     &    ,SHOP(LIMLMB,LIMLMB,NPAT,0:NENVMAX,NSPINMAX)
     &    ,TMAT(LIMLMB,LIMLMB,NPAT,0:NENVMAX,NSPINMAX),PHSK
     &    ,SMAT(LIMLMB,LIMLMB,NPAT,0:NENVMAX,NSPINMAX)
     &    ,OMAT(NDIMMAX*NSPINMAX,NDIMMAX*NSPINMAX)
     &    ,HMAT(NDIMMAX*NSPINMAX,NDIMMAX*NSPINMAX)
     &    ,U(NWIGMAX,48),SOPHS(2,NOPRMAX)
	DIMENSION PNT(3,KMAX,NPANMAX),TAU(3,NPAT)
     &    ,WGT(KMAX,NPANMAX),TENV(3,0:NENVMAX,NPAT)
     &    ,SHIFT(3,NOPRMAX),XVAL(NDIMMAX*NSPINMAX)
     &    ,SH(3,NPANMAX),RDC(3,NPAT,NOPRMAX)
	LOGICAL LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX)
     &    ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
     &    ,LTBAS(0:LMAXB,NPAT),LSBAS(0:LMAXB,NSORTMAX)
C Controls:
        COMMON /CONTROL/LIFT,LMTO,NCOU,NOVR,NPFR              !!! from readini
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM         !!! from readini
	COMMON /SPIN/   NSPIN                                 !!! from readini
        COMMON /ORBS/   NORBS                                 !!! from readini
        COMMON /INP1/   ICHUB,ICHOP,ICOPT                     !!! from readini
C Inputs:
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                     !!! from readini
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS                 !!! from readini
	COMMON /NBANDS/ NBNDF,NBNDE,NBNDT                     !!! from readini
	COMMON /INDX/   IND                                   !!! from lmtpar
        COMMON /BASIS/  TAU                                   !!! from readstr
C TB-data:
        COMMON /TBBPAR/ LTBAS,LSBAS,INBAS,NTBAS               !!! from readhop
        COMMON /ENVSITE/NENV,TENV,ISENV,IPENV,IRENV           !!! from envmesh
        COMMON /HOPCOM/ TMAT,SMAT                             !!! from gethtb
C K-mesh:
        COMMON /INTTR/  NDIV,NDIC,SH                          !!! from readini
	COMMON /MESH/   NPNT,PNT,WGT                          !!! from tetra
C Tmp.storage:
        COMMON /STORE1/ THOP,SHOP                             !!! from gethtb
	COMMON /STORE2/ HMAT,OMAT                             !!! from lmtmat
C Group:
        COMMON /INVERS/ INV,IKOV                              !!! from groups
        COMMON /GROUPOUT/NGROUP,U,IP,RDC,SHIFT,SOPHS          !!! from groups
C Outputs:
        COMMON /UNIT/    IUN                                 !!! from readini
        DATA PI/3.141592653589793D0/,ICHECK/1/
	IF(ICHOP.EQ.0)RETURN
	IF(IPAN.GT.1)RETURN
	NDIM=NBNDT(IPAN)*NSPIN
        IF(NORBS.EQ.2)STOP'<GETHOP> SPIN-ORBIT VERSION NOT READY'
c  DO OVER SPINS IF THERE IS NO SPIN-ORBIT COUPLING
        DO 1000 ISPIN=1,NSPIN
        MSHF=NBNDT(IPAN)*(ISPIN-1)
C  SET UP REAL-SPACE HOPPING INTEGRALS
        DO IATOM1=1,NATOM                   !!! over iatom1
        ISORT1=IS(IATOM1)
        DO IENV=0,NENV(IATOM1)              !!! over ienv
        IATOM=ISENV(IENV,IATOM1)
        ISORT=IS(IATOM)
        RX=TENV(1,IENV,IATOM1)+(TAU(1,IATOM1)-TAU(1,IATOM))
        RY=TENV(2,IENV,IATOM1)+(TAU(2,IATOM1)-TAU(2,IATOM))
        RZ=TENV(3,IENV,IATOM1)+(TAU(3,IATOM1)-TAU(3,IATOM))
        XK=PNT(1,IPNT,IPAN)+SH(1,IPAN)
        YK=PNT(2,IPNT,IPAN)+SH(2,IPAN)
        ZK=PNT(3,IPNT,IPAN)+SH(3,IPAN)
        SCP=XK*RX+YK*RY+ZK*RZ
        PHSK=EXP((0.D0,-1.D0)*SCP*2.D0*PI)
        DO L1=0,ILSB(ISORT1)                !!! over l1
        DO M1=-L1,L1                        !!! over m1
        IF(.NOT.LTBAS(L1,IATOM1))EXIT
        IF(.NOT.LTPAN(L1,IATOM1,1,IPAN))EXIT
        L1M1=L1*(L1+1)+M1+1
	IDIM1=IND(L1M1,IATOM1,1,1,IPAN)
        DO L=0,ILSB(ISORT)                  !!! over l
        DO M=-L,L                           !!! over m
        IF(.NOT.LTBAS(L,IATOM))EXIT
        IF(.NOT.LTPAN(L,IATOM,1,IPAN))EXIT
        LM=L*(L+1)+M+1
	IDIM=IND(LM,IATOM,1,1,IPAN)
C DO NOT RENORMALIZE! IT CAN LEAD TO LONGER RANGE
	ANORM=1.D0/SQRT(DREAL(OMAT(IDIM1+MSHF,IDIM1+MSHF)))
     &            /SQRT(DREAL(OMAT(IDIM +MSHF,IDIM +MSHF)))
	ANORM=1.D0
        IND1=IDIM1+MDIM*(IDIM-1)
        IND2=IND1+MDIM*MDIM
	IF(IPNT.EQ.1)
     &  TMAT(L1M1,LM,IATOM1,IENV,ISPIN)=(0.D0,0.D0)
	IF(IPNT.EQ.1)
     &  SMAT(L1M1,LM,IATOM1,IENV,ISPIN)=(0.D0,0.D0)
        TMAT(L1M1,LM,IATOM1,IENV,ISPIN)=
     &  TMAT(L1M1,LM,IATOM1,IENV,ISPIN)+WGT(IPNT,IPAN)/2.D0*
     &  HMAT(IDIM1+MSHF,IDIM+MSHF)*PHSK*ANORM
        SMAT(L1M1,LM,IATOM1,IENV,ISPIN)=
     &  SMAT(L1M1,LM,IATOM1,IENV,ISPIN)+WGT(IPNT,IPAN)/2.D0*
     &  OMAT(IDIM1+MSHF,IDIM+MSHF)*PHSK*ANORM
        ENDDO                               !!! over m
        ENDDO                               !!! over l
        ENDDO                               !!! over m1
        ENDDO                               !!! over l1
        ENDDO                               !!! over ienv
        ENDDO                               !!! over iatom1
1000	CONTINUE                            !!! over spins
        IF(IPNT.NE.NPNT(IPAN))RETURN
C  MAKE SYMMETRIZATION
        DO ISPIN=1,NSPIN                    !!! over spins
        DO IATOM1=1,NATOM                   !!! over iatom1
        ISORT1=IS(IATOM1)
        DO IENV=0,NENV(IATOM1)              !!! over ienv
        IATOM=ISENV(IENV,IATOM1)
        ISORT=IS(IATOM)
        DO L1=0,ILSB(ISORT1)                !!! over l1
        IF(LTBAS(L1,IATOM1))THEN
        DO L=0,ILSB(ISORT)                  !!! over l
        IF(LTBAS(L,IATOM))THEN
        DO M1=-L1,L1
        L1M1=L1*(L1+1)+M1+1
        DO M=-L,L
        LM=L*(L+1)+M+1
        THOP(L1M1,LM,IATOM1,IENV,ISPIN)=(0.D0,0.D0)
        SHOP(L1M1,LM,IATOM1,IENV,ISPIN)=(0.D0,0.D0)
        ENDDO
        ENDDO
        DO IR=1,NGROUP                      !!! over point group
        IG=IKOV(IR)
        IATOM1G=IP(IATOM1,IR)
        IENVG=IPENV(IENV,IATOM1,IR)
        IATOMG=ISENV(IENVG,IATOM1G)
        DO M1=-L1,L1
        L1M1=L1*(L1+1)+M1+1
        DO M=-L,L
        LM=L*(L+1)+M+1
        DO M2=-L1,L1
        L1M2=L1*(L1+1)+M2+1
        IWIG12=L1*(2*L1-1)*(2*L1+1)/3+(2*L1+1)*(L1+M2)+L1+M1+1
        DO M3=-L,L
        LM3=L*(L+1)+M3+1
        IWIG03=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M3)+L+M+1
        THOP(L1M1,LM,IATOM1,IENV,ISPIN)=
     &  THOP(L1M1,LM,IATOM1,IENV,ISPIN)+
     &  TMAT(L1M2,LM3,IATOM1G,IENVG,ISPIN)*
     &  U(IWIG12,IG)*CONJG(U(IWIG03,IG))
        SHOP(L1M1,LM,IATOM1,IENV,ISPIN)=
     &  SHOP(L1M1,LM,IATOM1,IENV,ISPIN)+
     &  SMAT(L1M2,LM3,IATOM1G,IENVG,ISPIN)*
     &  U(IWIG12,IG)*CONJG(U(IWIG03,IG))
        ENDDO
        ENDDO
        ENDDO
        ENDDO
        ENDDO                               !!! over point group
	ENDIF
        ENDDO                               !!! over l
	ENDIF
        ENDDO                               !!! over l1
        ENDDO                               !!! over ienv
        ENDDO                               !!! over iatom1
        ENDDO                               !!! over spins
C  SET UP ROTATED MATRIX
        DO ISPIN=1,NSPIN                    !!! over spins
        DO IATOM1=1,NATOM                   !!! over iatom1
        ISORT1=IS(IATOM1)
        DO IENV=0,NENV(IATOM1)              !!! over ienv
        IATOM=ISENV(IENV,IATOM1)
        ISORT=IS(IATOM)
        DO L1=0,ILSB(ISORT1)                !!! over l1
        IF(LTBAS(L1,IATOM1))THEN
        DO L=0,ILSB(ISORT)                  !!! over l
        IF(LTBAS(L,IATOM))THEN
        DO M1=-L1,L1
        L1M1=L1*(L1+1)+M1+1
        DO M=-L,L
        LM=L*(L+1)+M+1
        TMAT(L1M1,LM,IATOM1,IENV,ISPIN)=
     &  THOP(L1M1,LM,IATOM1,IENV,ISPIN)/DBLE(NGROUP)
        SMAT(L1M1,LM,IATOM1,IENV,ISPIN)=
     &  SHOP(L1M1,LM,IATOM1,IENV,ISPIN)/DBLE(NGROUP)
        ENDDO
        ENDDO
	ENDIF
        ENDDO                               !!! over l
	ENDIF
        ENDDO                               !!! over l1
        ENDDO                               !!! over ienv
        ENDDO                               !!! over iatom1
        ENDDO                               !!! over spins
C  STORE HOPPING INTEGRALS
	CALL WRITEHOP
	END
