	SUBROUTINE SHUBPAR(IPAN)
***************************************************************
*   Adds Hubbard correction to the potential parameters.      *
*   Written by S.Yu.Savrasov (P.N.Lebedev Physical Institute) *
***************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX)
     &    ,NRAD(NSORTMAX),NKAP(NPANMAX)
	COMPLEX*16 EK(NKAPMAX,NPANMAX),EKAP(NKAPMAX,NPANMAX)
     &    ,HPARHH(LIMLMB,LIMLMB,NPAT),HPARJH(LIMLMT,LIMLMB,NPAT)
     &    ,HPARHJ(LIMLMB,LIMLMT,NPAT),HPARJJ(LIMLMT,LIMLMT,NPAT)
     &    ,HMTHH(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NSPINMAX)
     &    ,HMTJH(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NSPINMAX)
     &    ,HMTHJ(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NSPINMAX)
     &    ,HMTJJ(NKAPMAX,NKAPMAX,0:LMAXT,NSORTMAX,NSPINMAX)
     &    ,OMTHH(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NSPINMAX)
     &    ,OMTJH(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NSPINMAX)
     &    ,OMTHJ(NKAPMAX,NKAPMAX,0:LMAXB,NSORTMAX,NSPINMAX)
     &    ,OMTJJ(NKAPMAX,NKAPMAX,0:LMAXT,NSORTMAX,NSPINMAX)
        COMPLEX*16 
     &     VHUB(LIMLMB2,NPAT,NSPINMAX),DHUB(LIMLMB2,NPAT,NSPINMAX)
     &    ,VCNS(LIMLMB2,NPAT,NSPINMAX),DLDA(LIMLMB2,NPAT,NSPINMAX)
	DIMENSION SMT(NSORTMAX),GAM(0:LMAXT,NSORTMAX)
	LOGICAL LOG1,LOG,LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX)
     &    ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
	CHARACTER*60 SCRFILE(100) 
	COMMON /CONTROL/MAN,LMTO,NLR,NINT                !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM    !!! from init
	COMMON /POTCOM/ SWZ,SMT                          !!! from vfull
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                !!! from init
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS            !!! from init
	COMMON /LMTPAR/ GAM                              !!! from potpar
	COMMON /SPIN/   NSPIN                            !!! from init
        COMMON /MTPAR / HMTHH,HMTJH,HMTHJ,HMTJJ,OMTHH,OMTJH,OMTHJ,OMTJJ
	COMMON /STORE1/ HPARHH,HPARJH,HPARHJ,HPARJJ      !!! from nmtpar
        COMMON /HUBCOM/ DHUB,VHUB,DLDA,VCNS              !!! from hubpot
	COMMON /INP1/   ICHUB                            !!! from readini
        COMMON /EXCH/   IEXCH                            !!! from readini
	COMMON /WORD/   NVAL                             !!! from nmtdata
	DATA PI/3.141592653589793D0/
	IF(ICHUB.EQ.0)RETURN
	IF(IPAN .NE.1)RETURN
	DO 4000 ISPIN=1,NSPIN          !!! over spins
	DO 3000 IATOM=1,NATOM          !!! over atoms
	ISORT=IS(IATOM)
        DO 2000 IKAP1=1,NKAP(IPAN)     !!! over energy
        DO 1000 IKAP =1,NKAP(IPAN)     !!! over energy
C  READ POTENTIAL PARAMETERS
        IREC=IKAP1+NKAP(IPAN)*(IKAP-1)+NKAP(IPAN)**2*(IATOM-1)+
     &  NKAP(IPAN)**2*NATOM*(ISPIN-1)
        READ(13,REC=IREC)((HPARHH(L1M1,LM,IATOM),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((HPARJH(L1M1,LM,IATOM),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((HPARHJ(L1M1,LM,IATOM),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &  ((HPARJJ(L1M1,LM,IATOM),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
C  ADD HUBBARD POTENTIAL
	DO L=0,ILSB(ISORT)             !!! over l
	LOG1=.FALSE.
	LOG =.FALSE.
	IF(LTPAN(L,IATOM,IKAP1,IPAN))LOG1=.TRUE.
	IF(LTPAN(L,IATOM,IKAP ,IPAN))LOG =.TRUE.
	DO M1=-L,L                     !!! over m1
	LM1=L*(L+1)+M1+1
	DO M=-L,L                      !!! over m
	LM=L*(L+1)+M+1
        IU=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M1+1 !!! (l,m1 m)
	IF(LOG1.AND.LOG)
     &  HPARHH(LM1,LM,IATOM)=HPARHH(LM1,LM,IATOM)+
     &  OMTHH(IKAP1,IKAP,L,ISORT,ISPIN)*(VHUB(IU,IATOM,ISPIN)+
     &  VCNS(IU,IATOM,ISPIN))
 	IF(LOG)
     &	HPARJH(LM1,LM,IATOM)=HPARJH(LM1,LM,IATOM)+
     &  OMTJH(IKAP1,IKAP,L,ISORT,ISPIN)*(VHUB(IU,IATOM,ISPIN)+
     &  VCNS(IU,IATOM,ISPIN))
 	IF(LOG1)
     &	HPARHJ(LM1,LM,IATOM)=HPARHJ(LM1,LM,IATOM)+
     &  OMTHJ(IKAP1,IKAP,L,ISORT,ISPIN)*(VHUB(IU,IATOM,ISPIN)+ 
     &  VCNS(IU,IATOM,ISPIN))
 	HPARJJ(LM1,LM,IATOM)=HPARJJ(LM1,LM,IATOM)+
     &  OMTJJ(IKAP1,IKAP,L,ISORT,ISPIN)*(VHUB(IU,IATOM,ISPIN)+
     &  VCNS(IU,IATOM,ISPIN))
        ENDDO                          !!! over m
        ENDDO                          !!! over m1
        ENDDO                          !!! over l
C  STORE POTENTIAL PARAMETERS
	IREC=IKAP1+NKAP(IPAN)*(IKAP-1)+NKAP(IPAN)**2*(IATOM-1)+
     &  NKAP(IPAN)**2*NATOM*(ISPIN-1)
	WRITE(13,REC=IREC)((HPARHH(L1M1,LM,IATOM),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((HPARJH(L1M1,LM,IATOM),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((HPARHJ(L1M1,LM,IATOM),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &  ((HPARJJ(L1M1,LM,IATOM),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
1000    CONTINUE                       !!! over ikap
2000    CONTINUE                       !!! over ikap1
3000    CONTINUE                       !!! over atoms
4000    CONTINUE                       !!! over spins
	END
