	SUBROUTINE INTMSH
***************************************************************
*   Module prepares radial mesh in each interstitial region.  *
*   according to zeroes of the Chebyshev polinoms             *
***************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX)
     &   ,NSHE(NSORTMAX),ILSV(NSORTMAX),NRAD(NSORTMAX)
     &   ,NPOL(0:NSORTMAX)
	DIMENSION RINT(0:NSHEMAX,NSORTMAX),SMT(NSORTMAX)
     &   ,SROU(NSORTMAX),XINT(0:NSHEMAX,NSORTMAX)
     &   ,TT(0:NPOLMAX,0:NSHEMAX,NSORTMAX),H(NSORTMAX)
     &   ,R(0:NRADMAX,NSORTMAX)
	COMMON /PARAM/   NSORT,IS,ILST,ILSB,ILSV,NATOM      !!! from init
	COMMON /POTCOM/  SWZ,SMT                            !!! for all modules
	COMMON /INTMESH/ NSHE,NPOL,SROU,RINT,XINT,TT        !!! all modules
	COMMON /RADMESH/ NRAD,H,R                           !!! for all modules
	COMMON /LATPAR/  PAR                                !!! from init
	COMMON /UNIT/    IUN                                !!! from init
	DATA PI/3.141592653589793D0/
C  CALCULATE # OF POINTS IN THE INTERSTITIAL REGION
	NPOL(0)=0
	DO 10 ISORT=1,NSORT
	STEP=R(NRAD(ISORT),ISORT)-R(NRAD(ISORT)-1,ISORT)
	SINT=SROU(ISORT)-SMT(ISORT)
	SSHE=SINT/STEP
	NUMB=SSHE
	NUMB=NUMB/2
	NUMB=NUMB*4
	IF(NUMB.LT.50)NUMB=50
	NUMB=MIN(NUMB,NSHEMAX)
	NSHE(ISORT)=50
	NPOL(ISORT)=10
C       IF(NPOL(ISORT).LT.ILSV(ISORT))NPOL(ISORT)=ILSV(ISORT)
C       IF(NPOL(ISORT).GT.NPOLMAX)PRINT*,'LOST OF ACCURACY POSSIBLE,
C    &  NPOLMAX MUST BE INCREASED UP TO',NPOL(ISORT)
	IF(NSHE(ISORT).GT.NSHEMAX-1)NSHE(ISORT)=NSHEMAX-1
	IF(NPOL(ISORT).GT.NPOLMAX)NPOL(ISORT)=NPOLMAX
	NPOL(0)=MAX(NPOL(0),NPOL(ISORT))
  10    CONTINUE
C  SET ZEROES OF THE CHEBYSHEV POLYNOMS
	DO 40 ISORT=1,NSORT
	XINT(0,ISORT)=1.D0
	XINT(NSHE(ISORT)+1,ISORT)=-1.D0
	CALL ORTPOL(XINT(0,ISORT),TT(0,0,ISORT),NPOL(ISORT))
	CALL ORTPOL(XINT(NSHE(ISORT)+1,ISORT),
     &  TT(0,NSHE(ISORT)+1,ISORT),NPOL(ISORT))
	DO 20 I=1,NSHE(ISORT)
	XINT(I,ISORT)=COS(PI*DBLE(2*I-1)/DBLE(2*NSHE(ISORT)))
	CALL ORTPOL(XINT(I,ISORT),TT(0,I,ISORT),NPOL(ISORT))
  20    CONTINUE
C  SET MESH IN THE INTERSTITIAL REGION
	AT=0.5D0*(SROU(ISORT)+SMT(ISORT))
	BT=0.5D0*(SROU(ISORT)-SMT(ISORT))
	RINT(0,ISORT)=SMT(ISORT)
	RINT(NSHE(ISORT)+1,ISORT)=SROU(ISORT)
	DO 30 I=1,NSHE(ISORT)
	RINT(I,ISORT)=AT-BT*XINT(I,ISORT)
  30    CONTINUE
  40    CONTINUE
	END


	SUBROUTINE ORTPOL(X,T,NPOL)
*************************************************
*  The calculation of the Chebyshev"s polinoms  *
*************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	DIMENSION T(NPOL+1)
	T(1)=1.D0
	T(2)=X
	DO 10 I=2,NPOL
  10    T(I+1)=2.D0*X*T(I)-T(I-1)
	T(1)=T(1)/SQRT(2.D0)
	END
