	SUBROUTINE SINTPAR(IPAN)
**************************************************************
*  Subroutine calculates interstitial contribution to the    *
*  potential parameters of the hamiltonian matrix.           *
*  Written by S.Yu.Savrasov in Max-Planck-Institut, Germany  *
**************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	PARAMETER (LPLMAX=(2*LMAXV+1)**2)
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,IS(NPAT),NHSORT(NSORTMAX),LMSYM(LMMAXV,NPAT)
     &    ,IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX)
     &    ,NKAP(NPANMAX),NSHE(NSORTMAX),NPOL(0:NSORTMAX)
	COMPLEX*16 CHEBV(0:NPOLMAX,NSYMMAX,NPAT,NSPINMAX)
     &    ,CONVV(0:NPOLMAX,NSYMMAX,NPAT,NSPINMAX)
     &    ,HPARHH(LIMLMB,LIMLMB,NPAT),HPARHJ(LIMLMB,LIMLMT,NPAT)
     &    ,HPARJH(LIMLMT,LIMLMB,NPAT),HPARJJ(LIMLMT,LIMLMT,NPAT)
     &    ,EKAP(NKAPMAX,NPANMAX),EK(NKAPMAX,NPANMAX),BES(3,0:LMAXT)
     &    ,HAN(3,0:LMAXT),HANR(0:NSHEMAX,0:LMAXT,NKAPMAX)
     &    ,AHH(0:NPOLMAX),AJH(0:NPOLMAX),AJJ(0:NPOLMAX)
     &    ,BESR(0:NSHEMAX,0:LMAXT,NKAPMAX),AHJ(0:NPOLMAX)
     &    ,ALPHA(0:LMAXT,0:NSORTMAX,NKAPMAX,NPANMAX)
     &    ,ALPDOT(0:LMAXT,0:NSORTMAX,NKAPMAX,NPANMAX)
     &    ,DLOG(0:LMAXT,0:NSORTMAX,NKAPMAX,NPANMAX)
	DIMENSION SMT(NSORTMAX),RINT(0:NSHEMAX,NSORTMAX),SROU(NSORTMAX)
     &    ,XINT(0:NSHEMAX,NSORTMAX),TT(0:NPOLMAX,0:NSHEMAX,NSORTMAX)
     &    ,C(0:LMAXV+1,LMMAXV1,LMMAXV1),GAM(0:LMAXT,NSORTMAX)
     &    ,RLOC(NSORTMAX)
	LOGICAL SYM(LMMAXV,NPAT),LOG1,LOG
     &    ,LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX)
     &    ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
	CHARACTER TXTEL(NSORTMAX)*10
	COMMON /CONTROL/MAN,LMTO,NLR,NINT                   !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT!!! from init
	COMMON /POTCOM/ SWZ,SMT                             !!! from init
	COMMON /CHEBV/  CHEBV,CONVV                         !!! from vcheb
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                   !!! from init
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS               !!! from init
	COMMON /STORE1/ HPARHH,HPARJH,HPARHJ,HPARJJ         !!! from intpar
	COMMON /LATPAR/ PAR                                 !!! from init
	COMMON /GAUNT/  C                                   !!! from gaunt
	COMMON /LMTPAR/ GAM                                 !!! from lmtpar
	COMMON /INTMESH/NSHE,NPOL,SROU,RINT,XINT,TT         !!! from init
        COMMON /SCRINP/ RLOC,ALPHA,ALPDOT,DLOG              !!! from alpcon
	COMMON /SYMMLM/ SYM,LMSYM                           !!! from symlm
	COMMON /SPIN/   NSPIN                               !!! from init
	COMMON /UNIT/   IUN                                 !!! from init
	COMMON /WORD/   NVAL                                !!! from nmtdata
	COMMON /TXTEL/  TXTEL                               !!! from init
	DATA PI/3.141592653589793D0/
	SQPI4=2.D0*SQRT(PI)
	SQ2=SQRT(2.D0)
	DO 200 ISPIN=1,NSPIN                       !!! over spins
	DO 190 IATOM=1,NATOM                       !!! over atoms
	ISORT=IS(IATOM)
	ST=SMT(ISORT)
C  FIND CHEBYSHEV COEFFICIENTS FOR PRODUCT OF TWO SPHERICAL FUNCTIONS
	DO 30 IKAP=1,NKAP(IPAN)                    !!! over energies
	DO 20 IRAD=0,NSHE(ISORT)+1                 !!! over radial mesh
	RT=RINT(IRAD,ISORT)
	CALL BESSEL(RT,EKAP(IKAP,IPAN),ST,BES(1,0),ILST(ISORT))
	CALL HANKEL(RT,EKAP(IKAP,IPAN),ST,HAN(1,0),ILST(ISORT))
	DO 10 L=0,ILST(ISORT)                       !!! over l
	HANR(IRAD,L,IKAP)=HAN(1,L)
        BESR(IRAD,L,IKAP)=BES(1,L)-ALPHA(L,ISORT,IKAP,IPAN)/
     &  GAM(L,ISORT)*HAN(1,L)
  10    CONTINUE                                   !!! over l
  20    CONTINUE                                   !!! over radial mesh
  30    CONTINUE                                   !!! over energies
	DO 180 IKAP1=1,NKAP(IPAN)                  !!! over energies
	DO 170 IKAP=1,NKAP(IPAN)                   !!! over energies
	IREC=IKAP1+NKAP(IPAN)*(IKAP-1)+NKAP(IPAN)**2*(IATOM-1)+
     &  NKAP(IPAN)**2*NATOM*(ISPIN-1)
	READ(13,REC=IREC)((HPARHH(L1M1,LM,IATOM),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((HPARJH(L1M1,LM,IATOM),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((HPARHJ(L1M1,LM,IATOM),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &  ((HPARJJ(L1M1,LM,IATOM),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
	DO 160 L1=0,ILST(ISORT)                    !!! over l1
	LOG1=.FALSE.
	IF(LTPAN(L1,IATOM,IKAP1,IPAN))LOG1=.TRUE.
	DO 150 L=0,ILST(ISORT)                     !!! over l
	LOG=.FALSE.
	IF(LTPAN(L,IATOM,IKAP,IPAN))LOG=.TRUE.
	DO 50 IPOL=0,NPOL(ISORT)                   !!! over polinoms
	AHH(IPOL)=(0.D0,0.D0)
	AJH(IPOL)=(0.D0,0.D0)
	AHJ(IPOL)=(0.D0,0.D0)
	AJJ(IPOL)=(0.D0,0.D0)
	DO 40 IRAD=1,NSHE(ISORT)                   !!! over radial mesh
	IF(LOG1.AND.LOG)
     &  AHH(IPOL)=AHH(IPOL)+2.D0/NSHE(ISORT)*HANR(IRAD,L1,IKAP1)
     &   *CONJG(HANR(IRAD,L,IKAP))*TT(IPOL,IRAD,ISORT)
	IF(LOG)
     &  AJH(IPOL)=AJH(IPOL)+2.D0/NSHE(ISORT)*BESR(IRAD,L1,IKAP1)
     &   *CONJG(HANR(IRAD,L,IKAP))*TT(IPOL,IRAD,ISORT)
	IF(LOG1)
     &  AHJ(IPOL)=AHJ(IPOL)+2.D0/NSHE(ISORT)*HANR(IRAD,L1,IKAP1)
     &   *CONJG(BESR(IRAD,L,IKAP))*TT(IPOL,IRAD,ISORT)
	AJJ(IPOL)=AJJ(IPOL)+2.D0/NSHE(ISORT)*BESR(IRAD,L1,IKAP1)
     &   *CONJG(BESR(IRAD,L,IKAP))*TT(IPOL,IRAD,ISORT)
  40    CONTINUE                                   !!! over radial mesh
  50    CONTINUE                                   !!! over polinoms
C  CALCULATE INTERSTITIAL POTENTIAL MATRIX ELEMENTS
	DO 140 M1=-L1,L1                           !!! over m1
	L1M1=L1*(L1+1)+M1+1
	DO 130 M=-L,L                              !!! over m
	LM=L*(L+1)+M+1
	DO 120 L2=ABS(L-L1),L+L1,2                 !!! over l2
	LL2=L2/2
	M2=M1-M
	IF(ABS(M2).LE.L2.AND.L2.LE.ILSV(ISORT))THEN!!! over m2
	L2M2=L2*(L2+1)+M2+1
	IF(SYM(L2M2,IATOM))THEN                    !!! for non-zeroes
	ISYM=LMSYM(L2M2,IATOM)
	DO 110 IPOL2=0,NPOL(ISORT)                 !!! over polinoms
	IF(LOG1.AND.LOG)HPARHH(L1M1,LM,IATOM)=HPARHH(L1M1,LM,IATOM)+
     &  C(LL2,L1M1,LM)*(0.D0,1.D0)**(L-L1+L2)*
     &  CONVV(IPOL2,ISYM,IATOM,ISPIN)*CONJG(AHH(IPOL2))
	IF(LOG)HPARJH(L1M1,LM,IATOM)=HPARJH(L1M1,LM,IATOM)+
     &  C(LL2,L1M1,LM)*(0.D0,1.D0)**(L-L1+L2)*
     &  CONVV(IPOL2,ISYM,IATOM,ISPIN)*CONJG(AJH(IPOL2))*
     &  GAM(L1,ISORT)
	IF(LOG1)HPARHJ(L1M1,LM,IATOM)=HPARHJ(L1M1,LM,IATOM)+
     &  C(LL2,L1M1,LM)*(0.D0,1.D0)**(L-L1+L2)*
     &  CONVV(IPOL2,ISYM,IATOM,ISPIN)*CONJG(AHJ(IPOL2))*GAM(L,ISORT)
	HPARJJ(L1M1,LM,IATOM)=HPARJJ(L1M1,LM,IATOM)+
     &  C(LL2,L1M1,LM)*(0.D0,1.D0)**(L-L1+L2)*
     &  CONVV(IPOL2,ISYM,IATOM,ISPIN)*
     &  CONJG(AJJ(IPOL2))*GAM(L1,ISORT)*GAM(L,ISORT)
 110    CONTINUE                                   !!! over polynoms
	ENDIF                                      !!! for non-zeroes
	ENDIF                                      !!! over m2
 120    CONTINUE                                   !!! over l2
 130    CONTINUE                                   !!! over m
 140    CONTINUE                                   !!! over m1
 150    CONTINUE                                   !!! over l
 160    CONTINUE                                   !!! over l1
	IREC=IKAP1+NKAP(IPAN)*(IKAP-1)+NKAP(IPAN)**2*(IATOM-1)+
     &  NKAP(IPAN)**2*NATOM*(ISPIN-1)
	WRITE(13,REC=IREC)((HPARHH(L1M1,LM,IATOM),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((HPARJH(L1M1,LM,IATOM),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((HPARHJ(L1M1,LM,IATOM),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &  ((HPARJJ(L1M1,LM,IATOM),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
 170    CONTINUE                                   !!! over energies
 180    CONTINUE                                   !!! over energies
 190    CONTINUE                                   !!! over atoms
 200    CONTINUE                                   !!! over spins
	END
