	SUBROUTINE MIXROB(ITER,KEY)
**************************************************************
*  Mixes charge densities according to the Broyden           *
*  prescription.                                             *
*  Last modified 31.10.96.                                   *
**************************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
        INCLUDE 'PARAM.DAT'
        INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,IS(NPAT),NHSORT(NSORTMAX),NKAP(NPANMAX),NRAD(NSORTMAX)
     &   ,LMSYM(LMMAXV,NPAT),NSHE(NSORTMAX),NPOL(0:NSORTMAX)
        DIMENSION H(NSORTMAX),R(0:NRADMAX,NSORTMAX),SMT(NSORTMAX)
     &   ,WEIGHT(0:NRADMAX,NSORTMAX),Z(NSORTMAX),ZCOR(NSORTMAX)
     &   ,RL(0:NRADMAX,0:LMAXV,NSORTMAX),DR(0:NRADMAX,NSORTMAX)
     &   ,WTER(0:NTERMAX),QCH(NPAT,NSPINMAX),SROU(NSORTMAX)
     &   ,RINT(0:NSHEMAX,NSORTMAX),WRAD(NLENMAX)
        COMPLEX*16 RO(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX)
     &   ,WORK1(0:NRADMAX),WORK2(0:NRADMAX),WMIX(NTERMAX,NTERMAX)
     &   ,ROVALDS(3,NSYMMAX,NPAT,NSPINMAX),WINP(NTERMAX)
     &   ,ROCOR(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX)
     &   ,ROINT(0:NSHEMAX,NSYMMAX,NPAT,NSPINMAX)
     &   ,ROCINT(0:NSHEMAX,NSYMMAX,NPAT,NSPINMAX)
     &   ,TCH(NSYMMAX,NPAT,2,NSPINMAX)
     &   ,AMTOT(NSYMMAX,NPAT,NSPINMAX)
     &	 ,XRHO(NLENMAX),XNEW(NLENMAX)
     &	 ,WRK1(NLENMAX),WRK2(NLENMAX)
        CHARACTER*10 TXTEL(NSORTMAX),TXTSP(2)*2,SCRFILE(100)*60
        LOGICAL SYM(LMMAXV,NPAT),FIRST,RESET
        COMMON /CONTROL/LIFT,LMTO,NCOU,NINT,NPF              !!! from init
        COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT !!! from init
        COMMON /POTCOM/ SWZ,SMT                              !!! from init
        COMMON /DENS/   RO,ROVALDS,ROCOR,ROINT,ROCINT        !!! from rofull
        COMMON /RADMESH/NRAD,H,R,DR,WEIGHT,RL                !!! from radmsh
	COMMON /MIXBROY/LBROY,IBROY,ADMIXB,ADMIXH,MTER,WINP,WMIX!from init
        COMMON /INTMESH/NSHE,NPOL,SROU,RINT                  !!! from intmsh
	COMMON /STORE1/ XRHO,XNEW,WRAD,WRK1,WRK2             !!! tmp.storage
        COMMON /MULTRO/ Z,ZCOR,TCH,AMTOT                     !!! from multro
        COMMON /SYMMLM/ SYM,LMSYM                            !!! from symlm
        COMMON /OUT0/   SCRFILE                              !!! from init
        COMMON /SPIN/   NSPIN                                !!! from init
        COMMON /UNIT/   IUN                                  !!! from init
        COMMON /TXTEL/  TXTEL,TXTSP                          !!! from init
	SAVE LBROY0,FIRST,RESET,WTER
        DATA PI/3.141592653589793D0/,FIRST/.TRUE./
C  SAVE SWITCH
        IF(FIRST)THEN
        LBROY0=LBROY
        MTER=0
        RESET=.TRUE.
        ENDIF
        FIRST=.FALSE.
C  DO NOT START BROYDEN, WAIT
	IF(ITER.LE.IBROY)THEN
	LBROY=-1
C  SWITCH ON NOW
	ELSEIF(ITER.GT.IBROY)THEN
	LBROY=LBROY0
	ENDIF
	IF(LBROY.LT.0)RETURN
C  SET ITERATION NUMBER
	IF(MTER.EQ.NTERMAX-1)RESET=.TRUE.
	IF(MTER.EQ.NTERMAX-1)
     &  PRINT*,'<MIXROB>:: MTER>NTERMAX, BROYDEN RESTARTED'
	IF(RESET)MTER=0
	IF(KEY.EQ.1.AND.MTER.NE.0)RETURN
	IF(KEY.EQ.2)MTER=MTER+1
C  *** SET MIXING ARRAY ***
	IDIM=0
	DO IATOM=1,NATOM                    !!! over atoms
	ISORT=IS(IATOM)
        DO L=0,ILSV(ISORT)                  !!! over l
        DO M=-L,L                           !!! over m
        LM=L*(L+1)+M+1
        ISYM=LMSYM(LM,IATOM)
        SL=SMT(ISORT)**L
        IF(SYM(LM,IATOM))THEN               !!! for only non-zero components
C  1) Pack Valence Charge Density within MTS into Array
        IF(L.LE.LBROY)THEN
	DO IRAD=0,NRAD(ISORT)               !!! over irad
	IDIM=IDIM+1
	IF(ISYM.EQ.1)
     &	XRHO(IDIM)=0.5D0*DBLE(NSPIN)*CMPLX(DREAL(
     & 	RO(IRAD,ISYM,IATOM,1)-ROCOR(IRAD,ISYM,IATOM,1)+
     &  RO(IRAD,ISYM,IATOM,NSPIN)-
     &  ROCOR(IRAD,ISYM,IATOM,NSPIN)),0.D0)
	IF(ISYM.GT.1)
     &	XRHO(IDIM)=0.5D0*DBLE(NSPIN)*(
     & 	RO(IRAD,ISYM,IATOM,1)-ROCOR(IRAD,ISYM,IATOM,1)+
     &  RO(IRAD,ISYM,IATOM,NSPIN)-
     &  ROCOR(IRAD,ISYM,IATOM,NSPIN))
	WRAD(IDIM)=1.D0
	ENDDO                               !!! over irad
	ENDIF
C  2) Pack Valence Charge Density in the INTS into Array
	DO IRAD=0,NSHE(ISORT)+1             !!! over ishe
	IDIM=IDIM+1
	IF(ISYM.EQ.1)
     &	XRHO(IDIM)=0.5D0*DBLE(NSPIN)*CMPLX(DREAL(
     & 	ROINT(IRAD,ISYM,IATOM,1)-ROCINT(IRAD,ISYM,IATOM,1)+
     &  ROINT(IRAD,ISYM,IATOM,NSPIN)-
     &  ROCINT(IRAD,ISYM,IATOM,NSPIN)),0.D0)
	IF(ISYM.GT.1)
     &	XRHO(IDIM)=0.5D0*DBLE(NSPIN)*(
     & 	ROINT(IRAD,ISYM,IATOM,1)-ROCINT(IRAD,ISYM,IATOM,1)+
     &  ROINT(IRAD,ISYM,IATOM,NSPIN)-
     &  ROCINT(IRAD,ISYM,IATOM,NSPIN))
	WRAD(IDIM)=1.D0
	ENDDO                               !!! over ishe
	IF(NSPIN.EQ.2)THEN
C  3) Pack Magnetization within MTS into Array
        IF(L.LE.LBROY)THEN
	DO IRAD=0,NRAD(ISORT)               !!! over irad
	IDIM=IDIM+1
	IF(ISYM.EQ.1)
     &	XRHO(IDIM)=CMPLX(DREAL(RO(IRAD,ISYM,IATOM,1)-
     &  ROCOR(IRAD,ISYM,IATOM,1)-RO(IRAD,ISYM,IATOM,NSPIN)+
     &  ROCOR(IRAD,ISYM,IATOM,NSPIN)),0.D0)
	IF(ISYM.GT.1)
     &	XRHO(IDIM)=RO(IRAD,ISYM,IATOM,1)-
     &  ROCOR(IRAD,ISYM,IATOM,1)-RO(IRAD,ISYM,IATOM,NSPIN)+
     &  ROCOR(IRAD,ISYM,IATOM,NSPIN)
	WRAD(IDIM)=1.D0
	ENDDO                               !!! over irad
	ENDIF
C  4) Pack Magnetization in the INTS into Array
	DO IRAD=0,NSHE(ISORT)+1             !!! over ishe
	IDIM=IDIM+1
	IF(ISYM.EQ.1)
     &	XRHO(IDIM)=CMPLX(DREAL(ROINT(IRAD,ISYM,IATOM,1)-
     &  ROCINT(IRAD,ISYM,IATOM,1)-ROINT(IRAD,ISYM,IATOM,NSPIN)+
     &  ROCINT(IRAD,ISYM,IATOM,NSPIN)),0.D0)
	IF(ISYM.GT.1)
     &	XRHO(IDIM)=ROINT(IRAD,ISYM,IATOM,1)-
     &  ROCINT(IRAD,ISYM,IATOM,1)-ROINT(IRAD,ISYM,IATOM,NSPIN)+
     &  ROCINT(IRAD,ISYM,IATOM,NSPIN)
	WRAD(IDIM)=1.D0
	ENDDO                               !!! over ishe
	ENDIF
	ENDIF                               !!! for only non-zero components
	ENDDO                               !!! over m
	ENDDO                               !!! over l
	ENDDO                               !!! over atoms
	NDIM=IDIM
	IF(NDIM.GT.NLENMAX)
     &  STOP'NLENMAX MUST BE INCREASED IN PARAM.DAT'
C  SEND ARRAY TO BROYDEN
        CALL BROY4N(XRHO,XNEW,WRAD,WRK1,WRK2,NDIM,MTER
     &             ,ADMIXB,WTER,WINP,WMIX,22,SCRFILE(22))      
	IF(MTER.EQ.0)RESET=.FALSE.
	IF(MTER.EQ.0)RETURN
C  *** DEFINE NEW CHARGE DENSITY ***
	IDIM=0
	NEGD=0
	DO IATOM=1,NATOM                    !!! over atoms
	ISORT=IS(IATOM)
        DO L=0,ILSV(ISORT)                  !!! over l
        DO M=-L,L                           !!! over m
        LM=L*(L+1)+M+1
        ISYM=LMSYM(LM,IATOM)
        SL=SMT(ISORT)**L
        IF(SYM(LM,IATOM))THEN               !!! for only non-zero components
C  Repack Spin Densities
        IF(L.LE.LBROY)THEN
	DO IRAD=0,NRAD(ISORT)               !!! over irad
	IDIM=IDIM+1
	IF(ISYM.EQ.1)THEN
	RO(IRAD,ISYM,IATOM,1)=
     &  CMPLX(DREAL(XNEW(IDIM)/DBLE(NSPIN)),0.D0)
	RO(IRAD,ISYM,IATOM,NSPIN)=
     &  CMPLX(DREAL(XNEW(IDIM)/DBLE(NSPIN)),0.D0)
	ELSE
	RO(IRAD,ISYM,IATOM,1)=XNEW(IDIM)/DBLE(NSPIN)
	RO(IRAD,ISYM,IATOM,NSPIN)=XNEW(IDIM)/DBLE(NSPIN)
	ENDIF
	ENDDO                               !!! over irad
	ENDIF
	DO IRAD=0,NSHE(ISORT)+1             !!! over ishe
	IDIM=IDIM+1
	IF(ISYM.EQ.1)THEN
	ROINT(IRAD,ISYM,IATOM,1)=
     &  CMPLX(DREAL(XNEW(IDIM)/DBLE(NSPIN)),0.D0)
	ROINT(IRAD,ISYM,IATOM,NSPIN)=
     &  CMPLX(DREAL(XNEW(IDIM)/DBLE(NSPIN)),0.D0)
	ELSE
	ROINT(IRAD,ISYM,IATOM,1)=XNEW(IDIM)/DBLE(NSPIN)
	ROINT(IRAD,ISYM,IATOM,NSPIN)=XNEW(IDIM)/DBLE(NSPIN)
	ENDIF
	ENDDO                               !!! over ishe
	IF(NSPIN.EQ.2)THEN
        IF(L.LE.LBROY)THEN
	DO IRAD=0,NRAD(ISORT)               !!! over irad
	IDIM=IDIM+1
	IF(ISYM.EQ.1)THEN
	RO(IRAD,ISYM,IATOM,1)=RO(IRAD,ISYM,IATOM,1)+
     &  CMPLX(DREAL(XNEW(IDIM)/DBLE(NSPIN)),0.D0)
	RO(IRAD,ISYM,IATOM,NSPIN)=RO(IRAD,ISYM,IATOM,NSPIN)-
     &  CMPLX(DREAL(XNEW(IDIM)/DBLE(NSPIN)),0.D0)
	ELSE
	RO(IRAD,ISYM,IATOM,1)=RO(IRAD,ISYM,IATOM,1)+
     &  XNEW(IDIM)/DBLE(NSPIN)
	RO(IRAD,ISYM,IATOM,NSPIN)=RO(IRAD,ISYM,IATOM,NSPIN)-
     &  XNEW(IDIM)/DBLE(NSPIN)
	ENDIF
	ENDDO                               !!! over irad
	ENDIF
	DO IRAD=0,NSHE(ISORT)+1             !!! over ishe
	IDIM=IDIM+1
	IF(ISYM.EQ.1)THEN
	ROINT(IRAD,ISYM,IATOM,1)=ROINT(IRAD,ISYM,IATOM,1)+
     &  CMPLX(DREAL(XNEW(IDIM)/DBLE(NSPIN)),0.D0)
	ROINT(IRAD,ISYM,IATOM,NSPIN)=ROINT(IRAD,ISYM,IATOM,NSPIN)-
     &  CMPLX(DREAL(XNEW(IDIM)/DBLE(NSPIN)),0.D0)
	ELSE
	ROINT(IRAD,ISYM,IATOM,1)=ROINT(IRAD,ISYM,IATOM,1)+
     &  XNEW(IDIM)/DBLE(NSPIN)
	ROINT(IRAD,ISYM,IATOM,NSPIN)=ROINT(IRAD,ISYM,IATOM,NSPIN)-
     &  XNEW(IDIM)/DBLE(NSPIN)
	ENDIF
	ENDDO                               !!! over ishe
	ENDIF
C  Add core density
	DO ISPIN=1,NSPIN
	IF(L.LE.LBROY)THEN
	DO IRAD=0,NRAD(ISORT)
	RO(IRAD,ISYM,IATOM,ISPIN)=RO(IRAD,ISYM,IATOM,ISPIN)+
     &  ROCOR(IRAD,ISYM,IATOM,ISPIN)
	ENDDO
	ENDIF
	DO IRAD=0,NSHE(ISORT)+1
	ROINT(IRAD,ISYM,IATOM,ISPIN)=ROINT(IRAD,ISYM,IATOM,ISPIN)+
     &  ROCINT(IRAD,ISYM,IATOM,ISPIN)
	ENDDO
	ENDDO
	ENDIF                               !!! for only non-zero components
	ENDDO                               !!! over m
	ENDDO                               !!! over l
C  Check out for positive definiteness
	DO ISPIN=1,NSPIN
	DO IRAD=0,NRAD(ISORT)
	IF(DREAL(RO(IRAD,1,IATOM,ISPIN)).LE.0.D0)NEGD=1
	ENDDO
	ENDDO
	ENDDO                               !!! over atoms
C  Switch off mixing ???
	IF(NEGD.EQ.1)
     &  WRITE(IUN,*)'<MIXROB>::CHARGE DENSITY IS NOT POSITIVE'
C	IF(NEGD.EQ.1)LBROY =-1
C	IF(NEGD.EQ.1)LBROY0=-1
C	IF(NEGD.EQ.1)PRINT*,'<MIXBRO>: BROYDEN  MIXING IS OFF' 
C  CHECK OUT ELECTRONEUTRALITY
        CALL ROCHEB         !!! find Chebyshev expansion coefficients
        CALL SMULTRO        !!! calculate multipole charges
	ZTOT=0.D0
	TOTM=0.D0
	IRES=0
        DO IATOM=1,NATOM                    !!! over atoms
        ISORT=IS(IATOM)
        DO ISPIN=1,NSPIN                    !!! over spins
        DO IRAD=0,NRAD(ISORT)
        WORK1(IRAD)=RO(IRAD,1,IATOM,ISPIN)*
     &  WEIGHT(IRAD,ISORT)/SQRT(4.D0*PI)
	ENDDO
        CALL CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	QIM=DIMAG(WORK2(NRAD(ISORT)))
        IF(ABS(QIM).GE.1.D-10)THEN
	IRES=1
	PRINT*,'<MIXBRO>: IMAGINARY PART IS NOT ZERO',QIM
        ENDIF
        QCH(IATOM,ISPIN)=AMTOT(1,IATOM,ISPIN)
	ZTOT=ZTOT+QCH(IATOM,ISPIN)
	TOTM=TOTM-QCH(IATOM,ISPIN)*(-1)**ISPIN
	ENDDO                               !!! over spins
	ENDDO                               !!! over atoms
C  Restart mixing
	IF(IRES.EQ.0)RESET=.FALSE.
 	IF(IRES.EQ.1)RESET=.TRUE.
	IF(IRES.EQ.1)PRINT*,'<MIXBRO>: BROYDEN  MIXING  RESTARTED' 
C  Switch off mixing ???
C	IF(IRES.EQ.1)LBROY =-1
C	IF(IRES.EQ.1)LBROY0=-1
C	IF(IRES.EQ.1)PRINT*,'<MIXBRO>: BROYDEN  MIXING  IS OFF' 
C  PRINT BLOCK
	WRITE(IUN,1010)WTER(MTER)
	IF(NSPIN.EQ.1)WRITE(IUN,1020)
	IF(NSPIN.EQ.2)WRITE(IUN,1030)
        DO IATOM=1,NATOM                    !!! over atoms
        ISORT=IS(IATOM)
	IF(NSPIN.EQ.1)
     &	WRITE(IUN,1040)0.5D0*DBLE(NSPIN)*(QCH(IATOM,1)+
     &  QCH(IATOM,NSPIN)),TXTEL(ISORT)
	IF(NSPIN.EQ.2)
     &	WRITE(IUN,1050)0.5D0*DBLE(NSPIN)*(QCH(IATOM,1)+
     &  QCH(IATOM,NSPIN)),QCH(IATOM,1)-QCH(IATOM,NSPIN),
     &  TXTEL(ISORT)
	ENDDO                               !!! over atoms
	WRITE(IUN,1060)ZTOT
	IF(NSPIN.EQ.2)WRITE(IUN,1070)TOTM
	WRITE(IUN,1080)
1010	FORMAT(1X,'Broyden Mixing for Rho(r), Iter-Weight=',G14.7)
1020	FORMAT(1X,' New Charge:')
1030	FORMAT(1X,' New Charge:        Magnetization:')           
1040	FORMAT(1X,G14.7,2X,A10)
1050	FORMAT(1X,G14.7,5X,G14.7,2X,A10)
1060	FORMAT(1X,'Extra charge  in the unit cell =',G14.7)
1070	FORMAT(1X,'Magnetization in the unit cell =',G14.7)
1080    FORMAT(1X,'----------------------------------------------')
	END
