	SUBROUTINE SMULTIN
**************************************************************
*  Finds multipoles of the charge density in the int.reg.    *
*  Written by S.Yu.Savrasov (P.N.Lebedev Physical Institute) *
**************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	PARAMETER (LPLMAX=(2*LMAXV+1)**2)
	INTEGER ILSV(NSORTMAX),ILST(NSORTMAX),ILSB(NSORTMAX)
     &    ,IS(NPAT),NHSORT(NSORTMAX),LMSYM(LMMAXV,NPAT)
     &    ,NCEL(NPAT),ICENV(0:NENVMAX,NPAT),NSYM(NPAT)
     &    ,NSHE(NSORTMAX),NPOL(0:NSORTMAX)
	DIMENSION SMT(NSORTMAX),RINT(0:NSHEMAX,NSORTMAX)
     &    ,RHOINT(0:NSHEMAX,NMSHMAX,NSPINMAX)
     &    ,SROU(NSORTMAX),Z(NSORTMAX),ZCOR(NSORTMAX)
     &    ,WCEL(0:NSHEMAX,NMSHMAX),PCEL(3,NMSHMAX)
     &    ,CENV(3,0:NENVMAX,NPAT)
	COMPLEX*16 TCH(NSYMMAX,NPAT,2,NSPINMAX),DIM,DIML,WRHOL
     &    ,QINT(NSYMMAX,NPAT),TRH(LMMAXV1,0:NENVMAX,NPAT,NSPINMAX)
     &    ,ROINT(0:NSHEMAX,NSYMMAX,NPAT,NSPINMAX),YY(LMMAXV1)
     &    ,ROCOR(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX)
     &    ,RO(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX)
     &    ,ROVALDS(3,NSYMMAX,NPAT,NSPINMAX)
     &    ,AMTOT(NSYMMAX,NPAT,NSPINMAX),QASA(NSYMMAX,NPAT)
	LOGICAL SYM(LMMAXV,NPAT)
	CHARACTER TXTEL(NSORTMAX)*10
	COMMON /CONTROL/LIFT,LMTO,NCOU,NINT,NPF             !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT!!! from init
	COMMON /STORE2/ RHOINT,WCEL,PCEL                    !!! from intrho
	COMMON /DENS/   RO,ROVALDS,ROCOR,ROINT              !!! from rofull
	COMMON /POTCOM/ SWZ,SMT                             !!! from init
	COMMON /LATPAR/ PAR                                 !!! from init
	COMMON /SYMMLM/ SYM,LMSYM,NSYM                      !!! from symlm
	COMMON /INTMESH/NSHE,NPOL,SROU,RINT                 !!! from init
	COMMON /CELMESH/NCEL,CENV,ICENV                     !!! from envmsh
	COMMON /MULTRO/ Z,ZCOR,TCH,AMTOT,QASA,QINT,TRH      !!! from init
	COMMON /SPIN/   NSPIN                               !!! from init
	COMMON /UNIT/   IUN                                 !!! from init
	DATA PI/3.141592653589793D0/,DIM/(0.D0,1.D0)/
	IAL=0
	IF(NPF.NE.0)IAL=1
	SQPI4=2.D0*SQRT(PI)
C SET INTEGRALS TO ZERO
	DO 50 IATOM=1,NATOM                  !!! over atoms
	ISORT=IS(IATOM)
	DO 40 IENV=0,NCEL(IATOM)             !!! over environment
	DO 30 ISPIN=1,NSPIN                  !!! over spins
	DO 20 L=0,ILSV(ISORT)+IAL
	DO 10 M=-L,L                         !!! over m
	LM=L*(L+1)+M+1
	TRH(LM,IENV,IATOM,ISPIN)=(0.D0,0.D0)
  10    CONTINUE                             !!! over m
  20    CONTINUE                             !!! over l
  30    CONTINUE                             !!! over spins
  40    CONTINUE                             !!! over environment 
  50    CONTINUE                             !!! over atoms
C CALCULATE CELL MULTIPOLE OF THE FIRST KIND
	DO 180 KATOM=1,NATOM                 !!! over atoms
	KSORT=IS(KATOM)
	CALL SRFGRD(KATOM,NMSH,WCEL,PCEL)              ! weights
	CALL SFUNIN(KATOM,NMSH,PCEL,ROINT,RHOINT)      ! charge density
	DO 170 IATOM=1,NATOM                 !!! over atoms
	ISORT=IS(IATOM)
	DO 160 IENV=0,NCEL(IATOM)            !!! over environment
	KATOMQ=ICENV(IENV,IATOM)
	IF(KATOMQ.NE.KATOM)GOTO160
	IF(NCOU.EQ.0.AND.IENV.NE.0)GOTO160
	DO 150 IMSH=1,NMSH                   !!! over surface grid
	DO 140 IRAD=0,NSHE(KSORT)+1          !!! over radial points
	XCOORD=RINT(IRAD,KSORT)*PCEL(1,IMSH)+CENV(1,IENV,IATOM)*PAR
	YCOORD=RINT(IRAD,KSORT)*PCEL(2,IMSH)+CENV(2,IENV,IATOM)*PAR
	ZCOORD=RINT(IRAD,KSORT)*PCEL(3,IMSH)+CENV(3,IENV,IATOM)*PAR
	RR=SQRT(XCOORD*XCOORD+YCOORD*YCOORD+ZCOORD*ZCOORD)
	CALL SPHHARM(XCOORD/RR,YCOORD/RR,ZCOORD/RR,ILSV(ISORT)+IAL,YY)
	DO 130 ISPIN=1,NSPIN
	WRHO=RHOINT(IRAD,IMSH,ISPIN)*WCEL(IRAD,IMSH)*SQPI4
	RSM=SMT(ISORT)/RR
	DIML=DIM
	LM=0
	DO 110 L=0,ILSV(ISORT)+IAL           !!! over l
	DIML=-DIM*DIML*RSM
	WRHOL=WRHO*DIML
	DO 100 M=-L,L                        !!! over m
	LM=LM+1
	TRH(LM,IENV,IATOM,ISPIN)=TRH(LM,IENV,IATOM,ISPIN)+
     &  WRHOL*DCONJG(YY(LM))
 100    CONTINUE                             !!! over m
 110    CONTINUE                             !!! over l
 130    CONTINUE                             !!! over spins
 140    CONTINUE                             !!! over radial mesh
 150    CONTINUE                             !!! over surface grid
 160    CONTINUE                             !!! over environment
 170    CONTINUE                             !!! over atoms
 180    CONTINUE                             !!! over atoms
C  NORMALIZATION
	DO 220 IATOM=1,NATOM                 !!! over atoms
	ISORT=IS(IATOM)
	DO 210 ISPIN=1,NSPIN                 !!! over spins
	DO 200 L=0,ILSV(ISORT)
	DO 190 M=-L,L 
	LM=L*(L+1)+M+1
	IF(SYM(LM,IATOM))THEN
	ISYM=LMSYM(LM,IATOM)
	TCH(ISYM,IATOM,1,ISPIN)=(0.D0,0.D0)
	ENDIF
 190	CONTINUE
 200	CONTINUE
 210	CONTINUE
 220	CONTINUE
	DO 260 IATOM=1,NATOM                 !!! over atoms
	ISORT=IS(IATOM)
	DO 250 ISPIN=1,NSPIN                 !!! over spins
	DO 240 IENV=0,NCEL(IATOM)
	DO 230 L=0,ILSV(ISORT)
	DO 225 M=-L,L 
	LM=L*(L+1)+M+1
	IF(SYM(LM,IATOM))THEN
	ISYM=LMSYM(LM,IATOM)
	TCH(ISYM,IATOM,1,ISPIN)=TCH(ISYM,IATOM,1,ISPIN)+
     &  TRH(LM,IENV,IATOM,ISPIN)
	ENDIF
 225	CONTINUE
 230	CONTINUE
 240	CONTINUE
 250	CONTINUE
 260	CONTINUE
	DO 290 IATOM=1,NATOM                 !!! over atoms
	ISORT=IS(IATOM)
	DO 280 ISPIN=1,NSPIN                 !!! over spins
	DO 270 L=0,ILSV(ISORT)+IAL
	DO 265 M=-L,L 
	LM=L*(L+1)+M+1
	TRH(LM,0,IATOM,ISPIN)=(0.D0,0.D0)
 265	CONTINUE
 270	CONTINUE
 280	CONTINUE
 290	CONTINUE
	END


	SUBROUTINE SFUNIN(IATOM,NMSH,PCEL,FINT,FUNINT)
**************************************************************
*  Finds full charge density at the array of points in the   *
*  interstitial region.                                      *
**************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	PARAMETER (LPLMAX=(2*LMAXV+1)**2)
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,IS(NPAT),NHSORT(NSORTMAX),LMSYM(LMMAXV,NPAT)
     &    ,NSYM(NPAT),NSHE(NSORTMAX),NPOL(0:NSORTMAX)
	COMPLEX*16 FINT(0:NSHEMAX,NSYMMAX,NPAT,NSPINMAX)
     &    ,YLM(LMMAXV),YSM(NSYMMAX),DIM,FTOT(NSPINMAX)
	DIMENSION SMT(NSORTMAX),SROU(NSORTMAX),RINT(0:NSHEMAX,NSORTMAX)
     &    ,FUNINT(0:NSHEMAX,NMSHMAX,NSPINMAX),PCEL(3,NMSHMAX)
	LOGICAL SYM(LMMAXV,NPAT)
	CHARACTER TXTEL(NSORTMAX)*10
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT!!! from init
	COMMON /POTCOM/ SWZ,SMT                             !!! from init
	COMMON /INTMESH/NSHE,NPOL,SROU,RINT                 !!! from init
	COMMON /SYMMLM/ SYM,LMSYM,NSYM                      !!! from symmlm
	COMMON /SPIN/   NSPIN                               !!! from init
	COMMON /UNIT/   IUN                                 !!! from init
	COMMON /TXTEL/  TXTEL                               !!! from init
	DATA PI/3.141592653589793D0/
	SQPI4=2.D0*SQRT(PI)
	ISORT=IS(IATOM)
	DO 1000 IMSH=1,NMSH                 !!! over surface mesh
	XCOORD=PCEL(1,IMSH)
	YCOORD=PCEL(2,IMSH)
	ZCOORD=PCEL(3,IMSH)
	CALL SPHHARM(XCOORD,YCOORD,ZCOORD,ILSV(ISORT),YLM)
	DIM=(0.D0,-1.D0)
	DO 20 L=0,ILSV(ISORT)               !!! over l 
	DIM=DIM*(0.D0,1.D0) 
	DO 10 M=-L,L                        !!! over m 
	LM=L*(L+1)+M+1
	IF(SYM(LM,IATOM))YSM(LMSYM(LM,IATOM))=YLM(LM)*DIM
  10    CONTINUE                            !!! over m
  20    CONTINUE                            !!! over l
	DO 130 ISPIN=1,NSPIN                !!! over spins 
	DO 120 IRAD=0,NSHE(ISORT)+1         !!! over radial mesh
C  SET UP TOTAL DENSITY AT THE POINT "IRAD,IMSH"
	FTOT(ISPIN)=(0.D0,0.D0)
	DO 110 ISYM=1,NSYM(IATOM)           !!! over isym
	FTOT(ISPIN)=FTOT(ISPIN)+
     &  FINT(IRAD,ISYM,IATOM,ISPIN)*YSM(ISYM)
 110    CONTINUE                            !!! over isym
	FUNINT(IRAD,IMSH,ISPIN)=DREAL(FTOT(ISPIN))
 120    CONTINUE                            !!! over radial points
 130    CONTINUE                            !!! over spins 
1000    CONTINUE                            !!! over surface points
	END
