	SUBROUTINE ORBMAG
**********************************************************
*  Finds orbital contribution to magnetization,          *
**********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,IS(NPAT),NHSORT(NSORTMAX),LMSYM(LMMAXV,NPAT),LR(NSORTMAX)
     &   ,NKAP(NPANMAX),IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX)
     &   ,NRAD(NSORTMAX)
	DIMENSION ENY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,TNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,VSPH(0:NRADMAX,NSORTMAX,NSPINMAX),R(0:NRADMAX,NSORTMAX)
     &   ,FID(0:NRADMAX,0:LMAXT),FI(0:NRADMAX,0:LMAXT)
     &   ,FIP(0:NRADMAX,0:LMAXT),FIDP(0:NRADMAX,0:LMAXT)
     &   ,FIDDS(0:LMAXT),FIDDPS(0:LMAXT),DR(0:NRADMAX,NSORTMAX)
     &   ,C(0:LMAXV+1,LMMAXV1,LMMAXV1),GAM(0:LMAXT,NSORTMAX)
     &   ,H(NSORTMAX),SMT(NSORTMAX)
	COMPLEX*16 RO(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX),CGNT
     &   ,ATOSHH(LIMLMB,LIMLMB,NPAT),ATOSJJ(LIMLMT,LIMLMT,NPAT)
     &   ,ATOSHJ(LIMLMB,LIMLMT,NPAT),ATOSJH(LIMLMT,LIMLMB,NPAT)
     &   ,ROVALDS(3,NSYMMAX,NPAT,NSPINMAX),ORBMZ(0:NRADMAX)
     &   ,AAH(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,AAJ(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,BBH(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,BBJ(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,FIH(0:NRADMAX,0:LMAXT,NKAPMAX) ,WORK1(0:NRADMAX)
     &   ,FIHD(0:NRADMAX,0:LMAXT,NKAPMAX),WORK2(0:NRADMAX)
     &   ,FIJ(0:NRADMAX,0:LMAXT,NKAPMAX)
     &   ,FIJD(0:NRADMAX,0:LMAXT,NKAPMAX)
     &   ,FIHDD(0:LMAXT,NKAPMAX),FIJDD(0:LMAXT,NKAPMAX)
	LOGICAL SYM(LMMAXV,NPAT),LOG1,LOG
     &   ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
     &   ,LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX)
	CHARACTER*10 TXTEL(NSORTMAX)
C Controls:
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT !!! from readini
	COMMON /ORBS/   NORBS                                !!! from readini
	COMMON /SPIN/   NSPIN                                !!! from readini
	COMMON /RELATIV/LR                                   !!! from readini
C Inputs:
	COMMON /POTCOM/ SWZ,SMT,VSPH                         !!! from vfull
	COMMON /INPPAR/ TNY,ENY                              !!! from readini
	COMMON /LMTPAR/ GAM,AAH,BBH,AAJ,BBJ                  !!! from potpar
	COMMON /KAPPAR/ NPAN,NKAP                            !!! from readini
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS                !!! from readini
	COMMON /SYMMLM/ SYM,LMSYM                            !!! from symmlm
C Density:
	COMMON /DENS/   RO,ROVALDS                           !!! from rhoful
C Temporary:
	COMMON /STORE1/ ATOSHH,ATOSJH,ATOSHJ,ATOSJJ          !!! from ttrint
	COMMON /STORE2/ FI,FID,FIP,FIDP,FIH,FIHD,FIJ,FIJD    !!! tmp.storage
C Gaunts:
	COMMON /GAUNT/  C                                    !!! from gaunt
C Rad.mesh:
	COMMON /RADMESH/NRAD,H,R,DR                          !!! from radmsh    
C Outputs:
	COMMON /UNIT/   IUN                                  !!! from readini
	COMMON /TXTEL/  TXTEL                                !!! from readini
	DATA PI/3.141592653589793D0/
	IF(NORBS.NE.2)RETURN
	SQPI4=2.D0*SQRT(PI)
	WRITE(IUN,1010)
1010	FORMAT(1X,'     Orbital magnetization:    ')
C  DO GLOBALLY OVER ATOMS AND PANELS
	DO 3000 IATOM=1,NATOM                  !!! over atoms
	ISORT=IS(IATOM)
	DO IRAD=0,NRAD(ISORT)
	ORBMZ(IRAD)=(0.D0,0.D0)
	ENDDO
	DO 2000 ISPIN=1,NSPIN                  !!! over spins
	DO 1000 IPAN=1,NPAN                    !!! over panels
	NSHIFT1=0
	NSHIFT2=0
	DO JPAN=1,NPAN
	IF(JPAN.LT.IPAN)NSHIFT1=NSHIFT1+NKAP(JPAN)**2
	NSHIFT2=NSHIFT2+NKAP(JPAN)**2
	ENDDO
	DO IKAP=1,NKAP(IPAN)                   !!! over energies
        CALL DFIFID(ENY(0,ISORT,IKAP,IPAN,ISPIN),FI,FIP,FID,FIDP,
     &  FIDDS,FIDDPS,SMT(ISORT),VSPH(0,ISORT,ISPIN),ILST(ISORT),
     &  NRAD(ISORT),H(ISORT),R(0,ISORT),DR(0,ISORT),LR(ISORT))
	DO L=0,ILST(ISORT)
	DO IRAD=0,NRAD(ISORT)
	FIH(IRAD,L,IKAP)=AAH(L,ISORT,IKAP,IPAN,ISPIN)*FI(IRAD,L)+
     &  BBH(L,ISORT,IKAP,IPAN,ISPIN)*FIP(IRAD,L)
	FIJ(IRAD,L,IKAP)=AAJ(L,ISORT,IKAP,IPAN,ISPIN)*FI(IRAD,L)+
     &  BBJ(L,ISORT,IKAP,IPAN,ISPIN)*FIP(IRAD,L)
	FIHD(IRAD,L,IKAP)=AAH(L,ISORT,IKAP,IPAN,ISPIN)*FID(IRAD,L)+
     &  BBH(L,ISORT,IKAP,IPAN,ISPIN)*FIDP(IRAD,L)
	FIJD(IRAD,L,IKAP)=AAJ(L,ISORT,IKAP,IPAN,ISPIN)*FID(IRAD,L)+
     &  BBJ(L,ISORT,IKAP,IPAN,ISPIN)*FIDP(IRAD,L)
	ENDDO
	FIHDD(L,IKAP)=AAH(L,ISORT,IKAP,IPAN,ISPIN)*FIDDS(L)+
     &  BBH(L,ISORT,IKAP,IPAN,ISPIN)*FIDDPS(L)
	FIJDD(L,IKAP)=AAJ(L,ISORT,IKAP,IPAN,ISPIN)*FIDDS(L)+
     &  BBJ(L,ISORT,IKAP,IPAN,ISPIN)*FIDDPS(L)
	ENDDO
	ENDDO
	DO IKAP1=1,NKAP(IPAN)                  !!! over energies
	DO IKAP=1,NKAP(IPAN)                   !!! over energies
	IREC=IKAP1+NKAP(IPAN)*(IKAP-1)+NKAP(IPAN)**2*(IATOM-1)+
     &  NSHIFT1*NATOM+NSHIFT2*NATOM*(ISPIN-1)
	READ(21,REC=IREC)((ATOSHH(L1M1,LM,IATOM),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((ATOSJH(L1M1,LM,IATOM),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((ATOSHJ(L1M1,LM,IATOM),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &  ((ATOSJJ(L1M1,LM,IATOM),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
	DO L=0,ILST(ISORT)                     !!! over l
	LOG1=.FALSE.
	IF(LTPAN(L,IATOM,IKAP1,IPAN))LOG1=.TRUE.
	LOG=.FALSE.
	IF(LTPAN(L,IATOM,IKAP ,IPAN))LOG =.TRUE.
	DO M=-L,L                              !!! over m
	LM=L*(L+1)+M+1
	DO IRAD=0,NRAD(ISORT)                  !!! over radial mesh
	IF(LOG1.AND.LOG)
     &  ORBMZ(IRAD)=ORBMZ(IRAD)+ATOSHH(LM,LM,IATOM)*
     &  CONJG(FIH(IRAD,L,IKAP1))*FIH(IRAD,L,IKAP)*
     &  DBLE(M)/SQPI4
	IF(LOG1)
     &  ORBMZ(IRAD)=ORBMZ(IRAD)-ATOSHJ(LM,LM,IATOM)*
     &  CONJG(FIH(IRAD,L,IKAP1))*FIJ(IRAD,L,IKAP)*
     &  DBLE(M)/SQPI4*GAM(L,ISORT)
	IF(LOG)
     &  ORBMZ(IRAD)=ORBMZ(IRAD)-ATOSJH(LM,LM,IATOM)*
     &  CONJG(FIJ(IRAD,L,IKAP1))*FIH(IRAD,L,IKAP)*
     &  DBLE(M)/SQPI4*GAM(L,ISORT)
	ORBMZ(IRAD)=ORBMZ(IRAD)+ATOSJJ(LM,LM,IATOM)*
     &  CONJG(FIJ(IRAD,L,IKAP1))*FIJ(IRAD,L,IKAP)*
     &  DBLE(M)/SQPI4*GAM(L,ISORT)*GAM(L,ISORT)
        ENDDO                                  !!! over radial mesh
        ENDDO                                  !!! over m
        ENDDO                                  !!! over l
        ENDDO                                  !!! over energies
        ENDDO                                  !!! over energies
1000	CONTINUE                               !!! over panels
2000	CONTINUE                               !!! over spins
C  FIND ORBITAL MOMENT 
	DO IRAD=0,NRAD(ISORT)
	WORK1(IRAD)=ORBMZ(IRAD)*SQPI4*R(IRAD,ISORT)**2*
     &  DR(IRAD,ISORT)
	ENDDO
        CALL CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	WRITE(IUN,1020)WORK2(NRAD(ISORT)),TXTEL(ISORT)
1020	FORMAT(1X,'(',G14.7,',',G14.7,') ',A10)
C  ADD ORBITAL MAGNETIZATION TO THE VALENCE DENSITY
C	DO IRAD=0,NRAD(ISORT)
C	RO(IRAD,1,IATOM,1)=RO(IRAD,1,IATOM,1)+
C    &  0.5D0*ORBMZ(IRAD)
C	RO(IRAD,1,IATOM,NSPIN)=RO(IRAD,1,IATOM,NSPIN)-
C    &  0.5D0*ORBMZ(IRAD)
C	ENDDO
C	ROVALDS(1,1,IATOM,1)=ROVALDS(1,1,IATOM,1)+
C    &  0.5D0*ORBMZ(IRAD)
C	ROVALDS(1,1,IATOM,NSPIN)=ROVALDS(1,1,IATOM,NSPIN)-
C    &  0.5D0*ORBMZ(IRAD)
3000    CONTINUE                               !!! over all atoms in cell
	END
