	SUBROUTINE SPLACE(ITER)
********************************************************************
* Place Eny at the centers of gravity of the occupied parts of the * 
* bands.                                                           *
********************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,NHSORT(NSORTMAX),IS(NPAT),NRAD(NSORTMAX),NKAP(NPANMAX)
     &   ,NODES(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX),LR(NSORTMAX)
     &   ,IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX)
     &   ,MNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX)
     &   ,LNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX)
     &   ,NCLS(0:LMAXT,NSORTMAX,NPANMAX)
	DIMENSION DNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,ENY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,TNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,DHLOG(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,R(0:NRADMAX,NSORTMAX),DR(0:NRADMAX,NSORTMAX)
     &   ,VSPH(0:NRADMAX,NSORTMAX,NSPINMAX),H(NSORTMAX)
     &   ,DNYOLD(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,SMT(NSORTMAX)
	COMPLEX*16
     &    ATOS(0:LMAXT,NSORTMAX,NKAPMAX,NKAPMAX,NPANMAX,NSPINMAX,0:5)
     &   ,ADOS(0:LMAXT,NSORTMAX,NKAPMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,PTOS(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX,0:2)
     &   ,PFOS(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX,0:2)
     &   ,PDOS(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX,0:2)
	LOGICAL LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX)
     &   ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
	CHARACTER TXTEL(NSORTMAX)*10
C Controls:
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM        !!! from readini
	COMMON /RELATIV/LR                                   !!! from readini
	COMMON /SPIN/   NSPIN                                !!! from readini
        COMMON /RWFCOM/ NRWF,LRWF,IRWF                       !!! from setup
C Inputs:
	COMMON /INPPAR/ TNY,ENY,DNY,NODES,MNY,DHLOG,NCLS,LNY !!! from splace
	COMMON /POTCOM/ SWZ,SMT,VSPH                         !!! from vfull
	COMMON /KAPPAR/ NPAN,NKAP                            !!! from readini
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS                !!! from readini
	COMMON /MIXRHO1/ADMIX1,ADMIN,ADMAX,KEY,ADMOPT        !!! from mixro1
	COMMON /MIXMAG1/ADMSPN,ASMIN,ASMAX,KSP,ADSPIN        !!! from mixro1
C Tos.pars:
	COMMON /TOSDOS/ ATOS,ADOS,PTOS,PFOS,PDOS             !!! from ttrint2
C Rad.mesh:
	COMMON /RADMESH/NRAD,H,R,DR                          !!! from radmesh
C Fermi energy:
	COMMON /EFERMI/ EF                                   !!! from ttrint1
C Outputs:
	COMMON /UNIT/   IUN                                  !!! from readini
	COMMON /TXTEL/  TXTEL                                !!! from readini
	SAVE DNYOLD
	DATA PI/3.141592653589793D0/
C  FIND ENY FROM THE CENTER-OF-GRAVITY SCHEME
	IF(NSPIN.EQ.1)ADMIX=ADMOPT
	IF(NSPIN.EQ.2)ADMIX=MAX(ADMOPT,ADSPIN)
	DO IPAN=1,NPAN                                   !!! over panels
	DO ISORT=1,NSORT                                 !!! over sorts
	DO IKAP=1,NKAP(IPAN)                             !!! over energies
	DO L=0,ILSB(ISORT)                               !!! over l
	IF(MNY(L,ISORT,IKAP,IPAN).EQ.3)THEN
C  CALCULATE CENTERS OF GRAVITY
	DO ISPIN=1,NSPIN                                 !!! over spins
	IF(ITER.EQ.0)GOTO300
	IF(LRWF.EQ.0)GOTO300
	ICLS=LNY(L,ISORT,IKAP,IPAN)
C  Spin averaged
	IF(LRWF.EQ.1)THEN
	TOS1=DREAL(PFOS(L,ISORT,ICLS,IPAN,1    ,1))*0.5D0+
     &       DREAL(PFOS(L,ISORT,ICLS,IPAN,NSPIN,1))*0.5D0
	TOS0=DREAL(PTOS(L,ISORT,ICLS,IPAN,1    ,1))*0.5D0+
     &       DREAL(PTOS(L,ISORT,ICLS,IPAN,NSPIN,1))*0.5D0
C  Spin dependent
	ELSEIF(LRWF.EQ.2)THEN
	TOS1=DREAL(PFOS(L,ISORT,ICLS,IPAN,ISPIN,1))
	TOS0=DREAL(PTOS(L,ISORT,ICLS,IPAN,ISPIN,1))
	ENDIF
	IF(ABS(TOS0).LE.1.D-10)
     &  STOP'<PLACE>: INTERNAL ERROR: PARTIAL TOS=0'
C  SET ENY INTO CENTER OF GRAVITY
        ENYCEN=TOS1/TOS0
        CALL CT(ENYCEN,TNYCEN,DTNYDE,L+1,SMT(ISORT),
     &  VSPH(0,ISORT,ISPIN),NRAD(ISORT),H(ISORT),R(0,ISORT),
     &  DR(0,ISORT),LR(ISORT))
        NODCEN=TNYCEN
        IF(NODCEN.EQ.NODES(L,ISORT,IKAP,IPAN))GOTO100
C  NODES MISMATCH, TRY ENY=EF
        ENYCEN=EF
        CALL CT(ENYCEN,TNYCEN,DTNYDE,L+1,SMT(ISORT),
     &  VSPH(0,ISORT,ISPIN),NRAD(ISORT),H(ISORT),R(0,ISORT),
     &  DR(0,ISORT),LR(ISORT))
        NODCEN=TNYCEN
        IF(NODCEN.EQ.NODES(L,ISORT,IKAP,IPAN))GOTO100
C  NODES MISMATCH, SET DNY=L AND DO NOT WORRY
	DNYCEN=DBLE(L)-0.05D0
	GOTO200
 100    DNYCEN=TAN(PI*(0.5D0+NODCEN-TNYCEN))
	IF(DNYCEN.GT.DBLE(L))DNYCEN=DBLE(L)-0.05D0
 200    DNY(L,ISORT,IKAP,IPAN,ISPIN)=
     &  DNYOLD(L,ISORT,IKAP,IPAN,ISPIN)*(1.D0-ADMIX)+DNYCEN*ADMIX
 300    DNYOLD(L,ISORT,IKAP,IPAN,ISPIN)=DNY(L,ISORT,IKAP,IPAN,ISPIN)
        ENDDO                                              !!! over spins
	ENDIF
        ENDDO                                              !!! over l
        ENDDO                                              !!! over energies
        ENDDO                                              !!! over sorts
        ENDDO                                              !!! over panels
	END
