	SUBROUTINE POLIX7(NODER,NP0,POLIST,NTR,LISTTR,ALF,BET,
     &  L,TINT,NGR,IDIV0,NMSH)
**************************************************************
*  Program for integration over polihedron by means of the   *
*  seventh order quadrature formula (see Abramovich, Stegun) *
*  A function is supposed to be product of the spherical     *
*  harmonic Ylm(<r>) to power (r**n).                        *
*  Written by D.Yu.Savrasov (P.N.Lebedev PhysicaL Institute) *
**************************************************************
	INCLUDE 'PARAM.DAT'
	PARAMETER (LPLMAX=(2*LMAXV+1)**2)
	PARAMETER (NTRMAX=NENVMAX)
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER LISTTR(3,NTRMAX,NENVMAX),NTR(NENVMAX)
	DIMENSION POLIST(3,NVCMAX),X(3),X1(3),X2(3)
	COMPLEX*16 YLM(LPLMAX),TINT(0:NPOLMAX,LPLMAX)
     &    ,S(0:NPOLMAX,0:2*LMAXV,0:2*LMAXV)
     &    ,S1(0:NPOLMAX,0:2*LMAXV,0:2*LMAXV)
     &    ,WT(7),XW(3,7),XC(2,7)
	COMMON/DENS/   S,S1
	SAVE LAGF,WT,XC,Q15,QPI
	DATA lagf/1/,idivmax/50/,pi/3.141592653589793d0/
	FF(XX,N)=(ALF**2*XX**(N+1)/(N+1)-2.D0*ALF*BET*XX**(N+2)/(N+2)+
     &            BET**2*XX**(N+3)/(N+3))*BET
	if (lagf.eq.1) then
	lagf=0
	q15=dsqrt(15.d0)
	qpi=dsqrt(pi)
	wt(1)=9.d0/40.d0
	wt(2)=(155.d0-q15)/1200.d0
	wt(3)=wt(2)
	wt(4)=wt(2)
	wt(5)=(155.d0+q15)/1200.d0
	wt(6)=wt(5)
	wt(7)=wt(5)
	xc(1,1)=1.d0/3.d0
	xc(2,1)=1.d0/3.d0
	xc(1,2)=(6.d0-q15)/21.d0
	xc(2,2)=(9.d0+2.d0*q15)/21.d0
	xc(1,3)=(9.d0+2.d0*q15)/21.d0
	xc(2,3)=(6.d0-q15)/21.d0
	xc(1,4)=(6.d0-q15)/21.d0
	xc(2,4)=(6.d0-q15)/21.d0
	xc(1,5)=(6.d0+q15)/21.d0
	xc(2,5)=(9.d0-2.d0*q15)/21.d0
	xc(1,6)=(6.d0+q15)/21.d0
	xc(2,6)=(6.d0+q15)/21.d0
	xc(1,7)=(9.d0-2.d0*q15)/21.d0
	xc(2,7)=(6.d0+q15)/21.d0
	endif
C ------------ MAIN SUMMATION -----------
C START UP:
		
	do 30 i=0,noder
	do 20 lc=0,l
	do 10 mc=0,lc
	s1(i,lc,mc)=(0.d0,0.d0)
  10    continue
  20    continue
  30    continue
	imsh=0
	 DO 300 I=1,NGR         ! over planes
		n1=listtr(1,1,i)
		n2=listtr(2,1,i)
		n3=listtr(3,1,i)
		do 40 k=1,3
		x1(k)=polist(k,n2)-polist(k,n1)
		x2(k)=polist(k,n3)-polist(k,n1)
  40            continue
	x(1)=x1(2)*x2(3)-x1(3)*x2(2)
	x(2)=x1(3)*x2(1)-x1(1)*x2(3)
	x(3)=x1(1)*x2(2)-x1(2)*x2(1)
	sstr=SQRT(x(1)**2+x(2)**2+x(3)**2)
	xarc=(x(1)*polist(1,n1)+x(2)*polist(2,n1)+x(3)*polist(3,n1))/
     &  sstr
		DO 290 J=1,NTR(I)       ! over triangles in plane
		do 70 i1=0,noder
		do 60 lc=0,l
		do 50 mc=0,lc
		s(i1,lc,mc)=(0.d0,0.d0)
  50            continue
  60            continue
  70            continue
		n1=listtr(1,j,i)
		n2=listtr(2,j,i)
		n3=listtr(3,j,i)
		do 80 k=1,3
		x1(k)=polist(k,n2)-polist(k,n1)
		x2(k)=polist(k,n3)-polist(k,n1)
  80            continue
	x(1)=x1(2)*x2(3)-x1(3)*x2(2)
	x(2)=x1(3)*x2(1)-x1(1)*x2(3)
	x(3)=x1(1)*x2(2)-x1(2)*x2(1)
	sstr=SQRT(x(1)**2+x(2)**2+x(3)**2)
	rcm=((polist(1,n1)+polist(1,n2)+polist(1,n3))**2+
     &      (polist(2,n1)+polist(2,n2)+polist(2,n3))**2+
     &      (polist(3,n1)+polist(3,n2)+polist(3,n3))**2)/9.d0
	idiv=idiv0*sqrt(sstr/rcm)/2.d0/qpi+1
	idiv=min(idivmax,idiv)
	do 90 k=1,3
	x1(k)=(polist(k,n2)-polist(k,n1))/DBLE(idiv)
	x2(k)=(polist(k,n3)-polist(k,n1))/DBLE(idiv)
  90    continue
		do 110 i1=1,7
		do 100 j1=1,3
		xw(j1,i1)=x1(j1)*xc(1,i1)+x2(j1)*xc(2,i1)
 100            continue
 110            continue
C  FOR DIRECT TRIANGLES:
		do 180 i1=0,idiv-1
		do 170 i2=0,idiv-1-i1
		do 160 i3=1,7
		do 120 k=1,3
		x(k)=DBLE(i1)*x1(k)+DBLE(i2)*x2(k)+polist(k,n1)+xw(k,i3)
 120            continue
		imsh=imsh+1
		r0=dsqrt(x(1)*x(1)+x(2)*x(2)+x(3)*x(3))
		r1=(alf-r0)/bet
		r2=1.d0
	CALL SPHHARM(x(1)/r0,x(2)/r0,x(3)/r0,L,YLM)
		do 150 k1=0,noder
		rr=(ff(r2,k1)-ff(r1,k1))/r0**3
		do 140 lc=0,l
		do 130 mc=0,lc
		lmc=lc*(lc+1)+1+mc
		s(k1,lc,mc)=rr*ylm(lmc)*wt(i3)+s(k1,lc,mc)
 130            continue
 140            continue
 150            continue
 160            continue
 170            continue
 180            continue
C  FOR REVERSE TRIANGLES:
		do 250 i1=1,idiv-1
		do 240 i2=1,idiv-i1
		do 230 i3=1,7
		do 190 k=1,3
		x(k)=DBLE(i1)*x1(k)+DBLE(i2)*x2(k)+polist(k,n1)-xw(k,i3)
 190            continue
		imsh=imsh+1
		r0=dsqrt(x(1)*x(1)+x(2)*x(2)+x(3)*x(3))
		r1=(alf-r0)/bet
		r2=1.d0
	CALL SPHHARM(x(1)/r0,x(2)/r0,x(3)/r0,L,YLM)
		do 220 k1=0,noder
		rr=(ff(r2,k1)-ff(r1,k1))/r0**3
		do 210 lc=0,l
		do 200 mc=0,lc
		lmc=lc*(lc+1)+1+mc
		s(k1,lc,mc)=rr*ylm(lmc)*wt(i3)+s(k1,lc,mc)
 200            continue
 210            continue
 220            continue
 230            continue
 240            continue
 250            continue
C NORMALIZATION:
		do 280 i1=0,noder
		do 270 lc=0,l
		do 260 mc=0,lc
		s1(i1,lc,mc)=s1(i1,lc,mc)+xarc*s(i1,lc,mc)*
     &          sstr/2.d0/idiv/idiv
 260            continue
 270            continue
 280            continue
 290            continue        ! over triangLes in plane
 300    continue                ! over planes
	do 330 i=0,noder
	do 320 lc=0,l
	do 310 mc=0,lc
	lmc=lc*(lc+1)+1+mc
	TINT(I,LMC)=s1(i,lc,mc)
	lmc=lc*(lc+1)+1-mc
	TINT(I,LMC)=conjg(s1(i,lc,mc))*(-1)**mc
 310    continue
 320    continue
 330    continue
	nmsh=imsh
	RETURN
	END

