	SUBROUTINE READHOP
*******************************************************
*  Prepares hopping matrix from the knowledge of the  *
*  hopping integrals read from HOPFILE.               *
*  Also sets overlap matrix if required.              *
*******************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
        INCLUDE 'PARAM.DAT'
	PARAMETER (NLIMMAX=LIMLMB*LIMLMB*NPAT*NENVMAX)
        INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX)
     &    ,ILSV(NSORTMAX),NENV(NPAT),ISENV(0:NENVMAX,NPAT)
     &    ,IKOV(NOPRMAX),IPENV(0:NENVMAX,NPAT,NOPRMAX)
     &    ,IRENV(0:NENVMAX,NPAT),INBAS(LIMLMB,NPAT)
     &    ,NODES(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX)
     &    ,NHSORT(NSORTMAX),IP(NPAT,NOPRMAX)
	DIMENSION TENV(3,0:NENVMAX,NPAT),RDC(3,NPAT,NOPRMAX)
     &    ,SHIFT(3,NOPRMAX),TAU(3,NPAT),ORTH(2:3),RENV(3) 
     &    ,ENY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &    ,DNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &    ,TNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &    ,RLOC(NSORTMAX)
	COMPLEX*16 TC(-3:3,7,0:3),TS(7,-3:3,0:3)
     &    ,TMAT(LIMLMB,LIMLMB,NPAT,0:NENVMAX,NSPINMAX)
     &    ,PMAT(LIMLMB,LIMLMB,NPAT,0:NENVMAX,NSPINMAX)
     &    ,SMAT(LIMLMB,LIMLMB,NPAT,0:NENVMAX,NSPINMAX)
     &    ,THOP(-LMAXB:LMAXB,-LMAXB:LMAXB),U(NWIGMAX,48)
     &    ,SHOP(-LMAXB:LMAXB,-LMAXB:LMAXB),CVAL(2)
        LOGICAL LTBAS(0:LMAXB,NPAT),LSBAS(0:LMAXB,NSORTMAX)
     &    ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX),EXIST
     &    ,LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX)
        CHARACTER*60 HUBFILE,HOPFILE,OPTFILE
	CHARACTER SCHM*10,RYEV*10,CUBC*10,REIM*10,HOPI*10,OVWR*10
     &    ,HINF(NLIMMAX)*60,HIND(NLIMMAX)*60,TXTH*120
     &    ,TXTEL(NSORTMAX)*10,TXTSP(2)*2,TL(0:3)*1,TEXT*60
C Controls:
        COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT !!! from readini
	COMMON /SPIN/   NSPIN                                !!! from readini
C Inputs:
        COMMON /INPPAR/ TNY,ENY,DNY,NODES                    !!! from readini
	COMMON /LATPAR/ PAR,ORTH,OMEGAC                      !!! from readini
        COMMON /PANPAR/ LTPAN,LSPAN                          !!! from readini
        COMMON /BASIS/  TAU                                  !!! from readstr
C TB-data:
	COMMON /TBBPAR/ LTBAS,LSBAS,INBAS,NTBAS              !!! from readini
	COMMON /SCRINP/ RLOC                                 !!! from readini
        COMMON /ENVSITE/NENV,TENV,ISENV,IPENV,IRENV          !!! from envmesh
        COMMON /HOPDAT/ NINF,NHOP,ISCHM,ICUBC,IRE,IWR,IHO    !!! from readhop
	COMMON /HOPTXT/ HINF,HIND                            !!! from readhop
C Hopping integrals:
	COMMON /HOPCOM/ TMAT,SMAT,PMAT                       !!! from hopmat
C Point group:
        COMMON /INVERS/ INV,IKOV                             !!! from groups
        COMMON /GROUPOUT/NGROUP,U,IP,RDC,SHIFT               !!! from groups
C Additional inputs:
        COMMON /INP1/   ICHUB,ICHOP,ICOPT                    !!! from readini
        COMMON /INP2/   HUBFILE,HOPFILE,OPTFILE              !!! from readini
C Outputs:
        COMMON /TXTEL/  TXTEL,TXTSP                          !!! from readini
	COMMON /UNIT/   IUN                                  !!! from readini
        DATA PI/3.141592653589793D0/,TL/'s','p','d','f'/
	IF(ICHOP.EQ.0)RETURN
C  CHECK EXISTENCE
        INQUIRE(FILE=HOPFILE,EXIST=EXIST)
        IF(.NOT.EXIST)STOP'<READHOP>: HOPFILE MUST EXIST!>'
C  SET HOPPING MATRIX TO ZERO
	DO ISPIN=1,NSPIN
	DO IATOM1=1,NATOM
	ISORT1=IS(IATOM1)
	DO IENV=0,NENV(IATOM1)
	IATOM=ISENV(IENV,IATOM1)
	ISORT=IS(IATOM)
	DO L1=0,ILSB(ISORT1)
	DO M1=-L1,L1
	L1M1=L1*(L1+1)+M1+1
	DO L=0,ILSB(ISORT)
	DO M=-L,L
	LM=L*(L+1)+M+1
	TMAT(L1M1,LM,IATOM1,IENV,ISPIN)=(0.D0,0.D0)
	PMAT(L1M1,LM,IATOM1,IENV,ISPIN)=(0.D0,0.D0)
	SMAT(L1M1,LM,IATOM1,IENV,ISPIN)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C  READ DATA FROM HOPFILE
        OPEN(UNIT=1,FILE=HOPFILE,STATUS='OLD',FORM='FORMATTED')
        READ(1,1010)TEXT
        READ(1,1010)TEXT
C  **** GENERAL SETTINGS ****
C  SCHM='        ' - yet not defined
C  RYEV='Ry' or 'eV' - input/output units
C  CUBC='Cubic' or 'Spherical' harmonics
C  REIM='Real' or 'Complex' - input/output
C  HOPI='Y' or 'N' hopping integrals avaiable
C  OVWR='Overwrite' or 'Append' hopping matrices in the HOPFILE
        READ(1,1010)TEXT
        READ(1,*)SCHM
        READ(1,*)RYEV
        READ(1,*)CUBC
        READ(1,*)REIM
        READ(1,*)HOPI
        READ(1,*)OVWR
C  Transform to integer keys
        CALL CONVLOW(SCHM,10)
        CALL RMBLANK(SCHM,10)
        NB=INDEX(SCHM,' ')
        ISCHM=0 
        CALL CONVLOW(RYEV,10)
        CALL RMBLANK(RYEV,10)
        NB=INDEX(RYEV,' ')
        IF(RYEV(:NB-1).EQ.'ry')RY=1.D0
        IF(RYEV(:NB-1).EQ.'ev')RY=1.D0/13.608D0
        IF(RYEV(:NB-1).NE.'ev'.AND.RYEV(:NB-1).NE.'ry')
     &  STOP'<READHOP>: SET RY OR EV'
        CALL CONVLOW(CUBC,10)
        CALL RMBLANK(CUBC,10)
        NB=INDEX(CUBC,' ')
        ICUBC=0
        IF(CUBC(:NB-1).EQ.'cubic')ICUBC=1
        IF(CUBC(:NB-1).EQ.'spherical')ICUBC=2
        IF(ICUBC.EQ.0)STOP'<READHOP>: SET CUBIC OR SPHERICAL'
        CALL CONVLOW(REIM,10)
        CALL RMBLANK(REIM,10)
        NB=INDEX(REIM,' ')
        IRE=0
        IF(REIM(:NB-1).EQ.'real')IRE=1
        IF(REIM(:NB-1).EQ.'complex')IRE=2
        IF(IRE.EQ.0)STOP'<READHOP>: SET REAL OR COMPLEX'
        CALL CONVLOW(HOPI,10)
        CALL RMBLANK(HOPI,10)
        NB=INDEX(HOPI,' ')
        IHO=0
        IF(HOPI(:NB-1).EQ.'yes')IHO=1
        IF(HOPI(:NB-1).EQ.'no' )IHO=2
        IF(IHO.EQ.0)STOP'<READHUB>: SET YES OR NO TO READ HOPPING'
        CALL CONVLOW(OVWR,10)
        CALL RMBLANK(OVWR,10)
        NB=INDEX(OVWR,' ')
        IWR=0
        IF(OVWR(:NB-1).EQ.'overwrite')IWR=1
        IF(OVWR(:NB-1).EQ.'append'   )IWR=2
        IF(IWR.EQ.0)STOP'<READHUB>: SET OVERWRITE OR APPEND'
C  **** HOPPING INTEGRALS ****
	IF(IHO.EQ.1)THEN
C  HOPPING INTEGRALS ARE DEFINED FROM A PARTICULAR ORBITAL
C  TO ANOTHER ORBITAL VIA A VECTOR SEPARATING TWO SITES.
C  THE OVERLAP INTEGRAL BETWEEN TWO SITES MUST ALSO BE 
C  GIVEN. 
        READ(1,1010)TEXT
	DO ISPIN=1,NSPIN                !!! over spins
        READ(1,*)NINF
	IF(NINF.GT.NLIMMAX)STOP'<READHOP> NINF OUT OF BOUNDS'
        DO INF=1,NINF
        READ(1,1010)TXTH
        CALL REDORB(TXTH,120,ICUBC,IRE,2,CVAL(1),
     &  IATOM1,NM1,L1,M1,IATOM,NM,L,M,IENV,IENV1)
	L1M1=L1*(L1+1)+M1+1
	LM=L*(L+1)+M+1
C  Set matrix elements:
	TMAT(L1M1,LM,IATOM1,IENV,ISPIN)=CVAL(1)
	SMAT(L1M1,LM,IATOM1,IENV,ISPIN)=CVAL(2)
	IATOM=ISENV(IENV,IATOM1)
C  Set complex conjugates:
	TMAT(LM,L1M1,IATOM,IENV1,ISPIN)=DCONJG(CVAL(1))
	SMAT(LM,L1M1,IATOM,IENV1,ISPIN)=DCONJG(CVAL(2))
	WRITE(HINF(INF),1020)IATOM1,NM1,L1,M1,IATOM,NM,
     &  L,M,IENV,IENV1
	ENDDO
	ENDDO                              !!! over spins
	ELSEIF(IHO.EQ.2)THEN
C  NO HOPPING INTEGRALS AVAIABLE
	INF=0
	DO IATOM1=1,NATOM
	ISORT1=IS(IATOM1)
	DO IENV=0,NENV(IATOM1)
	IATOM=ISENV(IENV,IATOM1)
	ISORT=IS(IATOM)
        IF(IRENV(IENV,IATOM1).EQ.1)THEN
C  Set complex conjugate:
        DO IE=0,NENV(IATOM)
        DIFF=(TENV(1,IENV,IATOM1)+TENV(1,IE,IATOM))**2
     &      +(TENV(2,IENV,IATOM1)+TENV(2,IE,IATOM))**2
     &      +(TENV(3,IENV,IATOM1)+TENV(3,IE,IATOM))**2
        IF(DIFF.LE.1.D-10)EXIT
        ENDDO
        IF(IE.EQ.NENV(IATOM)+1)STOP'<READHOP> WRONG CONJUGATION'
        IENV1=IE
C  Set orbitals:
	DO L1=0,ILSB(ISORT1)
	NM1=NODES(L1,ISORT1,1,1)+L1+1
	IF(LTPAN(L1,IATOM1,1,1))THEN
	DO L=0,ILSB(ISORT)
	NM=NODES(L,ISORT,1,1)+L+1
	IF(LTPAN(L,IATOM,1,1))THEN
	DO M1=-L1,L1
	L1M1=L1*(L1+1)+M1+1
	DO M=-L,L
	LM=L*(L+1)+M+1
	DO ISPIN=1,NSPIN
	TMAT(L1M1,LM,IATOM1,IENV,ISPIN)=(0.D0,0.D0)
	SMAT(L1M1,LM,IATOM1,IENV,ISPIN)=(0.D0,0.D0)
	IF(L1M1.EQ.LM.AND.IATOM1.EQ.IATOM.AND.IENV.EQ.0)
     &	SMAT(L1M1,LM,IATOM1,IENV,ISPIN)=(1.D0,0.D0)
	ENDDO
	INF=INF+1
	IF(INF.GT.NLIMMAX)STOP'<READHOP> NINF OUT OF BOUNDS'
	WRITE(HINF(INF),1020)IATOM1,NM1,L1,M1,IATOM,NM,
     &  L,M,IENV,IENV1
	ENDDO
	ENDDO
	ENDIF
	ENDDO
	ENDIF
	ENDDO
	ENDIF
	ENDDO
	ENDDO
	NINF=INF
	ENDIF
	CLOSE(1)
C  ALL INFORMATION READ, SET UP INDEXES
	IHOP=0
	DO IATOM1=1,NATOM
	ISORT1=IS(IATOM1)
	DO IENV=0,NENV(IATOM1)
	IATOM=ISENV(IENV,IATOM1)
	ISORT=IS(IATOM)
	DO L1=0,ILSB(ISORT1)
	DO L=0,ILSB(ISORT)
	IN=0
	DO INF=1,NINF
	READ(HINF(INF),*)IATOM1R,NM1R,L1R,M1R,IATOMR,NMR,
     &  LR,MR,IENVR,IENV1R
	IF(IATOM1R.EQ.IATOM1.AND.IATOMR.EQ.IATOM.AND.
     &  L1R.EQ.L1.AND.LR.EQ.L.AND.IENVR.EQ.IENV)IN=IN+1
	IF(IATOM1R.EQ.IATOM.AND.IATOMR.EQ.IATOM1.AND.
     &  L1R.EQ.L.AND.LR.EQ.L1.AND.IENV1R.EQ.IENV)IN=IN+1
	ENDDO
	IF(IN.NE.0)IHOP=IHOP+1
	IF(IHOP.GT.NLIMMAX)STOP'<READHOP> NHOP OUT OF BOUNDS'
	IF(IN.NE.0)WRITE(HIND(IHOP),1020)L1,L,IATOM1,IENV
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	NHOP=IHOP
C  TRANSFERE TO COMPLEX HARMONICS IF NECESSARY
	IF(ICUBC.EQ.1)THEN
	CALL TRANSC(TC)   ! built transformation matrices
	DO ISPIN=1,NSPIN                       !!! over spins
	DO IHOP=1,NHOP                         !!! over hopping integrals
	READ(HIND(IHOP),*)L1,L,IATOM1,IENV
	ISORT1=IS(IATOM1)
	IATOM=ISENV(IENV,IATOM1)
	ISORT=IS(IATOM)
	DO M1=-L1,L1
	L1M1=L1*(L1+1)+M1+1
	DO M=-L,L
	LM=L*(L+1)+M+1
	THOP(M1,M)=(0.D0,0.D0)
	SHOP(M1,M)=(0.D0,0.D0)
	DO K1=-L1,L1
	L1K1=L1*(L1+1)+K1+1
	DO K=-L,L
	LK=L*(L+1)+K+1
	THOP(M1,M)=THOP(M1,M)+CONJG(TC(M1,K1+L1+1,L1))*
     &  TMAT(L1K1,LK,IATOM1,IENV,ISPIN)*TC(M,K+L+1,L)
	SHOP(M1,M)=SHOP(M1,M)+CONJG(TC(M1,K1+L1+1,L1))*
     &  SMAT(L1K1,LK,IATOM1,IENV,ISPIN)*TC(M,K+L+1,L)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	DO M1=-L1,L1
	L1M1=L1*(L1+1)+M1+1
	DO M=-L,L
	LM=L*(L+1)+M+1
	TMAT(L1M1,LM,IATOM1,IENV,ISPIN)=THOP(M1,M)
	SMAT(L1M1,LM,IATOM1,IENV,ISPIN)=SHOP(M1,M)
	ENDDO
	ENDDO
        ENDDO                                 !!! over hopping integrals
	ENDDO                                 !!! over spins
	ENDIF
C  GENERATE WHOLE HOPPING MATRIX BY APPLYING GROUP OPERATIONS
	ISTOP=0
	DO ISPIN=1,NSPIN                            !!! over spins
	DO IHOP=1,NHOP                              !!! over hopping integrals
	READ(HIND(IHOP),*)L1,L,IATOM1,IENV
	ISORT1=IS(IATOM1)
	IATOM=ISENV(IENV,IATOM1)
	ISORT=IS(IATOM)
        DO IR=1,NGROUP                              !!! over point group
        IG=IKOV(IR)
	IATOM1G=IP(IATOM1,IR)
	IENVG=IPENV(IENV,IATOM1,IR)
	IATOMG=ISENV(IENVG,IATOM1G)
	DO M1=-L1,L1
	L1M1=L1*(L1+1)+M1+1
	DO M=-L,L
	LM=L*(L+1)+M+1
	THOP(M1,M)=(0.D0,0.D0)
	SHOP(M1,M)=(0.D0,0.D0)
	DO M2=-L1,L1
        L1M2=L1*(L1+1)+M2+1
        IWIG21=L1*(2*L1-1)*(2*L1+1)/3+(2*L1+1)*(L1+M1)+L1+M2+1
	DO M3=-L,L
        LM3=L*(L+1)+M3+1
        IWIG30=L*(2*L-1)*(2*L+1)/3+(2*L+1)*(L+M)+L+M3+1
	THOP(M1,M)=THOP(M1,M)+CONJG(U(IWIG21,IG))*
     &  TMAT(L1M2,LM3,IATOM1,IENV,ISPIN)*U(IWIG30,IG)
	SHOP(M1,M)=SHOP(M1,M)+CONJG(U(IWIG21,IG))*
     &  SMAT(L1M2,LM3,IATOM1,IENV,ISPIN)*U(IWIG30,IG)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C  SET UP ROTATED MATRIX, CHECK IT WHETHER IT COINCIDES
C  WITH THE INPUT MATRIX
	DO M1=-L1,L1
	L1M1=L1*(L1+1)+M1+1
	DO M=-L,L
	LM=L*(L+1)+M+1
	IF(IHO.EQ.1)THEN
	DO INF=1,NINF
	READ(HINF(INF),*)IATOM1R,NM1R,L1R,M1R,IATOMR,NMR,
     &  LR,MR,IENVR,IENV1R
	IF(IATOM1R.EQ.IATOM1G.AND.L1R.EQ.L1.AND.M1R.EQ.M1.AND.
     &  IATOMR.EQ.IATOMG.AND.LR.EQ.L.AND.MR.EQ.M.
     &  AND.IENVR.EQ.IENVG)THEN
	DIFF=ABS(TMAT(L1M1,LM,IATOM1G,IENVG,ISPIN)-THOP(M1,M))
	IF(DIFF.GE.1.D-04)
     &  PRINT*,'<READHOP>: ROTATED TMATRIX MISMATCHES WITH INPUT:',
     &  THOP(M1,M),TMAT(L1M1,LM,IATOM1G,IENVG,ISPIN),
     &  L1M1,LM,IATOM1G,IENVG
	IF(DIFF.GE.1.D-04)ISTOP=1
	DIFF=ABS(SMAT(L1M1,LM,IATOM1G,IENVG,ISPIN)-SHOP(M1,M))
	IF(DIFF.GE.1.D-04)
     &  PRINT*,'<READHOP>: ROTATED SMATRIX MISMATCHES WITH INPUT:',
     &  SHOP(M1,M),SMAT(L1M1,LM,IATOM1G,IENVG,ISPIN),
     &  L1M1,LM,IATOM1G,IENVG
	IF(DIFF.GE.1.D-04)ISTOP=1
	ENDIF
	ENDDO
	ENDIF
	TMAT(L1M1,LM,IATOM1G,IENVG,ISPIN)=THOP(M1,M)
	SMAT(L1M1,LM,IATOM1G,IENVG,ISPIN)=SHOP(M1,M)
	ENDDO
	ENDDO
	ENDDO                                     !!! over point group
        ENDDO                                     !!! over hopping integrals
	ENDDO                                     !!! over spins
C	IF(ISTOP.EQ.1)PRINT*,'<READHOP>: ERROR IN INPUT'
C  SET UP TIGHT-BINDING BASIS SET
    	ISTOP=0
	IDIM=0
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	DO L=0,ILSB(ISORT)
	IN=0
	DO M=-L,L
	LM=L*(L+1)+M+1
	IF(ABS(SMAT(LM,LM,IATOM,0,1    )).GT.1.D-10.AND.
     &     ABS(SMAT(LM,LM,IATOM,0,NSPIN)).GT.1.D-10)IN=IN+1
	INBAS(LM,IATOM)=0
	ENDDO
	IF(IN.EQ.2*L+1)THEN
	LTBAS(L,IATOM)=.TRUE.
	LSBAS(L,ISORT)=.TRUE.
	DO M=-L,L
	LM=L*(L+1)+M+1
	IDIM=IDIM+1
	INBAS(LM,IATOM)=IDIM
	ENDDO
	ELSEIF(IN.EQ.0)THEN
	LTBAS(L,IATOM)=.FALSE.
	LSBAS(L,ISORT)=.FALSE.
	ELSE
	PRINT*,'<READHOP>: BASIS SET IS WRONG:'
	ISTOP=1
	DO M=-L,L
	LM=L*(L+1)+M+1
	PRINT*,SMAT(LM,LM,IATOM,0,1),LM,IATOM
     &	      ,SMAT(LM,LM,IATOM,0,NSPIN)
	ENDDO
	ENDIF
	ENDDO
	ENDDO
	NTBAS=IDIM
	IF(ISTOP.EQ.1)STOP'<READHOP>: ERROR IN BASIS'
C  PRINT TIGHT-BINDING BASIS SET
        NB=1
        DO ISORT=1,NSORT
        DO I=10,5,-1
        IF(TXTEL(ISORT)(I:I).NE.' ')EXIT
        ENDDO
        NB=MAX(NB,I)
        ENDDO
	WRITE(IUN,1030)NTBAS
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	DO L=0,ILSB(ISORT)
	IF(LTBAS(L,IATOM))WRITE(IUN,1040)TL(L),
     &  TXTEL(ISORT)(:NB),IATOM
	ENDDO
	ENDDO
1010    FORMAT(A)
1020	FORMAT(1X,10(I3,1X))
1030	FORMAT(1X,'Tight-binding basis set::   ,total # =',I3)
1040	FORMAT(1X,A1,'-electrons ',A,'#',I2)
	END



	SUBROUTINE WRITEHOP
*******************************************************
*  Writes hopping matrix back to the HOPFILE.         *
*******************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
        INCLUDE 'PARAM.DAT'
	PARAMETER (NLIMMAX=LIMLMB*LIMLMB*NPAT*NENVMAX)
        INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX)
     &    ,ILSV(NSORTMAX),INBAS(LIMLMB,NPAT)
        LOGICAL LTBAS(0:LMAXB,NPAT),LSBAS(0:LMAXB,NSORTMAX),EXIST
        CHARACTER*60 HUBFILE,HOPFILE,OPTFILE
	CHARACTER SCHM*10,RYEV*10,CUBC*10,REIM*10,HOPI*10,OVWR*10
     &    ,HINF(NLIMMAX)*60,HIND(NLIMMAX)*60,TXTH*120
     &    ,TXTEL(NSORTMAX)*10,TXTSP(2)*2,TL(0:3)*1,TEXT*60
C Controls:
        COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT !!! from readini
	COMMON /SPIN/   NSPIN                                !!! from readini
C TB-data:
	COMMON /TBBPAR/ LTBAS,LSBAS,INBAS,NTBAS              !!! from readini
        COMMON /HOPDAT/ NINF,NHOP,ISCHM,ICUBC,IRE,IWR,IHO    !!! from readhop
	COMMON /HOPTXT/ HINF,HIND                            !!! from readhop
C Additional inputs:
        COMMON /INP1/   ICHUB,ICHOP,ICOPT                    !!! from readini
        COMMON /INP2/   HUBFILE,HOPFILE,OPTFILE              !!! from readini
C Outputs
	COMMON /UNIT/   IUN                                  !!! from readini
        COMMON /TXTEL/  TXTEL,TXTSP                          !!! from readini
        DATA PI/3.141592653589793D0/,TL/'s','p','d','f'/
	IF(ICHOP.EQ.0)RETURN
C  CHECK EXISTENCE
        INQUIRE(FILE=HOPFILE,EXIST=EXIST)
        IF(.NOT.EXIST)STOP'<READHOP>: HOPFILE MUST EXIST!>'
C  SKIP DATA FROM HOPFILE
        OPEN(UNIT=1,FILE=HOPFILE,STATUS='OLD',FORM='FORMATTED')
        READ(1,1010)TEXT
        READ(1,1010)TEXT
C  SKIP GENERAL SETTINGS ****
        READ(1,1010)TEXT
        READ(1,*)SCHM
        READ(1,*)RYEV
        READ(1,*)CUBC
        READ(1,*)REIM
        READ(1,*)HOPI
        READ(1,*)OVWR
C  SKIP HOPPING INTEGRALS ****
        READ(1,1010)TEXT
	IF(IWR.EQ.2.AND.IHO.EQ.1)THEN
	DO ISPIN=1,NSPIN                !!! over spins
        READ(1,*)NINF
	IF(NINF.GT.NLIMMAX)STOP'<READHOP> NINF OUT OF BOUNDS'
        DO INF=1,NINF
        READ(1,*)
	ENDDO
	ENDDO                           !!! over spins
	WRITE(1,1100)
	ENDIF
	CALL PRINTHM(1)
	CLOSE(1)
1010    FORMAT(A)
1020	FORMAT(1X,8(I3,1X))
1100	FORMAT(1X,'CALCULATED HOPPING INTEGRLAS BELOW!!!') 
	END





	SUBROUTINE PRINTHM(ICHAN)
*******************************************************
*  Prints hopping matrix.                             *
*******************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
        INCLUDE 'PARAM.DAT'
	PARAMETER (NLIMMAX=LIMLMB*LIMLMB*NPAT*NENVMAX)
        INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX)
     &    ,ILSV(NSORTMAX),INBAS(LIMLMB,NPAT)
	COMPLEX*16 TC(-3:3,7,0:3),TS(7,-3:3,0:3)
     &    ,TMAT(LIMLMB,LIMLMB,NPAT,0:NENVMAX,NSPINMAX)
     &    ,PMAT(LIMLMB,LIMLMB,NPAT,0:NENVMAX,NSPINMAX)
     &    ,SMAT(LIMLMB,LIMLMB,NPAT,0:NENVMAX,NSPINMAX)
     &    ,THOP(-LMAXB:LMAXB,-LMAXB:LMAXB),CVAL(2)        
     &    ,SHOP(-LMAXB:LMAXB,-LMAXB:LMAXB)
        LOGICAL LTBAS(0:LMAXB,NPAT),LSBAS(0:LMAXB,NSORTMAX)
	CHARACTER HINF(NLIMMAX)*60,HIND(NLIMMAX)*60
     &    ,TXTEL(NSORTMAX)*10,TXTSP(2)*2,TXTH*120
        COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM        !!! from init
	COMMON /TBBPAR/ LTBAS,LSBAS,INBAS,NTBAS              !!! from init
        COMMON /HOPDAT/ NINF,NHOP,ISCHM,ICUBC,IRE,IWR        !!! from readhop
	COMMON /HOPTXT/ HINF,HIND                            !!! from readhop
	COMMON /HOPCOM/ TMAT,SMAT,PMAT                       !!! from hopmat
        COMMON /TXTEL/  TXTEL,TXTSP                          !!! from init
	COMMON /SPIN/   NSPIN                                !!! from init
	COMMON /UNIT/   IUN                                  !!! from init
        DATA PI/3.141592653589793D0/
C  STORE CALCULATED HOPPING INTEGRALS
	DO ISPIN=1,NSPIN
        WRITE(ICHAN,1010)NINF
	IF(NINF.GT.NLIMMAX)STOP'<READHOP> NINF OUT OF BOUNDS'
        DO INF=1,NINF
	READ(HINF(INF),*)IATOM1,NM1,L1,K1R,IATOM,NM,
     &  L,KR,IENV,IENV1
C  TRANSFERE TO CUBIC HARMONICS IF NECESSARY
	IF(ICUBC.EQ.1)THEN
	CALL TRANSS(TS)   ! built transformation matrices
        DO K1=-L1,L1
        L1K1=L1*(L1+1)+K1+1
        DO K=-L,L
        LK=L*(L+1)+K+1
        THOP(K1,K)=(0.D0,0.D0)
        SHOP(K1,K)=(0.D0,0.D0)
        DO M1=-L1,L1
        L1M1=L1*(L1+1)+M1+1
        DO M=-L,L
        LM=L*(L+1)+M+1
        THOP(K1,K)=THOP(K1,K)+CONJG(TS(K1+L1+1,M1,L1))*
     &  TMAT(L1M1,LM,IATOM1,IENV,ISPIN)*TS(K+L+1,M,L)
        THOP(K1,K)=THOP(K1,K)+CONJG(TS(K1+L1+1,M1,L1))*
     &  PMAT(L1M1,LM,IATOM1,IENV,ISPIN)*TS(K+L+1,M,L)
        SHOP(K1,K)=SHOP(K1,K)+CONJG(TS(K1+L1+1,M1,L1))*
     &  SMAT(L1M1,LM,IATOM1,IENV,ISPIN)*TS(K+L+1,M,L)
        ENDDO
        ENDDO
        ENDDO
        ENDDO
	ELSE
	L1K1R=L1*(L1+1)+K1R+1
	LKR=L*(L+1)+KR+1
	THOP(K1R,KR)=TMAT(L1K1R,LKR,IATOM1,IENV,ISPIN)+
     &               PMAT(L1K1R,LKR,IATOM1,IENV,ISPIN)
	SHOP(K1R,KR)=SMAT(L1K1R,LKR,IATOM1,IENV,ISPIN)
	ENDIF
	CVAL(1)=THOP(K1R,KR)
	CVAL(2)=SHOP(K1R,KR)
        CALL WRIORB(TXTH,NB,ICUBC,IRE,2,CVAL(1),
     &  IATOM1,NM1,L1,K1R,IATOM,NM,L,KR,IENV,IENV1)
        WRITE(ICHAN,1020)TXTH(:NB)
	ENDDO
	ENDDO                           !!! over spins
1010	FORMAT(I5,2X,'<From>',7X,
     &  '<To> the orbital via connection:',
     &  14X,'<Energy>',3X,'<Overlap>')
1020	FORMAT(1X,A)                           
	END









        SUBROUTINE REDORB(TXTH,NB,ICUBC,IRE,NV,CVAL,
     &  IATOM1,NM1,L1,M1,IATOM,NM,L,M,IENV,IENV1)
*******************************************************
*  Reads information from the TXTH string concerning  *
*  hopping matrix elements.                           *
*******************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
        INCLUDE 'PARAM.DAT'
        INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX)
     &    ,ILSV(NSORTMAX),NENV(NPAT),ISENV(0:NENVMAX,NPAT)
     &    ,IPENV(0:NENVMAX,NPAT,NOPRMAX),NHSORT(NSORTMAX)
     &    ,IRENV(0:NENVMAX,NPAT)
	DIMENSION TENV(3,0:NENVMAX,NPAT),TAU(3,NPAT),ORTH(2:3)
     &    ,RLOC(NSORTMAX),VEC(3),RVAL(10)
	COMPLEX*16 CVAL(NV)
	CHARACTER TXTH*(*),TL(0:3)*1,TCUBC(-3:3,0:3,2)*10
     &    ,STRING(80)*1,TW1*10,TW2*10,TXTEL(NSORTMAX)*10
     &    ,TXTSP(2)*2
        COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT !!! from init
        COMMON /BASIS/  TAU                                  !!! from init
	COMMON /LATPAR/ PAR,ORTH,OMEGAC                      !!! from init
	COMMON /SCRINP/ RLOC                                 !!! from init
        COMMON /ENVSITE/NENV,TENV,ISENV,IPENV,IRENV          !!! from envmesh
        COMMON /TXTEL/  TXTEL,TXTSP                          !!! from init
	COMMON /SPIN/   NSPIN                                !!! from init
	COMMON /UNIT/   IUN                                  !!! from init
        DATA PI/3.141592653589793D0/,TL/'s','p','d','f'/
	CALL INTCUBC(TCUBC)
	CALL CONVLOW(TXTH,NB)
C  SEARCH FOR IATOM1, SITE <FROM>
	DO IB=1,NB
	IF(TXTH(IB:IB).EQ.'#')THEN
	DO IB1=IB+1,NB
	IF(TXTH(IB1:IB1).EQ.' ')EXIT
	ENDDO
	READ(TXTH(IB+1:IB1),*)IATOM1
	DO IB0=1,IB1
	TXTH(IB0:IB0)=' '
	ENDDO
	EXIT
	ENDIF
	ENDDO
	IF(IB.EQ.NB+1)STOP'<READHOP> CANNOT FIND DATA <FROM IATOM1>'
C  SET ORBITAL FOR THE ATOM <FROM>
	DO IB=1,NB
	IF(TXTH(IB:IB).NE.' ')EXIT
	ENDDO
	READ(TXTH(IB:IB),*)NM1         ! main quantum number
	TXTH(IB:IB)=' '
	L1=-1
	IF(TXTH(IB+1:IB+1).EQ.'s')L1=0
	IF(TXTH(IB+1:IB+1).EQ.'p')L1=1
	IF(TXTH(IB+1:IB+1).EQ.'d')L1=2
	IF(TXTH(IB+1:IB+1).EQ.'f')L1=3
	IF(L1.EQ.-1)STOP'<READHOP> CANNOT FIND DATA <FROM L1>'
	TXTH(IB+1:IB+1)=' '
	IF(L1.EQ.0)THEN
	M1=0
	ELSE
	DO IB1=1,NB
	IF(TXTH(IB1:IB1).EQ.'{')EXIT
	ENDDO
	DO IB2=1,NB
	IF(TXTH(IB2:IB2).EQ.'}')EXIT
	ENDDO
	DO I1=1,10
	TW1(I1:I1)=' '
	TW2(I1:I1)=' '
	ENDDO
	DO I1=1,IB2-IB1-1
	TW1(I1:I1)=TXTH(IB1+I1:IB1+I1)
	ENDDO
	CALL RMBLANK(TW1,10)
	DO MV=-L1,L1
	TW2=TCUBC(MV,L1,ICUBC)
	CALL RMBLANK(TW2,10)
	IF(TW1.EQ.TW2)EXIT
	ENDDO
	M1=MV
	IF(ABS(M1).GT.L1)STOP'<READHOP> CANNOT FIND DATA <FROM M1>'
	DO IB=IB1,IB2
	TXTH(IB:IB)=' '
	ENDDO
	ENDIF
C  SEARCH FOR IATOM, SITE <TO>
	DO IB=1,NB
	IF(TXTH(IB:IB).EQ.'@')THEN
	DO IB1=IB+1,NB
	IF(TXTH(IB1:IB1).EQ.'[')EXIT
	ENDDO
	DO IB2=IB1+1,NB
	IF(TXTH(IB2:IB2).EQ.']')EXIT
	ENDDO
	DO I1=1,80
	STRING(I1)=' '
	ENDDO
	DO I1=1,IB2-IB1-1
	STRING(I1)=TXTH(IB1+I1:IB1+I1)
	ENDDO
	CALL COMPVEC(STRING,VEC,3)
	VEC(1)=VEC(1)*1.D0
	VEC(2)=VEC(2)*ORTH(2)
	VEC(3)=VEC(3)*ORTH(3)
        IF(SQRT(VEC(1)**2+VEC(2)**2+VEC(3)**2).GT.RLOC(IS(IATOM1)))
     &  STOP'<REDORB> RLOC IS TOO SMALL'
	DO IE=0,NENV(IATOM1)
	DIFF=(VEC(1)-TENV(1,IE,IATOM1))**2+
     &       (VEC(2)-TENV(2,IE,IATOM1))**2+
     &       (VEC(3)-TENV(3,IE,IATOM1))**2
	IF(DIFF.LE.1.D-04)EXIT
	ENDDO
	IF(IE.EQ.NENV(IATOM1)+1)STOP'<REDORB>: CANNOT FIND <TO IENV>'
	IENV=IE
	IATOM=ISENV(IENV,IATOM1)
C  Set complex conjugate:
        DO IE=0,NENV(IATOM)
        DIFF=(VEC(1)+TENV(1,IE,IATOM))**2
     &      +(VEC(2)+TENV(2,IE,IATOM))**2
     &      +(VEC(3)+TENV(3,IE,IATOM))**2
        IF(DIFF.LE.1.D-10)EXIT
        ENDDO
        IF(IE.EQ.NENV(IATOM)+1)STOP'<REDORB> WRONG CONJUGATION'
	IENV1=IE
	DO IB0=1,IB2
	TXTH(IB0:IB0)=' '
	ENDDO
	EXIT
	ENDIF
	ENDDO
C  SET ORBITAL FOR THE ATOM <TO>
	DO IB=1,NB
	IF(TXTH(IB:IB).NE.' ')EXIT
	ENDDO
	READ(TXTH(IB:IB),*)NM          ! main quantum number
	TXTH(IB:IB)=' '
	L=-1
	IF(TXTH(IB+1:IB+1).EQ.'s')L=0
	IF(TXTH(IB+1:IB+1).EQ.'p')L=1
	IF(TXTH(IB+1:IB+1).EQ.'d')L=2
	IF(TXTH(IB+1:IB+1).EQ.'f')L=3
	IF(L.EQ.-1)STOP'<READHOP> CANNOT FIND DATA <TO L>'
	TXTH(IB+1:IB+1)=' '
	IF(L.EQ.0)THEN
	M=0
	ELSE
	DO IB1=1,NB
	IF(TXTH(IB1:IB1).EQ.'{')EXIT
	ENDDO
	DO IB2=1,NB
	IF(TXTH(IB2:IB2).EQ.'}')EXIT
	ENDDO
	DO I1=1,10
	TW1(I1:I1)=' '
	TW2(I1:I1)=' '
	ENDDO
	DO I1=1,IB2-IB1-1
	TW1(I1:I1)=TXTH(IB1+I1:IB1+I1)
	ENDDO
	CALL RMBLANK(TW1,10)
	DO MV=-L,L
	TW2=TCUBC(MV,L,ICUBC)
	CALL RMBLANK(TW2,10)
	IF(TW1.EQ.TW2)EXIT
	ENDDO
	M=MV
	IF(ABS(M).GT.L)STOP'<READHOP> CANNOT FIND DATA <TO M>'
	DO IB=IB1,IB2
	TXTH(IB:IB)=' '
	ENDDO
	ENDIF
C  READ NUMBERS
	IF(IRE.EQ.1)READ(TXTH,*)(RVAL(I),I=1,NV)
	IF(IRE.EQ.2)READ(TXTH,*)(CVAL(I),I=1,NV)
	IF(IRE.EQ.1)THEN
	DO IV=1,NV
	CVAL(IV)=DCMPLX(RVAL(IV),0.D0)
	ENDDO
	ENDIF
	END





        SUBROUTINE WRIORB(TXTH,NB,ICUBC,IRE,NV,CVAL,
     &  IATOM1,NM1,L1,M1,IATOM,NM,L,M,IENV,IENV1)
*******************************************************
*  Writes information to the TXTH string concerning   *
*  hopping matrix elements.                           *
*******************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
        INCLUDE 'PARAM.DAT'
        INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX)
     &    ,ILSV(NSORTMAX),NENV(NPAT),ISENV(0:NENVMAX,NPAT)
     &    ,IPENV(0:NENVMAX,NPAT,NOPRMAX),NHSORT(NSORTMAX)
     &    ,IRENV(0:NENVMAX,NPAT)
	DIMENSION TENV(3,0:NENVMAX,NPAT),TAU(3,NPAT),ORTH(2:3)
     &    ,RLOC(NSORTMAX),VEC(3),RVAL(10)
	COMPLEX*16 CVAL(NV)
	CHARACTER TXTH*120,TL(0:3)*1,TCUBC(-3:3,0:3,2)*10
     &    ,STRING(80)*1,TW1*10,TW2*10,TXTEL(NSORTMAX)*10
     &    ,TXTSP(2)*2,TDPS*8,TCPS*19,TW3*19
        COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT !!! from init
        COMMON /BASIS/  TAU                                  !!! from init
	COMMON /LATPAR/ PAR,ORTH,OMEGAC                      !!! from init
	COMMON /SCRINP/ RLOC                                 !!! from init
        COMMON /ENVSITE/NENV,TENV,ISENV,IPENV,IRENV          !!! from envmesh
        COMMON /TXTEL/  TXTEL,TXTSP                          !!! from init
	COMMON /SPIN/   NSPIN                                !!! from init
	COMMON /UNIT/   IUN                                  !!! from init
        DATA PI/3.141592653589793D0/,TL/'s','p','d','f'/
	CALL INTCUBC(TCUBC)
C INITIALIZE STRING
	DO IB=1,120
	TXTH(IB:IB)=' '
	ENDDO
        NT=1
        DO ISORT=1,NSORT
	IF(TXTEL(ISORT)(1:4).NE.'for '.AND.
     &     TXTEL(ISORT)(1:4).NE.'FOR ')STOP
     &  '<WRIORB> TXTEL ARRAY DOES NOT CONTAIN <FOR > WORD'
        DO I=10,5,-1
        IF(TXTEL(ISORT)(I:I).NE.' ')EXIT
        ENDDO
        NT=MAX(NT,I)
        ENDDO
C  SET IATOM1, SITE <FROM>
	ISORT1=IS(IATOM1)
	DO IB=1,NT-4
	TXTH(IB:IB)=TXTEL(ISORT1)(IB+4:IB+4)
	ENDDO
	IPOINT=NT-4
	IPOINT=IPOINT+1
	TXTH(IPOINT:IPOINT)='#'
	IPOINT=IPOINT+1
	IF(IATOM1.LE.9)THEN
        WRITE(TXTH(IPOINT:IPOINT+1),FMT='(I1)')IATOM1
	ELSEIF(IATOM1.LE.99.AND.IATOM1.GT.9)THEN
        WRITE(TXTH(IPOINT:IPOINT+2),FMT='(I2)')IATOM1
	ELSEIF(IATOM1.LE.999.AND.IATOM1.GT.99)THEN
        WRITE(TXTH(IPOINT:IPOINT+3),FMT='(I3)')IATOM1
	ELSE
	STOP'<WRIORB> # ATOMS>999 NOT ALLOWED HERE'
	ENDIF
	IF(NATOM.LE.999)ID=3
	IF(NATOM.LE.99 )ID=2
	IF(NATOM.LE.9  )ID=1
	IPOINT=IPOINT+ID
C  SET BLANCK
	IPOINT=IPOINT+1
C  SET ORBITAL <FROM>
	WRITE(TXTH(IPOINT:IPOINT),FMT='(I1)')NM1
	IPOINT=IPOINT+1
	IF(L1.EQ.0)TXTH(IPOINT:IPOINT)='s'
	IF(L1.EQ.1)TXTH(IPOINT:IPOINT)='p'
	IF(L1.EQ.2)TXTH(IPOINT:IPOINT)='d'
	IF(L1.EQ.3)TXTH(IPOINT:IPOINT)='f'
	IPOINT=IPOINT+1
	JPOINT=IPOINT
	IF(L1.NE.0)THEN
	TXTH(IPOINT:IPOINT)='{'
	TW2=TCUBC(M1,L1,ICUBC)
	CALL RMBLANK(TW2,10)
	DO IB=1,10
	IF(TW2(IB:IB).EQ.' ')EXIT
	TXTH(IPOINT+IB:IPOINT+IB)=TW2(IB:IB)
	ENDDO
	IPOINT=IPOINT+IB
	TXTH(IPOINT:IPOINT)='}'
	ENDIF
	IPOINT=JPOINT+10
C  SET IATOM, SITE <TO>
	ISORT=IS(IATOM)
	DO IB=1,NT-4
	TXTH(IPOINT+IB:IPOINT+IB)=TXTEL(ISORT)(IB+4:IB+4)
	ENDDO
	IPOINT=IPOINT+NT-4
	IPOINT=IPOINT+1
	TXTH(IPOINT:IPOINT)='@'
	IPOINT=IPOINT+1
	TXTH(IPOINT:IPOINT)='['
	VEC(1)=TENV(1,IENV,IATOM1)
	VEC(2)=TENV(2,IENV,IATOM1)/ORTH(2)
	VEC(3)=TENV(3,IENV,IATOM1)/ORTH(3)
	TW1=TDPS(VEC(1),1.D-05)
	DO IB=1,8
	TXTH(IPOINT+IB:IPOINT+IB)=TW1(IB:IB)
	ENDDO
	TXTH(IPOINT+9:IPOINT+9)=','
	IPOINT=IPOINT+9
	TW1=TDPS(VEC(2),1.D-05)
	DO IB=1,8
	TXTH(IPOINT+IB:IPOINT+IB)=TW1(IB:IB)
	ENDDO
	TXTH(IPOINT+9:IPOINT+9)=','
	IPOINT=IPOINT+9
	TW1=TDPS(VEC(3),1.D-05)
	DO IB=1,8
	TXTH(IPOINT+IB:IPOINT+IB)=TW1(IB:IB)
	ENDDO
	TXTH(IPOINT+9:IPOINT+9)=']'
	IPOINT=IPOINT+10
C  SET ORBITAL <TO>
	IPOINT=IPOINT+1
	WRITE(TXTH(IPOINT:IPOINT),FMT='(I1)')NM
	IPOINT=IPOINT+1
	IF(L.EQ.0)TXTH(IPOINT:IPOINT)='s'
	IF(L.EQ.1)TXTH(IPOINT:IPOINT)='p'
	IF(L.EQ.2)TXTH(IPOINT:IPOINT)='d'
	IF(L.EQ.3)TXTH(IPOINT:IPOINT)='f'
	IPOINT=IPOINT+1
	JPOINT=IPOINT
	IF(L.NE.0)THEN
	TXTH(IPOINT:IPOINT)='{'
	TW2=TCUBC(M,L,ICUBC)
	CALL RMBLANK(TW2,10)
	DO IB=1,10
	IF(TW2(IB:IB).EQ.' ')EXIT
	TXTH(IPOINT+IB:IPOINT+IB)=TW2(IB:IB)
	ENDDO
	IPOINT=IPOINT+IB
	TXTH(IPOINT:IPOINT)='}'
	ENDIF
	IPOINT=JPOINT+10
C  SET VALUES
	IF(IRE.EQ.1)THEN
	DO IV=1,NV
	TW1=TDPS(DREAL(CVAL(IV)),1.D-05)
	DO IB=1,8
	TXTH(IPOINT+IB:IPOINT+IB)=TW1(IB:IB)
	ENDDO
	IPOINT=IPOINT+11
	ENDDO
	IPOINT=IPOINT-3
	ELSEIF(IRE.EQ.2)THEN
	DO IV=1,NV
	TW3=TCPS(CVAL(IV),1.D-05)
	DO IB=1,19
	TXTH(IPOINT+IB:IPOINT+IB)=TW3(IB:IB)
	ENDDO
	IPOINT=IPOINT+22
	ENDDO
	IPOINT=IPOINT-3
	ENDIF
	NB=IPOINT
	END
