	SUBROUTINE READSCF
************************************************************
*  <READSCF> reads charge density destribution in cell     *
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,NHSORT(NSORTMAX),ILSOLD(NSORTMAX),LMOLD(NSYMMAX,NPAT)
     &   ,NSYMOLD(NPAT),NRADOLD(NSORTMAX),ICOR(NSORTMAX),ISPL(NSORTMAX)
     &   ,LNUM(36,NSORTMAX),NLEVC(NSORTMAX),NLEVT(NSORTMAX)
     &   ,NKAPOLD(NPANMAX),ILSTOLD(NSORTMAX),NKAP(NPANMAX)
     &   ,NODES(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX)
     &   ,MNY  (0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX)
     &   ,NODOLD(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX)
     &   ,MNYOLD(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX)
     &   ,NSHEOLD(NSORTMAX)
	DIMENSION Z(NSORTMAX),ZCOR(NSORTMAX),ZLEV(36,NSORTMAX)
     &   ,ROLD(0:NRADMAX,NSORTMAX),RINTOLD(0:NSHEMAX,NSORTMAX)
     &   ,ELEV(36,NSORTMAX)
	DIMENSION ENY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,DNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,TNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,ENYOLD(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,DNYOLD(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,TNYOLD(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,SPLIT(NSORTMAX)
	COMPLEX*16 RO(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX)
     &   ,ROCOR(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX)
     &   ,ROVALDS(3,NSYMMAX,NPAT,NSPINMAX)
     &   ,ROCINT(0:NSHEMAX,NSYMMAX,NPAT,NSPINMAX)
     &   ,ROINT(0:NSHEMAX,NSYMMAX,NPAT,NSPINMAX)
        CHARACTER*60 INIFILE,SC0FILE,STRFILE
	CHARACTER TXTEL(NSORTMAX)*10
C Controls:
	COMMON /PARAM/   NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT!! from readini
	COMMON /SPIN/    NSPIN,SPLIT,ISPL                   !!! from readini
        COMMON /RWFCOM/  NRWF,LRWF,IRWF                     !!! from setup
C Inputs:
        COMMON /INP0/    INIFILE,SC0FILE,STRFILE            !!! from readini
	COMMON /INPPAR/  TNY,ENY,DNY,NODES,MNY              !!! from readini
	COMMON /KAPPAR/  NPAN,NKAP                          !!! from readini
	COMMON /MULTRO/  Z,ZCOR                             !!! from readini
        COMMON /MIXBROY/ LBROY,IBROY,ADMIXB,ADMIXH          !!! from readini
C Density:
	COMMON /DENS/    RO,ROVALDS,ROCOR,ROINT,ROCINT      !!! from readscf
C Core levels:
	COMMON /COR1/    ICOR,NLEVC,NLEVT,ELEV,ZLEV,LNUM    !!! from readscf
C Fermi level:
	COMMON /EFERMI/  EFERMI                             !!! from readscf
C Old meshes:
	COMMON /OLDMESH/ NSYMOLD,LMOLD,NRADOLD,NSHEOLD,ROLD,RINTOLD !readscf
C Outputs: 
	COMMON /TXTEL/   TXTEL                              !!! from readini
	COMMON /UNIT/    IUN                                !!! from readini
	DATA PI/3.141592653589793D0/
C-----------------------------------------
C****** READ SCFFILE *********************
C-----------------------------------------
        OPEN(1,FILE=SC0FILE,STATUS='OLD',FORM='UNFORMATTED')
C    ****** INPUT DENSITY ******
C    RO    - full density distribution in unit-cell
C    ROCOR - core density distribution
	READ(1)NATOMOLD,NSORTOLD,(NRADOLD(ISORT),ISORT=1,
     &  NSORTOLD),NSHEOLD0,NLOLD,(NSYMOLD(IATOM),IATOM=1,NATOMOLD),
     &  (ILSOLD(ISORT),ISORT=1,NSORTOLD),NSPINOLD,
     &  (NSHEOLD(ISORT),ISORT=1,NSORTOLD)
        IF(NATOMOLD.NE.NATOM)CALL ERRMSG('READSCF',21,' ','S')
        IF(NSORTOLD.NE.NSORT)CALL ERRMSG('READSCF',22,' ','S')
        IF(NSPINOLD.GT.NSPINMAX)CALL ERRMSG('READSCF',23,' ','S')
        DO IATOM=1,NATOM
        ISORT=IS(IATOM)
        IF(NSYMOLD(IATOM).GT.NSYMMAX)
     &  CALL ERRMSG('READSCF',25,' ','S')
        IF(NRADOLD(IS(IATOM)).GT.NRADMAX)
     &  CALL ERRMSG('READSCF',26,' ','S')
        ENDDO
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	READ(1) (ROLD(I,ISORT),I=0,NRADOLD(ISORT))
	READ(1) (RINTOLD(I,ISORT),I=0,NSHEOLD(ISORT)+1)
	READ(1)
	DO ISYM=1,NSYMOLD(IATOM)
	IF(ISYM.LE.NSYMMAX)THEN
	READ(1)LMOLD(ISYM,IATOM)
	READ(1)((RO(I,ISYM,IATOM,ISPIN),I=0,NRADOLD(IS(IATOM))),
     &  ISPIN=1,NSPINOLD)
	READ(1)((ROINT(I,ISYM,IATOM,ISPIN),I=0,NSHEOLD(ISORT)+1),
     &  ISPIN=1,NSPINOLD)
	READ(1)((ROVALDS(I,ISYM,IATOM,ISPIN),I=1,3),
     &  ISPIN=1,NSPINOLD)
	READ(1)((ROCOR(I,ISYM,IATOM,ISPIN),I=0,NRADOLD(ISORT)),
     &  ISPIN=1,NSPINOLD)
	READ(1)((ROCINT(I,ISYM,IATOM,ISPIN),I=0,NSHEOLD(ISORT)+1),
     &  ISPIN=1,NSPINOLD)
	ELSEIF(ISYM.GT.NSYMMAX)THEN
	DO IREAD=1,6
	READ(1)
	ENDDO
	ENDIF
	ENDDO
	IF(NSYMOLD(IATOM).GT.NSYMMAX)NSYMOLD(IATOM)=NSYMMAX
C CORE INFORMATION
        READ(1)NLEVC(ISORT),NLEVT(ISORT)
        READ(1)(ZLEV(ILEV,ISORT),ILEV=1,NLEVT(ISORT))
        READ(1)(ELEV(ILEV,ISORT),ILEV=1,NLEVT(ISORT))
        READ(1)(LNUM(ILEV,ISORT),ILEV=1,NLEVT(ISORT))
        READ(1)
	ENDDO
C  RESTART INFORMATION
	NPANOLD=0
	READ(1,END=30,ERR=30)NPANOLD,(NKAPOLD(IPAN),IPAN=1,NPANOLD),
     &  (ILSTOLD(ISORT),ISORT=1,NSORT),(((((ENYOLD(L,ISORT,IKAP,
     &  IPAN,ISPIN),L=0,ILSTOLD(ISORT)),ISORT=1,NSORT),IKAP=1,
     &  NKAPOLD(IPAN)),IPAN=1,NPANOLD),ISPIN=1,NSPINOLD),
     &  (((((DNYOLD(L,ISORT,IKAP,IPAN,ISPIN),L=0,ILSTOLD(ISORT)),
     &  ISORT=1,NSORT),IKAP=1,NKAPOLD(IPAN)),IPAN=1,NPANOLD),ISPIN=
     &  1,NSPINOLD),(((((TNYOLD(L,ISORT,IKAP,IPAN,ISPIN),L=0,
     &  ILSTOLD(ISORT)),ISORT=1,NSORT),IKAP=1,NKAPOLD(IPAN)),IPAN=1,
     &  NPANOLD),ISPIN=1,NSPINOLD),((((NODOLD(L,ISORT,IKAP,IPAN),
     &  L=0,ILSTOLD(ISORT)),ISORT=1,NSORT),IKAP=1,NKAPOLD(IPAN)),
     &  IPAN=1,NPANOLD),((((MNYOLD(L,ISORT,IKAP,IPAN),L=0,
     &  ILSTOLD(ISORT)),ISORT=1,NSORT),IKAP=1,NKAPOLD(IPAN)),IPAN=1,
     &  NPANOLD),EFERMI
	IRESTART=1
	GOTO 40
  30    IRESTART=0
  40    CLOSE(1)
C  PRINT MESSAGE
        IF(IRESTART.EQ.0)CALL ERRMSG('READSCF',28,' ','M')
C  ACCOUNT FOR SPIN INDEX
        IF(NSPIN.EQ.1.AND.NSPINOLD.EQ.2)
     &  CALL ERRMSG('READSCF',29,' ','M')
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	IF(NSPIN.EQ.NSPINOLD.AND.ISPL(ISORT).EQ.0)SPLIT(ISORT)=0.D0
	IF(NSPIN.EQ.1)SPLIT(ISORT)=0.D0  ! set up splitting to zero
	DO ISYM=1,NSYMOLD(IATOM)
	IF(ISYM.LE.NSYMMAX)THEN
	IF(NSPIN.EQ.2.AND.NSPINOLD.EQ.1)THEN
	DO IRAD=0,NRADOLD(ISORT)
	RO(IRAD,ISYM,IATOM,1)=RO(IRAD,ISYM,IATOM,1)/2.D0
	RO(IRAD,ISYM,IATOM,NSPIN)=RO(IRAD,ISYM,IATOM,1)
	ROCOR(IRAD,ISYM,IATOM,1)=ROCOR(IRAD,ISYM,IATOM,1)/2.D0
	ROCOR(IRAD,ISYM,IATOM,NSPIN)=ROCOR(IRAD,ISYM,IATOM,1)
	ENDDO
	DO IRAD=0,NSHEOLD(ISORT)+1
	ROINT(IRAD,ISYM,IATOM,1)=ROINT(IRAD,ISYM,IATOM,1)/2.D0
	ROINT(IRAD,ISYM,IATOM,NSPIN)=ROINT(IRAD,ISYM,IATOM,1)
	ROCINT(IRAD,ISYM,IATOM,1)=ROCINT(IRAD,ISYM,IATOM,1)/2.D0
	ROCINT(IRAD,ISYM,IATOM,NSPIN)=ROCINT(IRAD,ISYM,IATOM,1)
	ENDDO
	DO ID=1,3
	ROVALDS(ID,ISYM,IATOM,1)=ROVALDS(ID,ISYM,IATOM,1)/2.D0
	ROVALDS(ID,ISYM,IATOM,NSPIN)=ROVALDS(ID,ISYM,IATOM,1)
	ENDDO
	ELSEIF(NSPIN.EQ.1.AND.NSPINOLD.EQ.2)THEN
	DO IRAD=0,NRADOLD(ISORT)
	RO(IRAD,ISYM,IATOM,1)=RO(IRAD,ISYM,IATOM,1)+
     &  RO(IRAD,ISYM,IATOM,NSPINOLD)
	RO(IRAD,ISYM,IATOM,NSPINOLD)=(0.D0,0.D0)
	ROCOR(IRAD,ISYM,IATOM,1)=ROCOR(IRAD,ISYM,IATOM,1)+
     &  ROCOR(IRAD,ISYM,IATOM,NSPINOLD)
	ROCOR(IRAD,ISYM,IATOM,NSPINOLD)=(0.D0,0.D0)
	ENDDO
	DO IRAD=0,NSHEOLD(ISORT)+1
	ROINT(IRAD,ISYM,IATOM,1)=ROINT(IRAD,ISYM,IATOM,1)+
     &  ROINT(IRAD,ISYM,IATOM,NSPINOLD)
	ROINT(IRAD,ISYM,IATOM,NSPINOLD)=(0.D0,0.D0)
	ROCINT(IRAD,ISYM,IATOM,1)=ROCINT(IRAD,ISYM,IATOM,1)+
     &  ROCINT(IRAD,ISYM,IATOM,NSPINOLD)
	ROCINT(IRAD,ISYM,IATOM,NSPINOLD)=(0.D0,0.D0)
	ENDDO
	DO ID=1,3
	ROVALDS(ID,ISYM,IATOM,1)=ROVALDS(ID,ISYM,IATOM,1)+
     &  ROVALDS(ID,ISYM,IATOM,NSPINOLD)
	ROVALDS(ID,ISYM,IATOM,NSPINOLD)=(0.D0,0.D0)
	ENDDO
	ENDIF
	ENDIF 
	ENDDO
	ENDDO
C  ACCOUNT FOR RESTART INFORMATION
	IF(IRESTART.NE.0)THEN
	DO IKAP=1,NKAP(1)
	IF(NKAP(1).EQ.NKAPOLD(1))THEN
	DO ISORT=1,NSORT
	DO L=0,ILSTOLD(ISORT)
	IF(NODES(L,ISORT,IKAP,1).EQ.NODOLD(L,ISORT,IKAP,1))THEN
	IF(.NOT.(MNY(L,ISORT,IKAP,1).NE.3.AND.MNY(L,ISORT,IKAP,1).NE.
     &  MNYOLD(L,ISORT,IKAP,1)))THEN
C  SET ENY,DNY,TNY
	IF(NSPIN.EQ.NSPINOLD)THEN
	DO ISPIN=1,NSPIN
	ENY(L,ISORT,IKAP,1,ISPIN)=ENYOLD(L,ISORT,IKAP,1,ISPIN)
	DNY(L,ISORT,IKAP,1,ISPIN)=DNYOLD(L,ISORT,IKAP,1,ISPIN)
	TNY(L,ISORT,IKAP,1,ISPIN)=TNYOLD(L,ISORT,IKAP,1,ISPIN)
	ENDDO
	ELSEIF(NSPIN.EQ.2.AND.NSPINOLD.EQ.1)THEN
	DO ISPIN=1,NSPIN
	ENY(L,ISORT,IKAP,1,ISPIN)=ENYOLD(L,ISORT,IKAP,1,NSPINOLD)
	DNY(L,ISORT,IKAP,1,ISPIN)=DNYOLD(L,ISORT,IKAP,1,NSPINOLD)
	TNY(L,ISORT,IKAP,1,ISPIN)=TNYOLD(L,ISORT,IKAP,1,NSPINOLD)
	ENDDO
	ELSEIF(NSPIN.EQ.1.AND.NSPINOLD.EQ.2)THEN
	ENY(L,ISORT,IKAP,1,1)=(ENYOLD(L,ISORT,IKAP,1,1)+
     &  ENYOLD(L,ISORT,IKAP,1,NSPINOLD))/2.D0
	ENY(L,ISORT,IKAP,1,NSPINOLD)=(0.D0,0.D0)
	DNY(L,ISORT,IKAP,1,1)=(DNYOLD(L,ISORT,IKAP,1,1)+
     &  DNYOLD(L,ISORT,IKAP,1,NSPINOLD))/2.D0
	DNY(L,ISORT,IKAP,1,NSPINOLD)=(0.D0,0.D0)
	TNY(L,ISORT,IKAP,1,1)=(TNYOLD(L,ISORT,IKAP,1,1)+
     &  TNYOLD(L,ISORT,IKAP,1,NSPINOLD))/2.D0
	TNY(L,ISORT,IKAP,1,NSPINOLD)=(0.D0,0.D0)
	ENDIF
	ENDIF
	ENDIF
C AVERAGE OVER SPINS IF REQUIRED
        IF(LRWF.EQ.1)THEN
        ENY(L,ISORT,IKAP,1,1)=(ENY(L,ISORT,IKAP,1,1)+
     &  ENY(L,ISORT,IKAP,1,NSPIN))/2.D0
        DNY(L,ISORT,IKAP,1,1)=(DNY(L,ISORT,IKAP,1,1)+
     &  DNY(L,ISORT,IKAP,1,NSPIN))/2.D0
        TNY(L,ISORT,IKAP,1,1)=(TNY(L,ISORT,IKAP,1,1)+
     &  TNY(L,ISORT,IKAP,1,NSPIN))/2.D0
        ENY(L,ISORT,IKAP,1,NSPIN)=ENY(L,ISORT,IKAP,1,1)
        DNY(L,ISORT,IKAP,1,NSPIN)=DNY(L,ISORT,IKAP,1,1)
        TNY(L,ISORT,IKAP,1,NSPIN)=TNY(L,ISORT,IKAP,1,1)
        ENDIF
	ENDDO
	ENDDO
	ENDIF
	ENDDO
	ENDIF 
C  SET UP # OF CORE LEVELS ACCORDING TO ZCOR
        DO ISORT=1,NSORT
        IF(ABS(ZCOR(ISORT)).GT.1.D-05)THEN
        NZCOR=ZCOR(ISORT)/2.D0
        IF(ABS(ZCOR(ISORT)/2.D0-NZCOR).GT.1.D-10)
     &  CALL ERRMSG('READSCF',30,' ','S')
        ZC=0.D0
        DO ILEV=1,NLEVT(ISORT)
        ZC=ZC+ZLEV(ILEV,ISORT)
        IF(ABS(ZC-ZCOR(ISORT)).LE.1.D-10)GOTO100
        ENDDO
        CALL ERRMSG('READSCF',31,' ','S')
 100    IF(NLEVC(ISORT).NE.ILEV)THEN
        IF(ICOR(ISORT).EQ.0)
     &  CALL ERRMSG('READSCF',32,TXTEL(ISORT),'W')
        IF(ICOR(ISORT).EQ.0)ICOR(ISORT)=1
        IF(LBROY.GE.0.AND.IBROY.EQ.0)CALL ERRMSG('READSCF',31,' ','W')
        IF(LBROY.GE.0.AND.IBROY.EQ.0)IBROY=1
        ENDIF
        NLEVC(ISORT)=ILEV
        ENDIF
        ENDDO
        IF(LBROY.GE.0.AND.IRESTART.EQ.0.AND.IBROY.EQ.0)IBROY=1
        END
