	SUBROUTINE RENCOR(ITER)
************************************************************
*   Renormalization of the core density                    *
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX)
     &   ,ILSV(NSORTMAX),NHSORT(NSORTMAX),NRAD(NSORTMAX)
     &   ,NLEVC(NSORTMAX),NLEVT(NSORTMAX),LNUM(36,NSORTMAX)
     &   ,LMSYM(LMMAXV,NPAT),NSYM(NPAT),ICOR(NSORTMAX)
     &   ,LR(NSORTMAX)
	DIMENSION H(NSORTMAX),R(0:NRADMAX,NSORTMAX),ELEV(36,NSORTMAX)
     &   ,DR(0:NRADMAX,NSORTMAX),SMT(NSORTMAX),ZLEV(36,NSORTMAX)
     &   ,WEIGHT(0:NRADMAX,NSORTMAX),Z(NSORTMAX),ZCOR(NSORTMAX)
     &   ,VSPH(0:NRADMAX,NSORTMAX,NSPINMAX),WORK1(0:NRADMAX)
     &   ,ZCMT(NSORTMAX),ANORM(NSORTMAX),VBAR(0:NRADMAX)
     &   ,APHI(0:NRADMAX),APHID(0:NRADMAX)
	COMPLEX*16 RO(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX)
     &   ,ROCOR(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX)
     &   ,V(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX)
     &   ,ROVALDS(3,NSYMMAX,NPAT,NSPINMAX)
	CHARACTER TXTEL(NSORTMAX)*10,TLEV(8,0:4,8)*19,THED*19
	LOGICAL SYM(LMMAXV,NPAT),EXIT
	COMMON /PARAM/   NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT  !!! from init
	COMMON /RADMESH/ NRAD,H,R,DR,WEIGHT                    !!! from radmsh
	COMMON /DENS/    RO,ROVALDS,ROCOR                      !!! from rofull
	COMMON /SYMMLM/  SYM,LMSYM,NSYM                        !!! from symmlm
	COMMON /VZERO/   VMT0                                  !!! from vzero
	COMMON /MULTRO/  Z,ZCOR                                !!! from multro
	COMMON /POTCOM/  SWZ,SMT,VSPH,V                        !!! from vfull
	COMMON /SPIN/    NSPIN                                 !!! from init
	COMMON /RELATIV/ LR                                    !!! from init
	COMMON /COR1/    ICOR,NLEVC,NLEVT,ELEV,ZLEV,LNUM       !!! from init
	COMMON /TXTEL/   TXTEL
	COMMON /UNIT/    IUN
	DATA PI/3.141592653589793D0/
	LCR=0  ! non-relativistic solution
	LCR=1  ! scalar relativistic solution
	LCR=2  ! fully relativistic solution
	DO 1000 IATOM=1,NATOM                       !!! over sorts
	ISORT=IS(IATOM)
	IF(ICOR(ISORT).EQ.0)GOTO1000
	IF(Z(ISORT).LE.1.D-5)GOTO1000
	DO IRAD=0,NRAD(ISORT)
	ROCOR(IRAD,1,IATOM,1)=0.D0
	ROCOR(IRAD,1,IATOM,NSPIN)=0.D0
	ENDDO
C  SET THE POTENTIAL
        DO IRAD=0,NRAD(ISORT)
        VBAR(IRAD)=0.D0
        ENDDO
        DO KATOM=1,NATOM
        IF(IS(KATOM).EQ.ISORT)THEN
        DO IRAD=1,NRAD(ISORT)
        VBAR(IRAD)=VBAR(IRAD)-R(IRAD,ISORT)/SQRT(4.D0*PI)*
     &  (V(IRAD,1,KATOM,1)+V(IRAD,1,KATOM,NSPIN))/2.D0/
     &  DBLE(NHSORT(ISORT))
        ENDDO
        ENDIF
        ENDDO
        VBAR(0)=2.D0*Z(ISORT)
C  RECALCULATE CORE LEVELS 
	DO ILEV=1,NLEVC(ISORT)                 !!! over core levels
	NQ=LNUM(ILEV,ISORT)/100
	LQ=(LNUM(ILEV,ISORT)-100*NQ)/10
	JQ=(LNUM(ILEV,ISORT)-100*NQ-10*LQ)
	QJ=DBLE(JQ)/2.D0
	NODE=NQ-LQ-1
	ROOT=ELEV(ILEV,ISORT)
C  SOLVE DIRAC EQUATION 
	CALL ENYCOR(ROOT,NODE,LQ,JQ,DLOG,SMT(ISORT),VBAR(0),
     &  APHI(0),APHID(0),NRAD(ISORT),H(ISORT),R(0,ISORT),
     &  DR(0,ISORT),LCR)
	ELEV(ILEV,ISORT)=ROOT
C  SET NEW CORE DENSITY FOR NON- OR SCALAR-RELATIVISTIC CASE
	IF(LCR.EQ.0.OR.LCR.EQ.1)THEN
	DO ISPIN=1,NSPIN
	DO IRAD=0,NRAD(ISORT)
	ROCOR(IRAD,1,IATOM,ISPIN)=ROCOR(IRAD,1,IATOM,ISPIN)+
     &  ZLEV(ILEV,ISORT)/DBLE(NSPIN)/SQRT(4.D0*PI)*
     &  APHI(IRAD)**2
	ENDDO
	ENDDO
C  SET CORE DENSITY IN THE FULLY RELATIVISTIC CASE
C  APHI and APHID are the LARGE and SMALL components
	ELSEIF(LCR.EQ.2)THEN
	DO ISPIN=1,NSPIN
	DO IRAD=0,NRAD(ISORT)
	ROCOR(IRAD,1,IATOM,ISPIN)=ROCOR(IRAD,1,IATOM,ISPIN)+
     &  ZLEV(ILEV,ISORT)/DBLE(NSPIN)/SQRT(4.D0*PI)*
     &  (APHI(IRAD)**2+APHID(IRAD)**2)
	ENDDO
	ENDDO
	ENDIF
	ENDDO                                  !!! over core levels
1000    CONTINUE                               !!! over sorts
C  SET NEW CHARGE DENSITY
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	DO ISPIN=1,NSPIN
	DO IRAD=0,NRAD(ISORT)
	RO(IRAD,1,IATOM,ISPIN)=RO(IRAD,1,IATOM,ISPIN)+
     &  ROCOR(IRAD,1,IATOM,ISPIN)
	ENDDO
	DO ISYM=2,NSYM(IATOM)
	ROCOR(IRAD,ISYM,IATOM,ISPIN)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO
C  FIND CORE CHARGE IN UNIT-CELL
	CALL ZCORE(ZCMT,ZCTOT,ANORM)
C  PRINT CORE LEVELS
	CALL TLEVCHAR(TLEV,THED) 
	DO ISORT=1,NSORT
	IF(ICOR(ISORT).NE.0)THEN
	WRITE(IUN,1010)THED,TXTEL(ISORT),ZCOR(ISORT)
	IF(ABS(ANORM(ISORT)-1.D0).GT.1.D-01)PRINT*,
     &  '<RENCOR>:: UNUSUALLY LARGE RENORMALIZATION OF ZCOR'
	DO ILEV=1,NLEVC(ISORT)
	NQ=LNUM(ILEV,ISORT)/100
	LQ=(LNUM(ILEV,ISORT)-100*NQ)/10
	JQ=(LNUM(ILEV,ISORT)-100*NQ-10*LQ)
	WRITE(IUN,1020)TLEV(NQ,LQ,JQ),INT(ZLEV(ILEV,ISORT)),
     &  ELEV(ILEV,ISORT)
	ENDDO
	ENDIF
	ENDDO
1010    FORMAT(1X,A19,'  # el.  Levels(Ry) ',A10,'; Zcor=',G12.5)
1020    FORMAT(1X,A19,3X,I2,3X,G14.7)
	END


	SUBROUTINE TLEVCHAR(TLEV,THED)
**********************************************************
*  Sets level notations.                                 *
**********************************************************
	CHARACTER*19 TLEV(8,0:4,8),THED
	THED       ='Orbital   n  l  j  '
C N=1
	TLEV(1,0,1)=' 1s1/2    1  0  1/2'
C N=2
	TLEV(2,0,1)=' 2s1/2    2  0  1/2'
	TLEV(2,1,1)=' 2p1/2    2  1  1/2'
	TLEV(2,1,3)=' 2p3/2    2  1  3/2'
C N=3
	TLEV(3,0,1)=' 3s1/2    3  0  1/2' 
	TLEV(3,1,1)=' 3p1/2    3  1  1/2'
	TLEV(3,1,3)=' 3p3/2    3  1  3/2'
	TLEV(3,2,3)=' 3d3/2    3  2  3/2'
	TLEV(3,2,5)=' 3d5/2    3  2  5/2'
C N=4
	TLEV(4,0,1)=' 4s1/2    4  0  1/2'
	TLEV(4,1,1)=' 4p1/2    4  1  1/2'
	TLEV(4,1,3)=' 4p3/2    4  1  3/2'
	TLEV(4,2,3)=' 4d3/2    4  2  3/2'
	TLEV(4,2,5)=' 4d5/2    4  2  5/2'
	TLEV(4,3,5)=' 4f5/2    4  3  5/2'
	TLEV(4,3,7)=' 4f7/2    4  3  7/2'
C N=5
	TLEV(5,0,1)=' 5s1/2    5  0  1/2'
	TLEV(5,1,1)=' 5p1/2    5  1  1/2'
	TLEV(5,1,3)=' 5p3/2    5  1  3/2'
	TLEV(5,2,3)=' 5d3/2    5  2  3/2'
	TLEV(5,2,5)=' 5d5/2    5  2  5/2'
	TLEV(5,3,5)=' 5f5/2    5  3  5/2'
	TLEV(5,3,7)=' 5f7/2    5  3  7/2'
C N=6
	TLEV(6,0,1)=' 6s1/2    6  0  1/2'
	TLEV(6,1,1)=' 6p1/2    6  1  1/2'
	TLEV(6,1,3)=' 6p3/2    6  1  3/2'
	TLEV(6,2,3)=' 6d3/2    6  2  3/2'
	TLEV(6,2,5)=' 6d5/2    6  2  5/2'
	TLEV(6,3,5)=' 6f5/2    6  3  5/2'
	TLEV(6,3,7)=' 6f7/2    6  3  7/2'
C N=7
	TLEV(7,0,1)=' 7s1/2    7  0  1/2'
	TLEV(7,1,1)=' 7p1/2    7  1  1/2'
	TLEV(7,1,3)=' 7p3/2    7  1  3/2'
	TLEV(7,2,3)=' 7d3/2    7  2  3/2'
	TLEV(7,2,5)=' 7d5/2    7  2  5/2'
	TLEV(7,3,5)=' 7f5/2    7  3  5/2'
	TLEV(7,3,7)=' 7f7/2    7  3  7/2'
	END



	SUBROUTINE ZCORE(ZCMT,ZCTOT,ANORM)
**************************************************************
*  Find core charge in the elementary cell                   *
**************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILSV(NSORTMAX),ILST(NSORTMAX),ILSB(NSORTMAX)
     &    ,IS(NPAT),NHSORT(NSORTMAX),NRAD(NSORTMAX)
	DIMENSION SMT(NSORTMAX),ZCOR(NSORTMAX),ZCMT(NSORTMAX)
     &    ,RL(0:NRADMAX,0:LMAXV,NSORTMAX),WORK2(0:NRADMAX)
     &    ,H(NSORTMAX),R(0:NRADMAX,NSORTMAX),WORK1(0:NRADMAX)
     &    ,WEIGHT(0:NRADMAX,NSORTMAX),DR(0:NRADMAX,NSORTMAX)
     &    ,Z(NSORTMAX),ANORM(NSORTMAX)
	COMPLEX*16 RO(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX)
     &    ,ROCOR(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX),ROC
     &    ,ROVALDS(3,NSYMMAX,NPAT,NSPINMAX),ROVAL,DIM
	CHARACTER TXTEL(NSORTMAX)*10
	COMMON /CONTROL/MAN,LMTO,NLR,NOVR                   !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT!!! from init
	COMMON /DENS/   RO,ROVALDS,ROCOR                    !!! from rofull
	COMMON /POTCOM/ SWZ,SMT                             !!! from init
	COMMON /MULTRO/ Z,ZCOR                              !!! from multro
	COMMON /RADMESH/NRAD,H,R,DR,WEIGHT,RL               !!! from radmsh
	COMMON /SPIN/   NSPIN                               !!! from init
	COMMON /UNIT/   IUN                                 !!! from init
	DATA PI/3.141592653589793D0/,DIM/(0.D0,1.D0)/
	SQPI4=2.D0*SQRT(PI)
	ZCTOT=0.D0
	ZCORT=0.D0
	DO 30 IATOM=1,NATOM                  !!! over atoms
	ISORT=IS(IATOM)
	ZCMT(ISORT)=0.D0
	DO 20 ISPIN=1,NSPIN                  !!! over spins
C  FIND CHARGES
	DO 10 IRAD=0,NRAD(ISORT)
	WORK1(IRAD)=ROCOR(IRAD,1,IATOM,ISPIN)*
     &  WEIGHT(IRAD,ISORT)/SQRT(4.D0*PI)
  10    CONTINUE
	CALL QD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	ZCMT(ISORT)=ZCMT(ISORT)+WORK2(NRAD(ISORT))
  20    CONTINUE                             !!! over spins
	ZCTOT=ZCTOT+ZCMT(ISORT)
	ZCORT=ZCORT+ZCOR(ISORT)
  30    CONTINUE                             !!! over atoms
C  RENORMALIZE CORE DENSITY
	DO 60 ISPIN=1,NSPIN
	DO 50 IATOM=1,NATOM
	ISORT=IS(IATOM)
	ANORM(ISORT)=1.D0
	IF(ZCOR(ISORT).GT.1.D-03)
     &  ANORM(ISORT)=ZCOR(ISORT)/ZCMT(ISORT)
	DO 40 IRAD=0,NRAD(ISORT)
	ROC=ROCOR(IRAD,1,IATOM,ISPIN)
	ROVAL=RO(IRAD,1,IATOM,ISPIN)-ROC
	ROC=ROC*ANORM(ISORT)
	RO(IRAD,1,IATOM,ISPIN)=ROVAL+ROC
	ROCOR(IRAD,1,IATOM,ISPIN)=ROCOR(IRAD,1,IATOM,ISPIN)*
     &  ANORM(ISORT)
  40    CONTINUE
  50    CONTINUE
  60    CONTINUE
	END
