	SUBROUTINE ROCHEB
**************************************************************
*  Find Chebyshev expansion of the density in the            *
*  interstitial region.                                      *
*  Written by S.Yu.Savrasov (P.N.Lebedev Physical Institute) *
**************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	PARAMETER (LPLMAX=(2*LMAXV+1)**2)
	INTEGER ILSV(NSORTMAX),ILST(NSORTMAX),ILSB(NSORTMAX)
     &    ,IS(NPAT),NHSORT(NSORTMAX),LMSYM(LMMAXV,NPAT)
     &    ,NSHE(NSORTMAX),NPOL(0:NSORTMAX)
	DIMENSION SMT(NSORTMAX),RINT(0:NSHEMAX,NSORTMAX)
     &    ,XINT(0:NSHEMAX,NSORTMAX),TT(0:NPOLMAX,0:NSHEMAX,NSORTMAX)
     &    ,C(0:LMAXV+1,LMMAXV1,LMMAXV1),SROU(NSORTMAX)
     &    ,Z(NSORTMAX),ZCOR(NSORTMAX)
	COMPLEX*16 ROINT(0:NSHEMAX,NSYMMAX,NPAT,NSPINMAX)
     &    ,RO    (0:NRADMAX,NSYMMAX,NPAT,NSPINMAX)
     &    ,ROCOR (0:NRADMAX,NSYMMAX,NPAT,NSPINMAX)
     &    ,CHEBRO(0:NPOLMAX,NSYMMAX,NPAT,NSPINMAX)
     &    ,CONVRO(0:NPOLMAX,NSYMMAX,NPAT,NSPINMAX)
     &    ,TCH(NSYMMAX,NPAT,2,NSPINMAX),AR(0:NPOLMAX,2),DIM
     &    ,RMAT(0:NPOLMAX,LPLMAX),TMAT(0:NPOLMAX,0:NPOLMAX)
     &    ,ROVALDS(3,NSYMMAX,NPAT,NSPINMAX)
	LOGICAL SYM(LMMAXV,NPAT)
	CHARACTER TXTEL(NSORTMAX)*10
	COMMON /CONTROL/MAN,LMTO,NLR,NINT                   !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT!!! from init
	COMMON /POTCOM/ SWZ,SMT                             !!! from init
	COMMON /CHEBRO/ CHEBRO,CONVRO                       !!! from rocheb
	COMMON /DENS/   RO,ROVALDS,ROCOR,ROINT              !!! from roint
	COMMON /SYMMLM/ SYM,LMSYM                           !!! from symlm
	COMMON /INTMESH/NSHE,NPOL,SROU,RINT,XINT,TT         !!! from init
	COMMON /STORE2/ RMAT                                !!! from srfmsh
	COMMON /MULTRO/ Z,ZCOR,TCH                          !!! from init
	COMMON /SPIN/   NSPIN                               !!! from init
	COMMON /GAUNT/  C                                   !!! from gdata
	COMMON /UNIT/   IUN                                 !!! from init
	DATA PI/3.141592653589793D0/,DIM/(0.D0,1.D0)/
	SQPI4=2.D0*SQRT(PI)
	IF(NINT.EQ.0)RETURN
	DO 180 ISPIN=1,NSPIN
	DO 170 IATOM=1,NATOM                 !!! over atoms
	ISORT=IS(IATOM)
	ST=SMT(ISORT)
C  FIND CHEBYSHEV COEFFICIENTS
	DO 40 L=0,ILSV(ISORT)                !!! over l
	DO 30 M=-L,L                         !!! over m
	LM=L*(L+1)+M+1
	IF(SYM(LM,IATOM))THEN
	ISYM=LMSYM(LM,IATOM)
	DO 20 IPOL=0,NPOL(ISORT)             !!! over polinoms
	CONVRO(IPOL,ISYM,IATOM,ISPIN)=(0.D0,0.D0)
	CHEBRO(IPOL,ISYM,IATOM,ISPIN)=(0.D0,0.D0)
	DO 10 I=1,NSHE(ISORT)                !!! over mesh points
	CHEBRO(IPOL,ISYM,IATOM,ISPIN)=CHEBRO(IPOL,ISYM,IATOM,ISPIN)
     &  +2.D0/NSHE(ISORT)*ROINT(I,ISYM,IATOM,ISPIN)*TT(IPOL,I,ISORT)
  10	CONTINUE                             !!! over mesh points
  20	CONTINUE                             !!! over polinoms
	ENDIF
  30	CONTINUE                             !!! over m
  40	CONTINUE                             !!! over l
C  READ SURFACE CONSTANTS FROM SCRATCH FILE 1
	DO 45 IPOL=0,NPOL(ISORT)
	IREC=IPOL+1+(NPOL(0)+1)*(IATOM-1)+NATOM+1
	READ(11,REC=IREC)(RMAT(IPOL,LM),LM=1,(2*ILSV(ISORT)+1)**2)
  45	CONTINUE
C  AND PERFORM CONVOLUTION WITH T-MATRIX
	DO 110 L2=0,2*ILSV(ISORT)
	LL2=L2/2
	DO 100 M2=-L2,L2
	L2M2=L2*(L2+1)+M2+1
	CALL CONVOLCH(NPOL(ISORT),RMAT(0,L2M2),TMAT(0,0),1)
	DO 90 L=0,ILSV(ISORT)                !!! over l
	DO 80 M=-L,L                         !!! over m
	LM=L*(L+1)+M+1
	IF(SYM(LM,IATOM))THEN                !!! only for non-zero components
	ISYM=LMSYM(LM,IATOM)
	DO 70 IPOL=0,NPOL(ISORT)             !!! over polinoms
	DO 60 L1=ABS(L-L2),L+L2,2            !!! over l1
	M1=M2+M                              !!! over m1
	IF(L1.LE.ILSV(ISORT).AND.ABS(M1).LE.L1)THEN
	L1M1=L1*(L1+1)+M1+1
	IF(SYM(L1M1,IATOM))THEN              !!! only for non-zero components
	ISYM1=LMSYM(L1M1,IATOM)
	DO 50 IPOL1=0,NPOL(ISORT)            !!! over polynoms
	IF(IPOL1+IPOL.LE.NPOL(ISORT))THEN    !!! when T.ne.0
	CONVRO(IPOL,ISYM,IATOM,ISPIN)=CONVRO(IPOL,ISYM,IATOM,ISPIN)+
     &  CHEBRO(IPOL1,ISYM1,IATOM,ISPIN)*C(LL2,L1M1,LM)*DIM**(L1-L)*
     &  TMAT(IPOL1,IPOL)
	ENDIF                                !!! when T.ne.0
  50	CONTINUE                             !!! over polynoms
	ENDIF                                !!! only for non-zero components
	ENDIF                                !!! over m1
  60	CONTINUE                             !!! over l1
  70	CONTINUE                             !!! over polinoms
	ENDIF                                !!! only for non-zero components
  80	CONTINUE                             !!! over m
  90	CONTINUE                             !!! over l
 100	CONTINUE                             !!! over m2
 110	CONTINUE                             !!! over l2
C  EXPAND MULTIPOLES
	DO 160 L=0,ILSV(ISORT)               !!! over l
	DO 130 IPOL=0,NPOL(ISORT)            !!! over polinoms
	AR(IPOL,1)=(0.D0,0.D0)
	AR(IPOL,2)=(0.D0,0.D0)
	DO 120 I=1,NSHE(ISORT)	             !!! over mesh points
	AR(IPOL,1)=AR(IPOL,1)+2.D0/NSHE(ISORT)*
     &  (RINT(I,ISORT)/ST)**(-L-1)*TT(IPOL,I,ISORT)
	AR(IPOL,2)=AR(IPOL,2)+2.D0/NSHE(ISORT)*
     &  (RINT(I,ISORT)/ST)**L*TT(IPOL,I,ISORT)
 120	CONTINUE                             !!! over mesh points
 130	CONTINUE                             !!! over polinoms
C  FIND MULTIPOLE CHARGES
	DO 150 M=-L,L                        !!! over m
	LM=L*(L+1)+M+1
	IF(SYM(LM,IATOM))THEN                !!! only for non-zero components
	ISYM=LMSYM(LM,IATOM)
C	TCH(ISYM,IATOM,1,ISPIN)=(0.D0,0.D0)
	TCH(ISYM,IATOM,2,ISPIN)=(0.D0,0.D0)
	DO 140 IPOL=0,NPOL(ISORT)            !!! over ipol
C	TCH(ISYM,IATOM,1,ISPIN)=TCH(ISYM,IATOM,1,ISPIN)+SQPI4*
C    &  AR(IPOL,1)*CONVRO(IPOL,ISYM,IATOM,ISPIN)
	TCH(ISYM,IATOM,2,ISPIN)=TCH(ISYM,IATOM,2,ISPIN)+SQPI4*
     &  AR(IPOL,2)*CONVRO(IPOL,ISYM,IATOM,ISPIN)
 140	CONTINUE                             !!! over ipol
	ENDIF                                !!! only for non-zero components
 150	CONTINUE                             !!! over m
 160	CONTINUE                             !!! over l
 170	CONTINUE                             !!! over atoms
 180	CONTINUE                             !!! over spins
	END




	SUBROUTINE RENROV
****************************************************************
*  Renormalize valence density according to the input charge   *
*  Written by S.Yu.Savrasov (P.N.Lebedev Physical Institute)   *
****************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	PARAMETER (LPLMAX=(2*LMAXV+1)**2)
	INTEGER ILSV(NSORTMAX),ILST(NSORTMAX),ILSB(NSORTMAX)
     &    ,IS(NPAT),NHSORT(NSORTMAX),LMSYM(LMMAXV,NPAT)
     & 	  ,NRAD(NSORTMAX),NSHE(NSORTMAX),NPOL(0:NSORTMAX)
	DIMENSION SMT(NSORTMAX),RINT(0:NSHEMAX,NSORTMAX),SROU(NSORTMAX)
     &    ,Z(NSORTMAX),ZCOR(NSORTMAX),C(0:LMAXV+1,LMMAXV1,LMMAXV1)
     &    ,H(NSORTMAX),R(0:NRADMAX,NSORTMAX),DR(0:NRADMAX,NSORTMAX)
     &    ,WEIGHT(0:NRADMAX,NSORTMAX),WORK1(0:NRADMAX),WORK2(0:NRADMAX)
     &    ,XINT(0:NSHEMAX,NSORTMAX),TT(0:NPOLMAX,0:NSHEMAX,NSORTMAX)
     & 	  ,RL(0:NRADMAX,0:LMAXV,NSORTMAX)
	COMPLEX*16 ROINT(0:NSHEMAX,NSYMMAX,NPAT,NSPINMAX)
     &    ,DIM,RMAT(0:NPOLMAX,LPLMAX),TMAT(0:NPOLMAX,0:NPOLMAX)
     &    ,ROVALDS(3,NSYMMAX,NPAT,NSPINMAX)
     &    ,RO(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX)
     &    ,ROCINT(0:NSHEMAX,NSYMMAX,NPAT,NSPINMAX)
     &    ,ROCOR(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX)
     &    ,CHEBRO(0:NPOLMAX,NSYMMAX,NPAT,NSPINMAX)
     &    ,CONVRO(0:NPOLMAX,NSYMMAX,NPAT,NSPINMAX),ROVAL
	LOGICAL SYM(LMMAXV,NPAT)
	CHARACTER TXTEL(NSORTMAX)*10
	COMMON /CONTROL/MAN,LMTO,NLR,NINT                   !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT!!! from init
	COMMON /DENS/   RO,ROVALDS,ROCOR,ROINT,ROCINT       !!! from rofull
	COMMON /POTCOM/ SWZ,SMT                             !!! from init
	COMMON /MULTRO/ Z,ZCOR                              !!! from init
	COMMON /GAUNT/  C                                   !!! from gdata
	COMMON /SYMMLM/ SYM,LMSYM                           !!! from symlm
	COMMON /STORE2/ RMAT                                !!! from srfmsh
	COMMON /RADMESH/NRAD,H,R,DR,WEIGHT,RL               !!! from radmsh
	COMMON /INTMESH/NSHE,NPOL,SROU,RINT,XINT,TT         !!! from init
	COMMON /SPIN/   NSPIN                               !!! from init
	COMMON /UNIT/   IUN                                 !!! from init
	DATA PI/3.141592653589793D0/,DIM/(0.D0,1.D0)/
	SQPI4=2.D0*SQRT(PI)
	IF(NINT.EQ.0)RETURN
	ZVTOT=0.D0
	ZVALT=0.D0
	DO 175 ISPIN=1,NSPIN                 !!! over spins
	DO 170 IATOM=1,NATOM                 !!! over atoms
	ISORT=IS(IATOM)
	ST=SMT(ISORT)
C  FIND CHEBYSHEV COEFFICIENTS
	DO 40 L=0,ILSV(ISORT)                !!! over l
	DO 30 M=-L,L                         !!! over m
	LM=L*(L+1)+M+1
	IF(SYM(LM,IATOM))THEN
	ISYM=LMSYM(LM,IATOM)
	DO 20 IPOL=0,NPOL(ISORT)             !!! over polinoms
	CONVRO(IPOL,ISYM,IATOM,ISPIN)=(0.D0,0.D0)
	CHEBRO(IPOL,ISYM,IATOM,ISPIN)=(0.D0,0.D0)
	DO 10 I=1,NSHE(ISORT)                !!! over mesh points
	CHEBRO(IPOL,ISYM,IATOM,ISPIN)=
     &  CHEBRO(IPOL,ISYM,IATOM,ISPIN)+
     &  2.D0/NSHE(ISORT)*ROINT(I,ISYM,IATOM,ISPIN)*TT(IPOL,I,ISORT)
  10	CONTINUE                             !!! over mesh points
  20	CONTINUE                             !!! over polinoms
	ENDIF
  30	CONTINUE                             !!! over m
  40	CONTINUE                             !!! over l
C  READ SURFACE CONSTANTS FROM SCRATCH FILE 1
	DO 45 IPOL=0,NPOL(ISORT)
	IREC=IPOL+1+(NPOL(0)+1)*(IATOM-1)+NATOM+1
	READ(11,REC=IREC)(RMAT(IPOL,LM),LM=1,(2*ILSV(ISORT)+1)**2)
  45	CONTINUE
C  AND PERFORM CONVOLUTION WITH T-MATRIX
	DO 110 L2=0,2*ILSV(ISORT)
	LL2=L2/2
	DO 100 M2=-L2,L2
	L2M2=L2*(L2+1)+M2+1
	CALL CONVOLCH(NPOL(ISORT),RMAT(0,L2M2),TMAT(0,0),1)
	DO 90 L=0,ILSV(ISORT)                !!! over l
	DO 80 M=-L,L                         !!! over m
	LM=L*(L+1)+M+1
	IF(SYM(LM,IATOM))THEN                !!! only for non-zero components
	ISYM=LMSYM(LM,IATOM)
	DO 70 IPOL=0,NPOL(ISORT)             !!! over polinoms
	DO 60 L1=ABS(L-L2),L+L2,2            !!! over l1
	M1=M2+M                              !!! over m1
	IF(L1.LE.ILSV(ISORT).AND.ABS(M1).LE.L1)THEN
	L1M1=L1*(L1+1)+M1+1
	IF(SYM(L1M1,IATOM))THEN              !!! only for non-zero components
	ISYM1=LMSYM(L1M1,IATOM)
	DO 50 IPOL1=0,NPOL(ISORT)            !!! over polynoms
	IF(IPOL1+IPOL.LE.NPOL(ISORT))THEN    !!! when T.ne.0
	CONVRO(IPOL,ISYM,IATOM,ISPIN)=
     &  CONVRO(IPOL,ISYM,IATOM,ISPIN)+
     &  CHEBRO(IPOL1,ISYM1,IATOM,ISPIN)*
     &  C(LL2,L1M1,LM)*DIM**(L1-L)*
     &  TMAT(IPOL1,IPOL)
	ENDIF                                !!! when T.ne.0
  50	CONTINUE                             !!! over polynoms
	ENDIF                                !!! only for non-zero components
	ENDIF                                !!! over m1
  60	CONTINUE                             !!! over l1
  70	CONTINUE                             !!! over polinoms
	ENDIF                                !!! only for non-zero components
  80	CONTINUE                             !!! over m
  90	CONTINUE                             !!! over l
 100	CONTINUE                             !!! over m2
 110	CONTINUE                             !!! over l2
C  FIND CHARGES
	DO 120 IRAD=0,NRAD(ISORT)
	WORK1(IRAD)=RO(IRAD,1,IATOM,ISPIN)*WEIGHT(IRAD,ISORT)/
     &  SQRT(4.D0*PI)
 120	CONTINUE
	CALL QD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	ZVTOT=ZVTOT+WORK2(NRAD(ISORT))+SQRT(2.D0)*SQPI4*
     &  CONVRO(0,1,IATOM,ISPIN)
	ZVALT=ZVALT+(Z(ISORT)-ZCOR(ISORT))/DFLOAT(NSPIN)
 170	CONTINUE                             !!! over atoms
 175	CONTINUE                             !!! over spins
	IF(ABS(ZVALT).LE.1.D-10)
     &  STOP'<RENROV>: INTERNAL ERROR, VALENCE CHARGE IS ZERO'
C  RENORMALIZE VALENCE DENSITY
	ANORM=ZVALT/ZVTOT
	DO 230 ISPIN=1,NSPIN
	DO 220 IATOM=1,NATOM
	ISORT=IS(IATOM)
	DO 210 L=0,ILSV(ISORT)                !!! over l
	DO 200 M=-L,L                         !!! over m
	LM=L*(L+1)+M+1
	IF(SYM(LM,IATOM))THEN
	ISYM=LMSYM(LM,IATOM)
	DO 180 IRAD=0,NRAD(ISORT)
	ROVAL=RO(IRAD,ISYM,IATOM,ISPIN)*ANORM
	RO(IRAD,ISYM,IATOM,ISPIN)=ROVAL
 180	CONTINUE
	DO 190 ISHE=0,NSHE(ISORT)+1
	ROVAL=ROINT(ISHE,ISYM,IATOM,ISPIN)*ANORM
	ROINT(ISHE,ISYM,IATOM,ISPIN)=ROVAL
 190	CONTINUE
	DO 195 IPOL=0,NPOL(ISORT)
	CHEBRO(IPOL,ISYM,IATOM,ISPIN)=
     &  CHEBRO(IPOL,ISYM,IATOM,ISPIN)*ANORM
	CONVRO(IPOL,ISYM,IATOM,ISPIN)=
     &  CONVRO(IPOL,ISYM,IATOM,ISPIN)*ANORM
 195	CONTINUE
	ROVALDS(1,ISYM,IATOM,ISPIN)=
     &  RO(NRAD(ISORT),ISYM,IATOM,ISPIN)
	ROVALDS(2,ISYM,IATOM,ISPIN)=
     &  ROVALDS(2,ISYM,IATOM,ISPIN)*ANORM
	ROVALDS(3,ISYM,IATOM,ISPIN)=
     &  ROVALDS(3,ISYM,IATOM,ISPIN)*ANORM
	ENDIF
 200	CONTINUE
 210	CONTINUE
 220	CONTINUE
 230	CONTINUE
	WRITE(IUN,1010)ZVALT
	WRITE(IUN,1020)ZVTOT
	WRITE(IUN,1030)ANORM
1010	FORMAT(1X,'Valence charge in whole  elementary cell  must be ',
     &  G14.7)
1020	FORMAT(1X,'Valence charge  found via one-center expansion is ',
     &  G14.7)
1030	FORMAT(1X,'Renormalization coefficient of the val.density is ',
     &  G14.7)
	END
