	SUBROUTINE SRFMSH
**************************************************************
*  The calculation of the surface constants for integratoion *
*  over the interstitial region. The calculation of their    *
*  gradients with respect to the displacement of the origin. *
*  After Dima.Yu.Savrasov (P.N.Lebedev PhysicaL Institute)   *
*  Last revision: 02.12.92.                                  *
**************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	PARAMETER (LPLMAX=(2*LMAXV+1)**2)
	PARAMETER (NTRMAX=NENVMAX)
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,ILT(NPAT),ILTOLD(NPAT),NTR(NENVMAX),IREFAT(0:NVCMAX)
     &    ,LISTTR(3,NTRMAX,NENVMAX),NRAD(NSORTMAX),NCEL(NPAT)
     &    ,LMSYM(LMMAXV,NPAT),ICENV(0:NENVMAX,NPAT),NSHE(NSORTMAX)
     &    ,NPOL(0:NSORTMAX) 
	DIMENSION WR(NPAT),RMT(NPAT),POLIST(3,NVCMAX),SASA(NSORTMAX)
     &    ,WS(NVCMAX),POLI(3,NVCMAX),RMT0(NPAT),Z(NSORTMAX)
     &    ,TAU(3,NPAT),TAU0(3,NPAT),TAU00(3,NPAT),ZCOR(NSORTMAX)
     &    ,CENV(3,0:NENVMAX,NPAT)
	COMPLEX*16 RMAT(0:NPOLMAX,LPLMAX),SMAT(LPLMAX)
	CHARACTER*60 KOVFILE,SRFFILE,CONFILE,TXTEL(NSORTMAX)*10
     &    ,SCRFILE(100)
	LOGICAL SYM(LMMAXV,NPAT),SYMT(LPLMAX,NPAT)
	COMMON /CONTROL/MAN,LMTO,NLR,NINT,NPF               !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM       !!! from init
	COMMON /LATTICE/RBAS(3,3)                           !!! from init
	COMMON /BASIS/  TAU                                 !!! from init
	COMMON /BASIS0/ TAU0                                !!! from init
	COMMON /POTCOM/ SWZ,SMT(NSORTMAX)                   !!! from init
	COMMON /LATPAR/ PAR                                 !!! from init
	COMMON /OUT0/   SCRFILE                             !!! from init 
	COMMON /OUT1/   ISS,ISRF,IKOV                       !!! from init
	COMMON /OUT2/   CONFILE,SRFFILE,KOVFILE             !!! from init
	COMMON /STORE1/ NP0,POLIST,NTR,LISTTR               !!! from polidet
	COMMON /STORE2/ RMAT                                !!! from srfmsh
	COMMON /SYMMLM/ SYM,LMSYM                           !!! from symmlm
	COMMON /SRFINP/ NDIV1,NDIV2                         !!! from init
	COMMON /ASASPH/ SASA                                !!! from init
	COMMON /MULTRO/ Z,ZCOR                              !!! from init
	COMMON /INTMESH/NSHE,NPOL,SROU(NSORTMAX)            !!! from init
	COMMON /CELMESH/NCEL,CENV,ICENV                     !!! from srfmsh
	COMMON /RADMESH/NRAD                                !!! from init
	COMMON /UNIT/   IUN                                 !!! from init
	COMMON /WORD/   NVAL                                !!! from block
	COMMON /TXTEL/  TXTEL                               !!! from init
	DATA PI/3.141592653589793D0/
	SQPI43=SQRT(4.D0*PI/3.D0)
C  OPEN SCRATCH FILES
	NRECL=0             !!! estimate record lenght for the scratch file 
	DO 10 IATOM=1,NATOM
	ILT(IATOM)=2*ILSV(IS(IATOM)) !!! max.lmax for the surface constants 
	NRECL=MAX(NRECL,NVAL*(ILT(IATOM)+1)**2)
  10    CONTINUE
	NSHIFT=(NPOL(0)+1)*NATOM+NATOM+1
	OPEN(UNIT=9,FILE=SCRFILE(9),STATUS='OLD',FORM='UNFORMATTED')
	IF(ISRF.EQ.0)THEN            !!! temporary storage
	OPEN(UNIT=11,FILE=SCRFILE(11),STATUS='NEW',FORM='UNFORMATTED',
     &  ACCESS='DIRECT',RECL=NRECL)
	WRITE(11,REC=1)NRECL,NATOM,NPOL(0),ISRF
	ELSEIF(ABS(ISRF).EQ.1)THEN   !!! permanent storage
	OPEN(UNIT=11,FILE=SRFFILE,STATUS='NEW',FORM='UNFORMATTED',
     &  ACCESS='DIRECT',RECL=NRECL)
	WRITE(11,REC=1)NRECL,NATOM,NPOL(0),ISRF
	ELSEIF(ABS(ISRF).EQ.2)THEN   !!! storage was done before
	INQUIRE(FILE=SRFFILE,RECL=NRECL)
CWRONG  IF(WRONG)THEN                !!! wrong compiler option
	NRECL=NVAL
	OPEN(UNIT=11,FILE=SRFFILE,STATUS='OLD',FORM='UNFORMATTED',
     &  ACCESS='DIRECT',RECL=NRECL)
	READ(11,REC=1)NRECL
	CLOSE(11)
CWRONG  ENDIF
	OPEN(UNIT=11,FILE=SRFFILE,STATUS='OLD',FORM='UNFORMATTED',
     &  ACCESS='DIRECT',RECL=NRECL)
	READ(11,REC=1)NRECL,NATOM0,NPOL0,ISRF0
	IF(NATOM0.NE.NATOM)STOP'<SRFMSH>:: NUMBER OF ATOMS MISMATCH,
     &  SRFFILE MUST BE RECALCULATED'
	IF(NPOL0.NE.NPOL(0))STOP'<SRFMSH>:: NUMBER OF POLYNOMS MISMATCH,
     &  SRFFILE MUST BE RECALCULATED'
	ENDIF
C ***** DO GLOBALLY OVER ALL ATOMS IN CELL
	OMEGI=0.D0
	DO 1000 IATOM=1,NATOM                 !!! over atoms
	ISORT=IS(IATOM)
C SET UP ATOMIC CELL ENVELOPES AND STORE THEM
	READ(9) (TAU(K,IATOM),K=1,3)
	READ(9) RMIN,RMAX,RMT(IATOM),RV,VOL
	READ(9) NP0,((POLIST(K,I),K=1,3),I=1,NP0)
	READ(9) NGR,(NTR(I),I=1,NGR)
	READ(9) (((LISTTR(K,I,J),K=1,3),I=1,NTR(J)),J=1,NGR)
	READ(9) ((POLI(K,I),K=1,3),I=1,NGR)
	READ(9) (WS(I),I=1,NGR),(IREFAT(I),I=0,NGR)
	OMEGI=OMEGI+VOL*PAR**3
	SASA(IS(IATOM))=(3.D0/4.D0/PI*VOL)**(1.D0/3.D0)*PAR
C FIND ENVIRONMENT VECTORS 
	CENV(1,0,IATOM)=0.D0
	CENV(2,0,IATOM)=0.D0
	CENV(3,0,IATOM)=0.D0
	ICENV(0,IATOM)=IATOM
	RLCL=0.D0
	DO 110 IPL=1,NGR
	CENV(1,IPL,IATOM)=POLI(1,IPL)
	CENV(2,IPL,IATOM)=POLI(2,IPL)
	CENV(3,IPL,IATOM)=POLI(3,IPL)
	RT=SQRT(POLI(1,IPL)**2+POLI(2,IPL)**2+POLI(3,IPL)**2) 
	RLCL=MAX(RLCL,RT)
	ICENV(IPL,IATOM)=IREFAT(IPL)
 110    CONTINUE
	NCEL(IATOM)=NGR
	IF(NGR.GT.NENVMAX)STOP'<SRFMSH>: NENVMAX MUST BE INCREASED
     &  IN PARAM.DAT'
	ALF=(SMT(IS(IATOM))+SROU(IS(IATOM)))/PAR/2.D0
	BET=(SROU(IS(IATOM))-SMT(IS(IATOM)))/PAR/2.D0
	IF(ABS(ISRF).NE.2)THEN     
	WRITE(IUN,1010)(TAU(I,IATOM),I=1,3),TXTEL(IS(IATOM))
C  SEVEN POINTS TRIANGLE QUADRATURE CALCULATION OF R(n,L)
	IREC=IATOM+1
	WRITE(11,REC=IREC)ILT(IATOM),ALF,BET,(TAU(K,IATOM),K=1,3)
	CALL POLIX7(NPOL(IS(IATOM)),NP0,POLIST,NTR,LISTTR,ALF,BET,
     &  ILT(IATOM),RMAT,NGR,NDIV2,NMSH)
	WRITE(IUN,1020)RLCL,NGR,NPOL(IS(IATOM)),NMSH
	EPS=(VOL-4.D0*PI/3.D0*(SMT(IS(IATOM))/PAR)**3)/2.D0/SQRT(PI)
	EPS1=DREAL(RMAT(0,1))
	DEPS=ABS(EPS-EPS1)
C       RMAT(0,1)=DCMPLX(EPS,0.D0)   !!! Reset interstitial volume
	WRITE(IUN,1030) DEPS,TXTEL(IS(IATOM))
	DO 120 IPOL=0,NPOL(IS(IATOM))  !!! over polynoms
	IREC=IPOL+1+(NPOL(0)+1)*(IATOM-1)+NATOM+1
	WRITE(11,REC=IREC)(RMAT(IPOL,LM),LM=1,(ILT(IATOM)+1)**2)
 120    CONTINUE                       !!! over polynoms
	ELSEIF(ABS(ISRF).EQ.2)THEN
C  CHECK OUT PREVIOUS CALCULATION
	IREC=IATOM+1
	READ(11,REC=IREC)ILTOLD(IATOM),ALF1,BET1,(TAU00(K,IATOM),K=1,3)
	ABST=0.D0
	DO 130 K=1,3
	ABST=ABST+ABS(TAU(K,IATOM)-TAU00(K,IATOM))
 130    CONTINUE
	IF(ABST.GE.1.D-10)
     &  PRINT*,'POSITIONS OF ATOMS MISMATCH IN <SRFFILE>'
	IF(ILTOLD(IATOM).LT.ILT(IATOM))
     &  STOP'<SRFMSH>: LMAX MISMATCH, SRFFILE MUST BE RECALCULATED'
	IF(ABS(ALF1-ALF).GE.1.D-10)
     &  PRINT*,'<SRFMSH>: MT,ROU-SPHERE MISMATCH,
     &  SRFFILE MUST, IN PRINCIPLE, BE RECALCULATED' 
	IF(ABS(BET1-BET).GE.1.D-10)
     &  PRINT*,'<SRFMSH>: MT,ROU-SPHERE MISMATCH,
     &  SRFFILE MUST, IN PRINCIPLE, BE RECALCULATED' 
	ENDIF
1000    CONTINUE                              !!! over atoms
C  VOLUME CHECKING
	OMEGA=4.D0*PI/3.D0*SWZ**3*NATOM
	IF(ABS(OMEGI-OMEGA).GE.1.D-06)WRITE(IUN,1040)OMEGA,OMEGI
	REWIND(UNIT=9)
C  DEFINE NON-ZERO COMPONENTS
	DO 240 IATOM=1,NATOM                  !!! over atoms
	DO 210 IPOL=0,NPOL(IS(IATOM))         !!! over polynoms
	IREC=IPOL+1+(NPOL(0)+1)*(IATOM-1)+NATOM+1
	READ(11,REC=IREC)(RMAT(IPOL,LM),LM=1,(ILT(IATOM)+1)**2)
 210    CONTINUE                       !!! over polynoms
	DO 230 LM=1,(ILT(IATOM)+1)**2
	SYMT(LM,IATOM)=.FALSE.
	SUM=0.D0
	DO 220 IPOL=0,NPOL(IS(IATOM))
	SUM=SUM+ABS(RMAT(IPOL,LM))
 220    CONTINUE
	IF(SUM.GE.1.D-14)SYMT(LM,IATOM)=.TRUE.
 230    CONTINUE
 240    CONTINUE                          !!! over atoms in cell
1010  FORMAT(1X,'Position : (',G12.5,',',G12.5,',',G12.5,') ',A10)
1020  FORMAT(1X,'localiz. sphere is ',G14.7,' ; npln=',I3,',npol=',
     &  I3,',nmsh=',I5)
1030  FORMAT(1X,'int-volume difference is ',G14.7,1X,a10)
1040  FORMAT(1X,'Error in volume definition : exact value is ',G14.7,' ,
     &  value found is ',G14.7)
	END




	SUBROUTINE CONVOLCH(NPOL,TN,TCH,KEY)
**************************************************************
*  Subroutine for the convolution of the power matrix tn(n)  *
*  in a matrix tch(m,k) defined for two Chebyshev polinoms.  *
**************************************************************
	INCLUDE 'PARAM.DAT'
	IMPLICIT REAL*8 (A-H,O-Z)
	DIMENSION C(0:NPOLMAX,0:NPOLMAX),CP(0:NPOLMAX,0:NPOLMAX,2)
	COMPLEX*16 TN(0:NPOLMAX),TCH(0:NPOLMAX,0:NPOLMAX),SS
	COMMON /LATPAR/ PAR           !!! lattice parameter coming from init
	SAVE ICALL,C,CP
	DATA ICALL/1/
	IF(ICALL.EQ.1) THEN
	ICALL=0
	C(0,0)=1.D0
	C(0,1)=0.D0
	C(1,1)=1.D0
	DO 20 I=2,NPOLMAX
	DO 10 J=1,I
	C(J,I)=C(J-1,I-1)*2.D0-C(J,I-2)
  10    CONTINUE
	C(0,I)=-C(0,I-2)
  20    CONTINUE
	C(0,0)=C(0,0)/DSQRT(2.D0)
	DO 25 I=0,NPOLMAX
	DO 25 J=0,NPOLMAX
	CP(I,J,1)=C(I,J)*PAR**1.5D0
	CP(I,J,2)=C(I,J)*PAR
  25    CONTINUE
	ENDIF
C CONVOLUTION:
	IC=KEY
	DO 60 N=0,NPOL
	DO 50 M=0,N
	IF((N+M).LE.NPOL) THEN
	SS=(0.d0,0.d0)
	DO 40 I=0,N
	DO 30 J=0,M
	SS=SS+TN(I+J)*CP(I,N,IC)*CP(J,M,IC)
  30    CONTINUE
  40    CONTINUE
	TCH(N,M)=SS
	TCH(M,N)=TCH(N,M)
	ELSE
	TCH(N,M)=(0.D0,0.D0)
	TCH(M,N)=TCH(N,M)
	ENDIF
  50    CONTINUE
  60    CONTINUE
	RETURN
	END
