	SUBROUTINE STRMAT(IATOM,JATOM,SS,SR)
*******************************************************
*  The preparation of the Madelung matrix for the     *
*  calculation of multipoles.                         *
*  Written by S.Savrasov (Lebedev Physical Institute) *
*  Last revision: 30.11.92                            *
*******************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	PARAMETER (LPLMAX=(2*LMAXV+3)**2,NDTMAX=NPAT*NPAT)
	INTEGER IS(NPAT),ILST(NSORTMAX),IDELP(NPAT,NPAT)
     &    ,ILSB(NSORTMAX),ILSV(NSORTMAX),NKAP(NPANMAX)
	COMPLEX*16 SIGMA(LPLMAX),SIGMR(LPLMAX),SS(LMMAXV1,LMMAXV1)
     &    ,EK(NKAPMAX,NPANMAX),SR(LMMAXV1,LMMAXV1)
	DIMENSION C(0:LMAXV+1,LMMAXV1,LMMAXV1)
     &    ,GGNT(0:LMAXV+1,0:LMAXV+1,0:LMAXV+1)
	COMMON /CONTROL/MAN,LMTO,NLR,NINT                   !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM       !!! from init
	COMMON /POTCOM/ SWZ,SMT(NSORTMAX)                   !!! from init
	COMMON /VECGEN/ LIMDT                               !!! from vecgen
	COMMON /LM2STR/ IDELP                               !!! from vecgen
	COMMON /LATPAR/ PAR                                 !!! from init
	COMMON /GAUNT/  C,GGNT                              !!! from init
	COMMON /UNIT/   IUN                                 !!! from init
	COMMON /WORD/   NVAL                                !!! from nmtdata
	DATA PI/3.141592653589793D0/
C  RESTORE FULL S(L'L) MATRIX FOR ATOM "IATOM"
	ITAU=IDELP(IATOM,JATOM)
	READ(7,REC=ITAU)LIM4,(SIGMA(LM),LM=1,LIM4)
	CALL RLSTR(IATOM,JATOM,SIGMR)
	DO 40 L1=0,ILSV(IS(IATOM))+1                     !!! over l1
	DO 30 L =0,ILSV(IS(JATOM))+1                     !!! over l
	SOS=(SMT(IS(IATOM))/SWZ)**(L1+0.5)*(SMT(IS(JATOM))/SWZ)**(L+0.5)
	QSOSQ=SQRT(SMT(IS(IATOM))/2.D0)*SOS*SQRT(SMT(IS(JATOM))/2.D0)
	L2=L1+L
	LL2=L2/2
	DO 20 M1=-L1,L1                                  !!! over m1
	L1M1=L1*(L1+1)+M1+1
	DO 10 M =-L,L                                    !!! over m
	LM=L*(L+1)+M+1
	M2=M1-M
	L2M2=L2*(L2+1)+M2+1
	SS(L1M1,LM)=C(LL2,L1M1,LM)*GGNT(LL2,L1,L)*SIGMA(L2M2)*
     &  QSOSQ
	SR(L1M1,LM)=C(LL2,L1M1,LM)*GGNT(LL2,L1,L)*(SIGMA(L2M2)-
     &  SIGMR(L2M2))*QSOSQ
  10	CONTINUE                                         !!! over m
  20	CONTINUE                                         !!! over m1
  30	CONTINUE                                         !!! over l
	IF(L1.EQ.1)SS(L1M1,L1M1)=SS(L1M1,L1M1)+
     &  3.D0/NATOM/SWZ**3*SMT(IS(IATOM))**2*SMT(IS(JATOM))**2
	IF(L1.EQ.1)SR(L1M1,L1M1)=SR(L1M1,L1M1)+
     &  3.D0/NATOM/SWZ**3*SMT(IS(IATOM))**2*SMT(IS(JATOM))**2
  40	CONTINUE                                         !!! over l1
  50	CONTINUE                                         !!! over jatom
	END




	SUBROUTINE RLSTR(IATOM,JATOM,SIGMR)
*******************************************************
*   Calculate part of the lattice sum which has bad   *
*   convergency with respect to l.                    *
*   Last revision: 24.03.93, S.S.                     *
*******************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	PARAMETER (NDTMAX=NPAT*NPAT,LPLMAX=(2*LMAXV+3)**2)
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX),IS(NPAT)
     &    ,NCEL(NPAT),ICENV(0:NENVMAX,NPAT)
	COMPLEX*16 SIGMR(LPLMAX),YLM(LPLMAX),DIM,COEF,DIML
     &    ,HAN(3,0:2*LMAXV+2)
	DIMENSION SMT(NSORTMAX),CENV(3,0:NENVMAX,NPAT),TAU(3,NPAT)
	CHARACTER*60 CONFILE
	LOGICAL FIRST,LOG
	COMMON /CONTROL/LIFT,LMTO,NCOU,NINT                     !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM           !!! from init
	COMMON /BASIS/  TAU                                     !!! from init
	COMMON /POTCOM/ SWZ,SMT                                 !!! from init
	COMMON /LATPAR/ PAR                                     !!! from init
	COMMON /CELMESH/NCEL,CENV,ICENV                         !!! from srfmsh
	COMMON /UNIT/   IUN                                     !!! from init
	DATA PI/3.141592653589793D0/,FIRST/.TRUE./,DIM/(0.D0,1.D0)/
	SQPI4=SQRT(4.D0*PI)
	ISORT=IS(IATOM)
	JSORT=IS(JATOM)
C INITIALIZE SIGMR
	ILSMAX=ILSV(ISORT)+ILSV(JSORT)+2 
	DO 20 L=0,ILSMAX
	DO 10 M=-L,L
	LM=L*(L+1)+M+1
	SIGMR(LM)=(0.D0,0.D0)
  10	CONTINUE
  20	CONTINUE
C ****  DO GLOBALLY OVER ALL NEAREST NEIGHBORS OF "IATOM" *****
	DO 50 IENV=1,NCEL(IATOM)
	IF(ICENV(IENV,IATOM).NE.JATOM)GOTO50
	IF(NCOU.EQ.0)GOTO50
	TX=CENV(1,IENV,IATOM)
	TY=CENV(2,IENV,IATOM)
	TZ=CENV(3,IENV,IATOM)
	TT=SQRT(TX*TX+TY*TY+TZ*TZ)
	CALL SPHHARM(TX/TT,TY/TT,TZ/TT,ILSMAX,YLM)
	CALL HANKEL(TT,(0.D0,0.D0),SWZ/PAR,HAN,ILSMAX)
	DIML=DIM
	DO 40 L=0,ILSMAX
	DIML=-DIM*DIML
	COEF=SQPI4*DIML*HAN(1,L)
	DO 30 M=-L,L
	LM=L*(L+1)+M+1
	SIGMR(LM)=SIGMR(LM)+COEF*DCONJG(YLM(LM))
  30	CONTINUE
  40	CONTINUE
  50	CONTINUE
	END

