	   SUBROUTINE STRMSH
**************************************************************
*  The preparation of the structure constants for the        *
*  LMTO method  at different energies and their energy       *
*  derivatives (following from the KKR)                      *
*  The symmetry analysis of the crystalline structure and    *
*  determination of the point group (possibly nonsymmorphic) *
*  Written by S.Yu.Savrasov (P.N.Lebedev PhysicaL Institute) *
**************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	PARAMETER (LPLMAX=(2*LMAXV+3)**2,NDTMAX=NPAT*NPAT
     &    ,LDLMAX=(2*LMAXB+2)**2,LTLMAX=(LMAXT+1+LMAXB+1)**2)
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX)
     &    ,LIMLPL2(NDTMAX),ILS2(NDTMAX),LIMLPL4(NDTMAX)
     &    ,LIMLDL2(NDTMAX),ILD2(NDTMAX),LIMLDL4(NDTMAX)
     &    ,LIM2OLD(NDTMAX),LIM4OLD(NDTMAX),NKAP(NPANMAX)
     &    ,LID2OLD(NDTMAX),NDIV(3),NDIC(3),ILS4(NDTMAX)
     &    ,NKAP0(NPANMAX),IDELP(NPAT,NPAT),NPNT(NPANMAX)
     &    ,ILSV(NSORTMAX),ILD4(NDTMAX)
	COMPLEX*16 EK(NKAPMAX,NPANMAX),EKAP(NKAPMAX,NPANMAX)
     &    ,EKOLD(NKAPMAX,NPANMAX),SIGMA(LTLMAX,NDTMAX,NKAPMAX)
     &    ,SIGMADOT(LDLMAX,NDTMAX,NKAPMAX)
     &    ,SIGMM(LPLMAX,NDTMAX)
	DIMENSION PNT(3,KMAX,NPANMAX),HSPNT(3,2,KMAX),SH(3,NPANMAX)
     &    ,DELTAU(3,NDTMAX)
	CHARACTER*60 KOVFILE,FTRFILE,CONFILE,SCRFILE(100),SYS*1
	LOGICAL FIRST
	COMMON /CONTROL/LIFT,LMTO                           !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM       !!! from init
	COMMON /LATTICE/A(3,3)                              !!! from init
	COMMON /BASIS0/ TAU0(3,NPAT)                        !!! from init
	COMMON /BASIS/  TAU(3,NPAT)                         !!! from init
	COMMON /OUT1/   ICON,IFTR,IKOV,IWF,ITMP,IBND        !!! from init
	COMMON /OUT2/   CONFILE,FTRFILE,KOVFILE             !!! from init
	COMMON /DENS/   SIGMA,SIGMADOT                      !!! from dstr,hstr
	COMMON /VECGEN/ LIMDT,DELTAU                        !!! from vecgen
	COMMON /LM2STR/ IDELP,NR2,ILS2,ILD2,LIMLPL2,LIMLDL2 !!! from vecgen
	COMMON /LM4STR/       NR4,ILS4,ILD4,LIMLPL4,LIMLDL4 !!! from vecgen
	COMMON /INTTR/  NDIV,NDIC,SH,NDIR,HSPNT             !!! from init
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP,EDGE              !!! from init
	COMMON /GROUPOUT/NGROUP                             !!! from group
	COMMON /MESH/   NPNT,PNT                            !!! from ttrmsh
	COMMON /OUT0/   SCRFILE                             !!! from init
	COMMON /ORBS/   NORBS                               !!! from init
	COMMON /SPIN/   NSPIN                               !!! from init
	COMMON /UNIT/   IUN                                 !!! from init
	COMMON /WORD/   NVAL                                !!! from nmtdata
        EQUIVALENCE (SIGMA(1,1,1),SIGMM(1,1))
	DATA PI/3.141592653589793D0/,EPS/1.D-05/
C  INITIATION
	LMMT=0
	LMMB=0
	LMMV=0
	DO 10 IATOM=1,NATOM
	LMMT=MAX(LMMT,ILST(IS(IATOM)))   !!! maximum lmaxt for all atoms
	LMMB=MAX(LMMB,ILSB(IS(IATOM)))   !!! maximum lmaxb for all atoms
	LMMV=MAX(LMMV,ILSV(IS(IATOM)))   !!! maximum lmaxv for all atoms
  10    CONTINUE
	LMMC=MAX(LMMT+1,LMMV+1)
C  CALCULATE TRANSFORMATION MATRICES
	IF(IKOV.EQ.1)SYS='C'
	IF(IKOV.EQ.2)SYS='H'    
	IF(IKOV.EQ.3)SYS='A'    
	CALL WIGMAT(LMMT,SYS,KOVFILE)
	CALL GROUPS(A,TAU0,IS,LMMT,NATOM,NSPIN,NORBS,EPS,1)
	WRITE(IUN,1010)NGROUP
	CALL WIGMAT(LMMT,SYS,KOVFILE)
	CALL GROUPS(A,TAU, IS,LMMT,NATOM,NSPIN,NORBS,EPS,2)
	WRITE(IUN,1020)NGROUP
	CALL KELITAB              !!! calculate Keli table
C  K-MESH CONSTRUCTION
	IF(ABS(IBND).NE.1)CALL SBZMESH(NDIV,NDIC)
	IF(ABS(IBND).EQ.1)CALL HSMSH(NDIV,HSPNT,NDIR)
	WRITE(IUN,1030)NPNT(1)
	IF(NPAN.GT.1)WRITE(IUN,1040)NPNT(NPAN)
C  GENERATE STR.VECTORS AND CHECK SINGULARITIES IN STR.CONSTANTS
	CALL GDATA(LMMC)          !!! calculate Gaunt-coefficients
	CALL SYMLMM               !!! calculate some logical arrays
C  STORE CHARGE DENSITY IN ORDER TO USE SOME MEMORY
	CALL WRITERO(0)           !!! store charge density
	CALL SVECGEN              !!! generate structure vectors
	IF(LMTO.LE.2)CALL CHECKS  !!! check singularities in str.con
C  OPEN FILE FOR SIGMA-CONSTANTS
	IF(ICON.EQ.1.AND.LMTO.LE.2)THEN
	OPEN(8,FILE=CONFILE,STATUS='NEW',FORM='UNFORMATTED',
     &  ACCESS='DIRECT',RECL=NR2)
	WRITE(8,REC=1)NR2,LMTO,NDIV(1),NDIC(1),NPNT(1),NPNT(NPAN),
     &  NATOM,LIMDT,NPAN,(NKAP(IPAN),IPAN=1,NPAN),((EK(IKAP,IPAN),
     &  IKAP=1,NKAP(IPAN)),IPAN=1,NPAN),LMTO
C  TEST INPUT DATA
	ELSEIF(ICON.EQ.2)THEN    !!! test input data !!!
	INQUIRE(FILE=CONFILE,RECL=NR2)
CWRONG  IF(WRONG)THEN           !!! wrong compiler statement
	NR2=NVAL
	OPEN(8,FILE=CONFILE,STATUS='OLD',FORM='UNFORMATTED',
     &  ACCESS='DIRECT',RECL=NR2)
	READ(8,REC=1)NR2
	CLOSE(8)
CWRONG  ENDIF
	OPEN(8,FILE=CONFILE,STATUS='OLD',FORM='UNFORMATTED',
     &  ACCESS='DIRECT',RECL=NR2)
	READ(8,REC=1)NR2,LMTO0,NDIV0,NDIC0,NPNT0,NPNTP,NATOM0,
     &  LIMDT0,NPAN0,(NKAP0(IPAN),IPAN=1,NPAN0),((EKOLD(IKAP,IPAN),
     &  IKAP=1,NKAP0(IPAN)),IPAN=1,NPAN0)
	IF(LMTO.EQ.3.AND.LMTO0.LT.2)STOP
     &  '<STRMSH>: BARE STRCON IN CONFILE WHILE LMTO=3'
	IF(LMTO.LE.2.AND.LMTO0.EQ.3)STOP
     &  '<STRMSH>: SCREENED STRCON IN CONFILE WHILE LMTO=1/2'
	DO 30 ITAU=1,LIMDT0
	IREC=ITAU+1
	READ(8,REC=IREC)LIM2OLD(ITAU),LID2OLD(ITAU)
  30    CONTINUE
	IF(NDIV0.NE.NDIV(1))
     &  STOP '<STRMSH>: NUMBER OF DIVISIONS MISMATCH,
     &  CONFILE MUST BE RECALCULATED'
	IF(LIMDT0.NE.LIMDT)STOP '<STRMSH>: NUMBER OF CONNECTING 
     &  VECTORS MISMATCH, CONFILE MUST BE RECALCULATED'
	IF(NPAN.NE.NPAN0)STOP '<STRMSH>: # OF PANELS MISMATCH,
     &  CONFILE MUST BE RECALCULATED'
	DO 50 IPAN=1,NPAN
	IF(NKAP(IPAN).NE.NKAP0(IPAN))
     &  STOP '<STRMSH>: # OF KAPPAS MISMATCH,
     &  CONFILE MUST BE RECALCULATED'
	DO 40 IKAP=1,NKAP(IPAN)
	IF(ABS(EK(IKAP,IPAN)-EKOLD(IKAP,IPAN)).GE.1.D-08)
     &  STOP '<STRMSH>:TAIL KAPPAS MISMATCH,
     &  CONFILE MUST BE RECALCULATED'
  40    CONTINUE
  50    CONTINUE
	DO 60 ITAU=1,LIMDT
	IF(LIMLPL2(ITAU).GT.LIM2OLD(ITAU))
     &  STOP '<STRMSH>: LMAX(T+B) MISMATCH,
     &  CONFILE MUST BE RECALCULATED'
	IF(LIMLDL2(ITAU).GT.LID2OLD(ITAU))
     &  STOP '<STRMSH>: LMAX(T+B)-DOT MISMATCH,
     &  CONFILE MUST BE RECALCULATED'
  60    CONTINUE
	CLOSE(8)
	ENDIF
C  ******* COMPUTE SIGMA-CONSTANTS IF NECESSARY ******
	IF(ICON.EQ.1.AND.LMTO.LE.2)THEN
	IREC=1
	DO 110 IPAN=1,NPAN                    !!! over energy panels
	FIRST=.TRUE.
	DO 100 IPNT=1,NPNT(IPAN)              !!! over k-points
	XK=PNT(1,IPNT,IPAN)+SH(1,IPAN)
	YK=PNT(2,IPNT,IPAN)+SH(2,IPAN)
	ZK=PNT(3,IPNT,IPAN)+SH(3,IPAN)
	IF(IPAN.EQ.1.OR.(DREAL(EKAP(1,IPAN)).GE.EDGE.AND.IPAN.NE.1))
     &  CALL DSTR(XK,YK,ZK,ILS2,ILD2,NKAP(IPAN),EK(1,IPAN),FIRST,
     &  LTLMAX,LDLMAX,NKAPMAX,SIGMA,SIGMADOT)
	IF(IPAN.NE.1.AND.DREAL(EKAP(1,IPAN)).LT.EDGE)
     &  CALL HSTR(XK,YK,ZK,ILS2,ILD2,NKAP(IPAN),EK(1,IPAN),FIRST,
     &  LTLMAX,LDLMAX,NKAPMAX,SIGMA,SIGMADOT)
	FIRST=.FALSE.
	DO 90 IKAP=1,NKAP(IPAN)
	DO 80 ITAU=1,LIMDT
	IREC=IREC+1
	WRITE(8,REC=IREC)LIMLPL2(ITAU),LIMLDL2(ITAU),
     &  (SIGMA(LM,ITAU,IKAP),LM=1,LIMLPL2(ITAU)),
     &  (SIGMADOT(LM,ITAU,IKAP),LM=1,LIMLDL2(ITAU))
  80    CONTINUE
  90    CONTINUE
 100    CONTINUE                             !!! over k-points
 110    CONTINUE                             !!! over energy panels
	CLOSE(8)
	ENDIF
C   CALCULATE MADELUNG MATRIX AND STORE IT
        OPEN(7,FILE=SCRFILE(7),STATUS='NEW',FORM='UNFORMATTED',
     &  ACCESS='DIRECT',RECL=NR4)
        CALL DSTR(0.D0,0.D0,0.D0,ILS4,ILD4,1,(0.D0,0.D0),.TRUE.,
     &  LPLMAX,1,1,SIGMM,SIGMADOT)
        DO 120 ITAU=1,LIMDT
        WRITE(7,REC=ITAU)LIMLPL4(ITAU),
     &  (SIGMM(LM,ITAU),LM=1,LIMLPL4(ITAU))
 120    CONTINUE
1010    FORMAT(1X,I4,' elements discovered for original   lattice')
1020    FORMAT(1X,I4,' elements found      for distorted  lattice')
1030    FORMAT(1X,I4,' k-points generated  for main valence panel')
1040    FORMAT(1X,I4,' k-points generated  for semicore    panels')
	END


	SUBROUTINE HSMSH(NDIV,HSPNT,NDIR)
******************************************************
* Construction of the k-mesh in arbitrary directions *
******************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER NPNT(NPANMAX)
	DIMENSION HSPNT(3,2,KMAX),PNT(3,KMAX,NPANMAX)
	COMMON /KAPPAR/NPAN
	COMMON /MESH/  NPNT,PNT
	NP=0
	DO 30 ND=1,NDIR
	DX=HSPNT(1,2,ND)-HSPNT(1,1,ND)
	DY=HSPNT(2,2,ND)-HSPNT(2,1,ND)
	DZ=HSPNT(3,2,ND)-HSPNT(3,1,ND)
		DO 20 I=1,NDIV+1
		NP=NP+1
		PNT(1,NP,1)=HSPNT(1,1,ND)+DX*(I-1)/NDIV
		PNT(2,NP,1)=HSPNT(2,1,ND)+DY*(I-1)/NDIV
		PNT(3,NP,1)=HSPNT(3,1,ND)+DZ*(I-1)/NDIV
  20            CONTINUE
  30    CONTINUE
	NPNT(1)=NP
	DO 40 IPAN=2,NPAN
	NPNT(IPAN)=0
  40    CONTINUE
	END




	SUBROUTINE CHECKS
****************************************************************
*    Check the singularities in the structure constants        *
*    by calculating the difference between free-electron       *
*    energies and input tail energies.                         *
****************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	PARAMETER (NDTMAX=NPAT*NPAT)
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,NKAP(NPANMAX),NPNT(NPANMAX)
	DIMENSION PNT(3,KMAX,NPANMAX),RBAS(3,3),GBAS(3,3)
     &    ,DELTAU(3,NDTMAX),GVEC(3,NVCMAX),RVEC(3,NVCMAX)
	COMPLEX*16 EK(NKAPMAX,NPANMAX),EKAP(NKAPMAX,NPANMAX)
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM       !!! from init
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                   !!! from init
	COMMON /VECGEN/ LIMDT,DELTAU,NRVEC,RVEC,NGVEC,GVEC  !!! from vecgen
	COMMON /MESH/   NPNT,PNT                            !!! from ttrmsh
	COMMON /UNIT/   IUN                                 !!! from init
	DATA PI/3.141592653589793D0/
	DO 50 IPAN=1,1 ! NPAN
	DO 40 IKAP=1,NKAP(IPAN)
	DIFMIN=10.D+10
	DO 30 IPNT=1,NPNT(IPAN)
	DO 20 IGVEC=1,NGVEC
	GKX=GVEC(1,IGVEC)+PNT(1,IPNT,IPAN)
	GKY=GVEC(2,IGVEC)+PNT(2,IPNT,IPAN)
	GKZ=GVEC(3,IGVEC)+PNT(3,IPNT,IPAN)
	GK2=GKX*GKX+GKY*GKY+GKZ*GKZ
	DIF=ABS(GK2-DREAL(EK(IKAP,IPAN))/4.D0/PI/PI)
	DIFMIN=MIN(DIFMIN,DIF)
  20    CONTINUE
  30    CONTINUE
	WRITE(IUN,1010)IKAP,DIFMIN
	IF(DIFMIN+ABS(DIMAG(EK(IKAP,IPAN))).LE.1.D-10)
     &  PRINT*,' <CHECKS> : STR.CONSTANTS WILL BE SINGULAR'
  40    CONTINUE
  50    CONTINUE
1010    FORMAT(1X,'Minimum difference between |k+G|^2 and kappa',
     &  I1,'^2 is ',G14.7)
	END
