	SUBROUTINE TTRINT2(EF)
***********************************************************
*  The calculation of the integrals over whole Brillouin  *
*  zone :                                                 *
*    __  /  3    kj*     kj                               *
*    >   \ d k  C1      C2    tetta(E-E  )                *
*    --  /       l1m1,t  lmt           kj                 *
*    j   BZ                                               *
*  where theta is a Heaviside step-function.              *
*  The C-coefficients are the variational coefficients    *
*         kj                   __    kj     k             *
*        A          or         >    A      S              *
*         L t                  --    L"t"   Lt,L"t"       *
*                              L"t"                       *
*  i.e. their convolutions with the structure constants   *
*  which are transformed with help of the Wigner matrices *
*  after applying the point group operation.              *
*  Written by S.Savrasov in Max-Planck Institute, Germany *
***********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,IKOV(NOPRMAX),NHSORT(NSORTMAX),IS(NPAT),NKAP(NPANMAX)
     &   ,IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX)
     &   ,NBNDF(NPANMAX),NBNDE(NPANMAX),NBNDT(NPANMAX)
     &   ,NPNT(NPANMAX),IP(NPAT,NOPRMAX)
	COMPLEX*16 ATOSHH(LIMLMB,LIMLMB,NPAT),ATOSHJ(LIMLMB,LIMLMT,NPAT)
     &   ,ATOSJH(LIMLMT,LIMLMB,NPAT),ATOSJJ(LIMLMT,LIMLMT,NPAT)
     &   ,PFVAL(-1:1,NPAT,NPANMAX,NSPINMAX),PFTMP(-1:1,NPAT)
     &   ,ATMP1(-LMAXT:LMAXT,-LMAXT:LMAXT,NPAT,4)
     &   ,TMPARR(-LMAXT:LMAXT,4),U(NWIGMAX,48)
	DIMENSION PNT(3,KMAX,NPANMAX),SHIFT(3,NOPRMAX)
     &   ,RBAS(3,3),GBAS(3,3),RDC(3,NPAT,NOPRMAX)
	LOGICAL LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX),LOG1,LOG
     &   ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT!!! from init
	COMMON /MESH/   NPNT,PNT                            !!! from ttrmsh
	COMMON /KAPPAR/ NPAN,NKAP                           !!! from init
	COMMON /LATTICE/RBAS,GBAS                           !!! from init
        COMMON /PILAUF/ PFVAL                               !!! from tospar
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS               !!! from init
	COMMON /STORE1/ ATOSHH,ATOSJH,ATOSHJ,ATOSJJ         !!! from ttrint2
	COMMON /INVERS/ INV,IKOV                            !!! from group
	COMMON /GROUPOUT/NGROUP,U,IP,RDC,SHIFT              !!! from group
	COMMON /NBANDS/ NBNDF,NBNDE,NBNDT                   !!! from init
	COMMON /SPIN/   NSPIN                               !!! from init
	COMMON /WORD/   NVAL                                !!! from nmtdat
	COMMON /UNIT/   IUN                                 !!! from init
	DATA PI/3.141592653589793D0/
C DO THE SAME OPERATIONS FOR EVERY SPIN AND ENERGY PANEL
	DO 4000 IPAN=1,NPAN                            !!! over panels
	NSHIFT1=0
	NSHIFT2=0
	DO 10 JPAN=1,NPAN
	IF(JPAN.LT.IPAN)NSHIFT1=NSHIFT1+NKAP(JPAN)**2
	NSHIFT2=NSHIFT2+NKAP(JPAN)**2
  10    CONTINUE
C *********** TETRAHEDRON METHOD FOR CONDUCTION BANDS *****
	DO 110 IPNT=1,NPNT(IPAN)                       !!! over k-points
C  COMPUTE INTEGRALS
	CALL TOSPAR(IPNT,IPAN,1)
 110    CONTINUE                                       !!! over k-points
C  ********  SYMMETRISATION OF THE MT-PART ********
	DO 3000 ISPIN=1,NSPIN                          !!! over spins
	DO 2000 IKAP=1,NKAP(IPAN)                      !!! over energies
	DO 1000 JKAP=1,NKAP(IPAN)                      !!! over energies
	DO 200 IATOM=1,NATOM                           !!! over iatom
	ISORT=IS(IATOM)
	IREC=IKAP+NKAP(IPAN)*(JKAP-1)+NKAP(IPAN)**2*(IATOM-1)+
     &  NSHIFT1*NATOM+NSHIFT2*NATOM*(ISPIN-1) 
	READ(21,REC=IREC)((ATOSHH(L1M1,LM,IATOM),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((ATOSJH(L1M1,LM,IATOM),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((ATOSHJ(L1M1,LM,IATOM),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &  ((ATOSJJ(L1M1,LM,IATOM),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
 200    CONTINUE                                       !!! over iatom
	ILSTMAX=0
	DO 210 ISORT=1,NSORT
	ILSTMAX=MAX(ILST(ISORT),ILSTMAX) 
 210    CONTINUE
	DO 330 L1=0,ILSTMAX                            !!! over l1
	NLS1=L1*(2*L1-1)*(2*L1+1)/3
	LP1=L1*L1+L1+1
	DO 320 L=0,ILSTMAX                             !!! over l
	NLS=L*(2*L-1)*(2*L+1)/3
	LP=L*L+L+1
	DO 280 IATOM=1,NATOM                           !!! over atoms in cell
	ISORT=IS(IATOM)
	LOG1=.FALSE.
	IF(LTPAN(L1,IATOM,IKAP,IPAN))LOG1=.TRUE.
	IF(L1.GT.ILST(ISORT))GOTO280
	LOG=.FALSE.
	IF(LTPAN(L,IATOM,JKAP,IPAN))LOG=.TRUE.
	IF(L.GT.ILST(ISORT))GOTO280
	DO 215 M1=-L1,L1                               !!! over m1
	DO 215 M=-L,L                                  !!! over m
	ATMP1(M1,M,IATOM,1)=(0.D0,0.D0)
	ATMP1(M1,M,IATOM,2)=(0.D0,0.D0)
	ATMP1(M1,M,IATOM,3)=(0.D0,0.D0)
	ATMP1(M1,M,IATOM,4)=(0.D0,0.D0)
 215    CONTINUE                                       !!! over m,m1
	DO 270 IR=1,NGROUP                             !!! over point group
	IG=IKOV(IR)
	DO 260 M=-L,L                                  !!! over m
	LM=LP+M
	MM=L+M+1
	DO 230 M2=-L1,L1
	L1M2=LP1+M2
	TMPARR(M2,1)=(0.D0,0.D0)
	TMPARR(M2,2)=(0.D0,0.D0)
	TMPARR(M2,3)=(0.D0,0.D0)
	TMPARR(M2,4)=(0.D0,0.D0)
	DO 220 M3=-L,L
	LM3=LP+M3
	IWIG03=NLS+(2*L+1)*(L+M3)+MM
	IF(LOG1.AND.LOG) 
     &  TMPARR(M2,1)=TMPARR(M2,1)+U(IWIG03,IG)*
     &  ATOSHH(L1M2,LM3,IP(IATOM,IR))
	IF(LOG) 
     &  TMPARR(M2,2)=TMPARR(M2,2)+U(IWIG03,IG)*
     &  ATOSJH(L1M2,LM3,IP(IATOM,IR))
	IF(LOG1) 
     &  TMPARR(M2,3)=TMPARR(M2,3)+U(IWIG03,IG)*
     &  ATOSHJ(L1M2,LM3,IP(IATOM,IR))
	TMPARR(M2,4)=TMPARR(M2,4)+U(IWIG03,IG)*
     &  ATOSJJ(L1M2,LM3,IP(IATOM,IR))
 220    CONTINUE
 230    CONTINUE
	DO 250 M1=-L1,L1                                   !!! over m1
	L1M1=LP1+M1
	MM1=L1+M1+1
	DO 240 M2=-L1,L1                                   !!! over m2
	IWIG12=NLS1+(2*L1+1)*(L1+M2)+MM1
	IF(LOG1.AND.LOG) 
     &  ATMP1(M1,M,IATOM,1)=ATMP1(M1,M,IATOM,1)+
     &  CONJG(U(IWIG12,IG))*TMPARR(M2,1)
	IF(LOG) 
     &  ATMP1(M1,M,IATOM,2)=ATMP1(M1,M,IATOM,2)+
     &  CONJG(U(IWIG12,IG))*TMPARR(M2,2)
	IF(LOG1) 
     &  ATMP1(M1,M,IATOM,3)=ATMP1(M1,M,IATOM,3)+
     &  CONJG(U(IWIG12,IG))*TMPARR(M2,3)
	ATMP1(M1,M,IATOM,4)=ATMP1(M1,M,IATOM,4)+
     &  CONJG(U(IWIG12,IG))*TMPARR(M2,4)
 240    CONTINUE                                         !!! over m2
 250    CONTINUE                                         !!! over m1
 260    CONTINUE                                         !!! over m
 270    CONTINUE                                         !!! over group
 280    CONTINUE                                         !!! over atoms in cell
C NORMALIZATION
	DO 310 IATOM=1,NATOM                             !!! over atoms in cell
	ISORT=IS(IATOM)
	LOG1=.FALSE.
	IF(LTPAN(L1,IATOM,IKAP,IPAN))LOG1=.TRUE.
	IF(L1.GT.ILST(ISORT))GOTO310
	LOG=.FALSE.
	IF(LTPAN(L,IATOM,JKAP,IPAN))LOG=.TRUE.
	IF(L.GT.ILST(ISORT))GOTO310 
	DO 300 M1=-L1,L1                                 !!! over m1
	L1M1=L1*(L1+1)+M1+1
	DO 290 M=-L,L                                    !!! over m
	LM=L*(L+1)+M+1
	IF(LOG1.AND.LOG)ATOSHH(L1M1,LM,IATOM)=ATMP1(M1,M,IATOM,1)/
     &  DBLE(NGROUP)
	IF(LOG)ATOSJH(L1M1,LM,IATOM)=ATMP1(M1,M,IATOM,2)/
     &  DBLE(NGROUP)
	IF(LOG1)ATOSHJ(L1M1,LM,IATOM)=ATMP1(M1,M,IATOM,3)/
     &  DBLE(NGROUP)
	ATOSJJ(L1M1,LM,IATOM)=ATMP1(M1,M,IATOM,4)/ 
     &  DBLE(NGROUP)
 290    CONTINUE                                        !!! over m
 300    CONTINUE                                        !!! over m1
 310    CONTINUE                                        !!! over atoms
 320    CONTINUE                                        !!! over l
 330    CONTINUE                                        !!! over l1
	DO 400 IATOM=1,NATOM
	ISORT=IS(IATOM)
	IREC=IKAP+NKAP(IPAN)*(JKAP-1)+NKAP(IPAN)**2*(IATOM-1)+
     &  NSHIFT1*NATOM+NSHIFT2*NATOM*(ISPIN-1) 
	WRITE(21,REC=IREC)((ATOSHH(L1M1,LM,IATOM),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((ATOSJH(L1M1,LM,IATOM),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILSB(ISORT)+1)**2),
     &  ((ATOSHJ(L1M1,LM,IATOM),
     &  L1M1=1,(ILSB(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2),
     &  ((ATOSJJ(L1M1,LM,IATOM),
     &  L1M1=1,(ILST(ISORT)+1)**2),LM=1,(ILST(ISORT)+1)**2)
 400    CONTINUE
1000    CONTINUE                                    !!! over energies
2000    CONTINUE                                    !!! over energies
C  SYMMETRIZE PULAY FORCE
        DO INUC=1,NATOM                             !!! over displacements
        DO MY=-1,1                                  !!! over polarizations
        PFTMP(MY,INUC)=(0.D0,0.D0)
        DO IR=1,NGROUP                              !!! over crystalline group
        IG=IKOV(IR)
        DO MY1=-1,1                                 !!! over polarizations
        IWIG=6+MY+3*MY1                             !!! U(L=1,MY,MY1)
        PFTMP(MY,INUC)=PFTMP(MY,INUC)+CONJG(U(IWIG,IG))*
     &  PFVAL(MY1,IP(INUC,IR),IPAN,ISPIN)
        ENDDO                                       !!! over polarizations
        ENDDO                                       !!! over crystalline group
        ENDDO                                       !!! over polarizations
        ENDDO                                       !!! over displacements
C  NORMALIZATION
        DO INUC=1,NATOM                             !!! over displacements
        DO MY=-1,1                                  !!! over polarizations
        PFRE=DREAL(PFTMP(MY,INUC))/DBLE(NGROUP)
        PFIM=DIMAG(PFTMP(MY,INUC))/DBLE(NGROUP)
C       IF(ABS(PFRE).LE.1.D-10)PFRE=0.D0
C       IF(ABS(PFIM).LE.1.D-10)PFIM=0.D0
        PFVAL(MY,INUC,IPAN,ISPIN)=DCMPLX(PFRE,PFIM)
        ENDDO                                       !!! over polarizations
        ENDDO                                       !!! over displacements
3000    CONTINUE                                    !!! over spins
4000    CONTINUE                                    !!! over panels
	END
