	SUBROUTINE TTRINT3(EF0,TOS,DOS)
***********************************************************
*  Calculate partial numbers and densities of states as   *
*  well as different moments of these.                    *
*  Written by S.Yu.Savrasov (Lebedev Physical Institute)  *
***********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,NHSORT(NSORTMAX),IS(NPAT),IP(NPAT,NOPRMAX)
     &   ,NKAP(NPANMAX),IKOV(NOPRMAX),NBNDF(NPANMAX)
     &   ,NBNDE(NPANMAX),NBNDT(NPANMAX),NPNT(NPANMAX)
	DIMENSION EARR(NDIMMAX*NSPINMAX,KMAX,NPANMAX)
     &   ,WEIGH(NDIMMAX*NSPINMAX,KMAX),PNT(3,KMAX,NPANMAX)
     &   ,WEIGD(NDIMMAX*NSPINMAX,KMAX),WGT(KMAX,NPANMAX)
     &   ,TOS(NPANMAX,0:1,NSPINMAX)
	COMPLEX*16 U(NWIGMAX,48)
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT !!! from init
	COMMON /MESH/   NPNT,PNT,WGT                         !!! from ttrmsh
	COMMON /ENERGY/ EARR,WEIGH,WEIGD                     !!! from lmtbnd
	COMMON /INVERS/ INV,IKOV                             !!! from group
	COMMON /GROUPOUT/NGROUP,U,IP                         !!! from group
	COMMON /KAPPAR/ NPAN,NKAP                            !!! from init
	COMMON /NBANDS/ NBNDF,NBNDE,NBNDT                    !!! from init
	COMMON /ORBS/   NORBS                                !!! from init
	COMMON /SPIN/   NSPIN                                !!! from init
	COMMON /UNIT/   IUN                                  !!! from init
	DATA PI/3.141592653589793D0/
C *********** INITIALIZATION **************
	EF=EF0
	DOS=0.D0
C *********** TETRAHEDRON METHOD FOR CONDUCTION BANDS ***********
	DO IPAN=1,NPAN                            !!! over panels
	DO ISPIN=1,NSPIN                          !!! over spins
	TOS(IPAN,0,ISPIN)=0.D0
	TOS(IPAN,1,ISPIN)=0.D0
	DO IPNT=1,NPNT(IPAN)                      !!! over k-points
	DO IBNDT=1,NBNDF(IPAN)                    !!! over bands 
	IBAND=ISPIN+NSPIN*(IBNDT-1)
	IF(IBNDT.GE.NBNDE(IPAN))THEN
	TOS(IPAN,0,ISPIN)=TOS(IPAN,0,ISPIN)+WEIGH(IBAND,IPNT)
	TOS(IPAN,1,ISPIN)=TOS(IPAN,1,ISPIN)+WEIGH(IBAND,IPNT)*
     &  EARR(IBAND,IPNT,IPAN)
	DOS=DOS+WEIGD(IBAND,IPNT)
	ELSEIF(IBNDT.LT.NBNDE(IPAN))THEN
	TOS(IPAN,0,ISPIN)=TOS(IPAN,0,ISPIN)+WGT(IPNT,IPAN)/DBLE(NSPIN)
	TOS(IPAN,1,ISPIN)=TOS(IPAN,1,ISPIN)+WGT(IPNT,IPAN)/DBLE(NSPIN)*
     &  EARR(IBAND,IPNT,IPAN)
	ENDIF
        ENDDO                                     !!! over valence bands
        ENDDO                                     !!! over k-points
        ENDDO                                     !!! over spins
C  AVERAGE IF SPIN-ORBIT COUPLING IS ON
	IF(NORBS.EQ.2)THEN
	DO I=0,1
	TBAR=(TOS(IPAN,I,1)+TOS(IPAN,I,NSPIN))/2.D0
	TOS(IPAN,I,1)=TBAR
	TOS(IPAN,I,NSPIN)=TBAR
	ENDDO
	ENDIF
        ENDDO                                     !!! over panels
	END
