        SUBROUTINE TTRVEL(EF0,DOS,VEL,SPDOS,SPVEL)
***********************************************************
*  The calculation of the mean square velocities at EF.   *
***********************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
        INCLUDE 'PARAM.DAT'
        INTEGER NHSORT(NSORTMAX),IS(NPAT),NPNT(NPANMAX)
     &   ,ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,NBNDF(NPANMAX),NBNDE(NPANMAX),NBNDT(NPANMAX)
     &   ,KCUT(3,4,6),IPQ(0:50,0:50,0:50),KTT(4),NDIV(3)
     &   ,IGQ(0:50,0:50,0:50)
        DIMENSION EARR(NDIMMAX*NSPINMAX,KMAX,NPANMAX)
     &   ,E(4),WEIGH(NDIMMAX*NSPINMAX,KMAX),WGT(KMAX,NPANMAX)
     &   ,WEIGD(NDIMMAX*NSPINMAX,KMAX),VEL(3),SPVEL(3,NSPINMAX)
     &   ,SPDOS(NSPINMAX),SPTOS(NSPINMAX),ORTH(2:3),RBAS(3,3)
     &   ,AT(4),AD(4),VK(3),GBAS(3,3),QB(3,3,2),RB(3,3,2),PKT(3,4)
     &   ,PNT(3,KMAX,NPANMAX)
        COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT    !!! from init
        COMMON /LATTICE/RBAS,GBAS,QB,RB                         !!! from init
        COMMON /MESH/   NPNT,PNT,WGT                            !!! from ttrmsh
        COMMON /WMESH/  KCUT,IPQ,IGQ                            !!! from bzmesh
        COMMON /ENERGY/ EARR,WEIGH,WEIGD                        !!! from lmtbnd
        COMMON /LATPAR/ PAR,ORTH,OMEGAC                         !!! from init
        COMMON /KAPPAR/ NPAN                                    !!! from init
        COMMON /NBANDS/ NBNDF,NBNDE,NBNDT                       !!! from init
        COMMON /ORBS/   NORBS                                   !!! from init
        COMMON /SPIN/   NSPIN                                   !!! from init
        COMMON /INTTR/  NDIV                                    !!! from init
        COMMON /UNIT/   IUN                                     !!! from init
        DATA PI/3.141592653589793D0/
	EF=EF0
	DO IBNDS=1,NSPIN
	SPTOS(IBNDS)=0.D0
	SPDOS(IBNDS)=0.D0
	SPVEL(1,IBNDS)=0.D0
	SPVEL(2,IBNDS)=0.D0
	SPVEL(3,IBNDS)=0.D0
	ENDDO
C  DO OVER WHOLE BRILLOUIN ZONE REPRESENTED BY MICROCELLS AND 
C  INTEGRATE OVER THE TETRAHEDRA
        VOLIBZ=1.D0
        OT=1.D0/NDIV(1)/NDIV(2)/NDIV(3)/6.D0
C  THE MICROCELL IS SET UP BY I1,I2,I3
C  SET UP TETRAHEDRA INSIDE MICROCELL
        DO I3=0,NDIV(3)-1                      !!! over cells along G3
        DO I2=0,NDIV(2)-1                      !!! over cells along G2
        DO I1=0,NDIV(1)-1                      !!! over cells along G1
	DO ITTR=1,6                            !!! over tetrahedra
C  COORDINATES OF THE TETRAHEDRON AGE GIVEN BY KTT
	DO I=1,4
	J1=I1+KCUT(1,I,ITTR)
	J2=I2+KCUT(2,I,ITTR)
	J3=I3+KCUT(3,I,ITTR)
	KTT(I)=IPQ(J1,J2,J3)
	PKT(1,I)=(J1*QB(1,1,1)+J2*QB(1,2,1)+J3*QB(1,3,1))*
     &  2.D0*PI/PAR
	PKT(2,I)=(J1*QB(2,1,1)+J2*QB(2,2,1)+J3*QB(2,3,1))*
     &  2.D0*PI/PAR
	PKT(3,I)=(J1*QB(3,1,1)+J2*QB(3,2,1)+J3*QB(3,3,1))*
     &  2.D0*PI/PAR
        ENDDO   
C  CALCULATE CONTRIBUTIONS FOR THESE POINTS
	IPAN=1
	DO IBNDS=1,NSPIN                       !!! over spin subbands
	DO IBNDT=1,NBNDT(1)                    !!! over bands
        IBAND=IBNDS+NSPIN*(IBNDT-1)
	DO I=1,4
	E(I)=EARR(IBAND,KTT(I),1)              !!! E(k,j)
        ENDDO    
	CALL GETVEL(E,PKT,VK)                  !!! dE(kj)/dk
	CALL MCTTRINT0(E,EF,OT,AT,AD,TS,DS,'B','W')! d.o.s.
	SPTOS(IBNDS)=SPTOS(IBNDS)+TS
	SPDOS(IBNDS)=SPDOS(IBNDS)+DS
	DO IVEL=1,3                            !!! velocities
	SPVEL(IVEL,IBNDS)=SPVEL(IVEL,IBNDS)+DS*VK(IVEL)**2
        ENDDO         
        ENDDO                                  !!! over bands
	ENDDO                                  !!! over spin subbands
        ENDDO                                  !!! over tetrahedra
        ENDDO                                  !!! over cells along G1
        ENDDO                                  !!! over cells along G2
        ENDDO                                  !!! over cells along G3
C  NORMALIZATION
	DO IBNDS=1,NSPIN
	SPTOS(IBNDS)=SPTOS(IBNDS)/VOLIBZ*2.D0/DBLE(NSPIN)!!! tos
	SPDOS(IBNDS)=SPDOS(IBNDS)/VOLIBZ*2.D0/DBLE(NSPIN)!!! dos
	SPVEL(1,IBNDS)=SPVEL(1,IBNDS)/VOLIBZ*2.D0/DBLE(NSPIN)! <v_x^2>
	SPVEL(2,IBNDS)=SPVEL(2,IBNDS)/VOLIBZ*2.D0/DBLE(NSPIN)! <v_y^2>
	SPVEL(3,IBNDS)=SPVEL(3,IBNDS)/VOLIBZ*2.D0/DBLE(NSPIN)! <v_z^2>
	ENDDO
	TOS=(SPTOS(1)+SPTOS(NSPIN))/2.D0*DBLE(NSPIN)
	DOS=(SPDOS(1)+SPDOS(NSPIN))/2.D0*DBLE(NSPIN)
	VEL(1)=(SPVEL(1,1)+SPVEL(1,NSPIN))/2.D0*DBLE(NSPIN)
	VEL(2)=(SPVEL(2,1)+SPVEL(2,NSPIN))/2.D0*DBLE(NSPIN)
	VEL(3)=(SPVEL(3,1)+SPVEL(3,NSPIN))/2.D0*DBLE(NSPIN)
C  PRINT DOS
        WRITE(IUN,1010)EF,TOS,DOS
1010    FORMAT(' EF,TOS,DOS==',3(1X,G14.7))
	IF(NSPIN.EQ.2.AND.NORBS.EQ.1)THEN
        WRITE(IUN,1020)SPTOS(1)    ,SPDOS(1)
        WRITE(IUN,1030)SPTOS(NSPIN),SPDOS(NSPIN)
        WRITE(IUN,1040)SPTOS(1)-SPTOS(NSPIN)
1020    FORMAT('    TUP,DUP==',15X,2(1X,G14.7))
1030    FORMAT('    TDN,DDN==',15X,2(1X,G14.7))
1040	FORMAT(' MM=TUP-TDN==',15X,1X,G14.7)
	ENDIF
C  PRINT VELOCITIES
        WRITE(IUN,1050)
1050    FORMAT(1X,'Calculated average square of electron velocities:')
        WRITE(IUN,1060)(VEL(I),I=1,3)
	IF(NSPIN.EQ.2.AND.NORBS.EQ.1)THEN
        WRITE(IUN,1070)(SPVEL(I,1),I=1,3)
        WRITE(IUN,1080)(SPVEL(I,NSPIN),I=1,3)
1060    FORMAT(1X,'<Vx^2>=',G14.7,' ; <Vy^2>=',G14.7,' ; <Vz^2>=',G14.7)
1070    FORMAT(1X,'<Ux^2>=',G14.7,' ; <Uy^2>=',G14.7,' ; <Uz^2>=',G14.7)
1080    FORMAT(1X,'<Dx^2>=',G14.7,' ; <Dy^2>=',G14.7,' ; <Dz^2>=',G14.7)
	ENDIF
C  PRINT PLASMA FREQUENCIES
        WRITE(IUN,1090)
1090    FORMAT(1X,'Calculated bare plasma frequencies (in eV):')
        WRITE(IUN,1100)(13.6058D0*SQRT(8.D0*PI*VEL(I)/OMEGAC),I=1,3)
	IF(NSPIN.EQ.2.AND.NORBS.EQ.1)THEN
        WRITE(IUN,1110)(13.6058D0*
     &  SQRT(8.D0*PI*SPVEL(I,1)/OMEGAC),I=1,3)
        WRITE(IUN,1120)(13.6058D0*
     &  SQRT(8.D0*PI*SPVEL(I,NSPIN)/OMEGAC),I=1,3)
1100    FORMAT(1X,'om_p^x=',G14.7,' ; om_p^y=',G14.7,' ; om_p^z=',G14.7)
1110    FORMAT(1X,'om_u^x=',G14.7,' ; om_u^y=',G14.7,' ; om_u^z=',G14.7)
1120    FORMAT(1X,'om_d^x=',G14.7,' ; om_d^y=',G14.7,' ; om_d^z=',G14.7)
	ENDIF
	RETURN
	END




        SUBROUTINE GETVEL(E0,Q0,V)
*************************************************
*  Calculates velocities inside the tetrahedron *
*************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
        DIMENSION E0(4),Q0(3,4),V(3),Q(3,3),EV(3)
        DO J=1,3
        EV(J)=E0(J)-E0(4)
        DO I=1,3
        Q(J,I)=Q0(I,J)-Q0(I,4)
	ENDDO
	ENDDO
        CALL SIMQ(Q,EV,3,3,IFAIL)
        IF(IFAIL.NE.0)PRINT*,'<GETVEL>: SIMQ FAILS'
        DO IV=1,3
        V(IV)=EV(IV)
	ENDDO
        END
