	SUBROUTINE VCHEB
**************************************************************
*  Find Chebyshev expansion of the potential in the          *
*  interstitial region.                                      *
*  Written by S.Yu.Savrasov (P.N.Lebedev Physical Institute) *
**************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	PARAMETER (LPLMAX=(2*LMAXV+1)**2)
	INTEGER ILSV(NSORTMAX),ILST(NSORTMAX),ILSB(NSORTMAX)
     &    ,IS(NPAT),NHSORT(NSORTMAX),LMSYM(LMMAXV,NPAT)
     &    ,NSHE(NSORTMAX),NPOL(0:NSORTMAX)
	DIMENSION SMT(NSORTMAX),RINT(0:NSHEMAX,NSORTMAX),SROU(NSORTMAX)
     &   ,VSF(NSORTMAX,NSPINMAX),C(0:LMAXV+1,LMMAXV1,LMMAXV1)
     &   ,XINT(0:NSHEMAX,NSORTMAX),TT(0:NPOLMAX,0:NSHEMAX,NSORTMAX)
     &   ,VMT(NSORTMAX,NSPINMAX),VAVINT(NPAT,NSPINMAX)
     &   ,SASA(NSORTMAX)
	COMPLEX*16 VINT(0:NSHEMAX,NSYMMAX,NPAT,NSPINMAX)
     &    ,RMAT(0:NPOLMAX,LPLMAX),TMAT(0:NPOLMAX,0:NPOLMAX)
     &    ,CONVV(0:NPOLMAX,NSYMMAX,NPAT,NSPINMAX),DIM
     &    ,CHEBV(0:NPOLMAX,NSYMMAX,NPAT,NSPINMAX)
	LOGICAL SYM(LMMAXV,NPAT)
	COMMON /CONTROL/MAN,LMTO,NLR,NINT                   !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT!!! from init
	COMMON /POTCOM/ SWZ,SMT                             !!! from init
	COMMON /VINT/   VINT                                !!! for vfull
	COMMON /CHEBV/  CHEBV,CONVV                         !!! for nmtins
	COMMON /VZERO/  VMT0,VMT,VSF0,VSF,VAV,VAVINT        !!! from vzero
	COMMON /SYMMLM/ SYM,LMSYM                           !!! from symlm
	COMMON /ASASPH/ SASA                                !!! from init
	COMMON /GAUNT/  C                                   !!! from gdata
	COMMON /STORE2/ RMAT                                !!! from srfmsh
	COMMON /INTMESH/NSHE,NPOL,SROU,RINT,XINT,TT         !!! from init
	COMMON /SPIN/   NSPIN                               !!! from init
	COMMON /UNIT/   IUN                                 !!! from init
	DATA PI/3.141592653589793D0/,DIM/(0.D0,1.D0)/
	SQPI8=SQRT(8.D0*PI)
	IF(NINT.EQ.0)RETURN
	VAV=0.D0
	OMEGAMT=0.D0
	OMEGACL=0.D0
	DO 130 ISPIN=1,NSPIN                  !!! over spins
	DO 120 IATOM=1,NATOM                  !!! over atoms
	ISORT=IS(IATOM)
	VAVINT(IATOM,ISPIN)=0.D0
C FIND CHEBYSHEV EXPANSION COEFFICIENTS
	DO 40 L=0,ILSV(ISORT)                 !!! over l
	DO 30 M=-L,L                          !!! over m
	LM=L*(L+1)+M+1
	IF(SYM(LM,IATOM))THEN
	ISYM=LMSYM(LM,IATOM)
	DO 20 IPOL=0,NPOL(ISORT)              !!! over polinoms
	CHEBV(IPOL,ISYM,IATOM,ISPIN)=(0.D0,0.D0)
	CONVV(IPOL,ISYM,IATOM,ISPIN)=(0.D0,0.D0)
	DO 10 I=1,NSHE(ISORT)                 !!! over radial mesh
	CHEBV(IPOL,ISYM,IATOM,ISPIN)=CHEBV(IPOL,ISYM,IATOM,ISPIN)+
     &  2.D0/NSHE(ISORT)*VINT(I,ISYM,IATOM,ISPIN)*TT(IPOL,I,ISORT)
  10	CONTINUE                              !!! over radial mesh
  20	CONTINUE                              !!! over polinoms
	ENDIF
  30	CONTINUE                              !!! over m
  40	CONTINUE                              !!! over l
C  READ SURFACE CONSTANTS FROM SCRATCH FILE 1
	DO 45 IPOL=0,NPOL(ISORT)
	IREC=IPOL+1+(NPOL(0)+1)*(IATOM-1)+NATOM+1
	READ(11,REC=IREC)(RMAT(IPOL,LM),LM=1,(2*ILSV(ISORT)+1)**2)
  45	CONTINUE
C  AND PERFORM CONVOLUTION WITH T-MATRIX
	DO 110 L2=0,2*ILSV(ISORT)
	LL2=L2/2
	DO 100 M2=-L2,L2
	L2M2=L2*(L2+1)+M2+1
	CALL CONVOLCH(NPOL(ISORT),RMAT(0,L2M2),TMAT(0,0),1)
	DO 90 L=0,ILSV(ISORT)                !!! over l
	DO 80 M=-L,L                         !!! over m
	LM=L*(L+1)+M+1
	IF(SYM(LM,IATOM))THEN                !!! only for non-zero components
	ISYM=LMSYM(LM,IATOM)
	DO 70 IPOL=0,NPOL(ISORT)             !!! over polinoms
	DO 60 L1=ABS(L-L2),L+L2,2            !!! over l1
	M1=M2+M                              !!! over m1
	IF(L1.LE.ILSV(ISORT).AND.ABS(M1).LE.L1)THEN
	L1M1=L1*(L1+1)+M1+1
	IF(SYM(L1M1,IATOM))THEN              !!! only for non-zero components
	ISYM1=LMSYM(L1M1,IATOM)
	DO 50 IPOL1=0,NPOL(ISORT)            !!! over polynoms
	IF(IPOL1+IPOL.LE.NPOL(ISORT))THEN    !!! when T.ne.0
	CONVV(IPOL,ISYM,IATOM,ISPIN)=CONVV(IPOL,ISYM,IATOM,ISPIN)+
     &  CHEBV(IPOL1,ISYM1,IATOM,ISPIN)*C(LL2,L1M1,LM)*DIM**(L1-L)*
     &  TMAT(IPOL1,IPOL)
	ENDIF                                !!! when T.ne.0
  50	CONTINUE                             !!! over polynoms
	ENDIF                                !!! only for non-zero components
	ENDIF                                !!! over m1
  60	CONTINUE                             !!! over l1
  70	CONTINUE                             !!! over polinoms
	ENDIF                                !!! only for non-zero components
  80	CONTINUE                             !!! over m
  90	CONTINUE                             !!! over l
 100	CONTINUE                             !!! over m2
 110	CONTINUE                             !!! over l2
	OMEGAM=4.D0*PI/3.D0*SMT (IS(IATOM))**3
	OMEGAC=4.D0*PI/3.D0*SASA(IS(IATOM))**3
	VAV=VAV+SQPI8*CONVV(0,1,IATOM,ISPIN)
	OMEGAMT=OMEGAMT+OMEGAM
	OMEGACL=OMEGACL+OMEGAC
	VAVINT(IATOM,ISPIN)=SQPI8*CONVV(0,1,IATOM,ISPIN)/(OMEGAC-OMEGAM) 
 120	CONTINUE                             !!! over atoms
 130	CONTINUE                             !!! over spins
	OMEGAINT=4.D0*PI/3.D0*SWZ**3*DBLE(NSPIN*NATOM)-OMEGAMT
	IF(ABS(OMEGAINT+OMEGAMT-OMEGACL).GE.1.D-10)PRINT*,
     &  '<VCHEB>:: INTERSTITIAL VOLUME ERROR'
	VAV=VAV/OMEGAINT
	END
