	SUBROUTINE VCOUL
************************************************************
*  The calculation of the Coulomb potential within MTS     *
*  without nuclear part.                                   * 
*  Written by S.Yu.Savrasov (P.N.Lebedev Physical Instit.) *
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,IS(NPAT),NHSORT(NSORTMAX),LMSYM(LMMAXV,NPAT),NRAD(NSORTMAX)
     &    ,ISPL(NSORTMAX)
	COMPLEX*16 VC1(0:NRADMAX),VC2(0:NRADMAX),QASA(NSYMMAX,NPAT)
     &    ,VDS(3,NSYMMAX,NPAT,NSPINMAX),AMTOT(NSYMMAX,NPAT,NSPINMAX)
     &    ,TCH(NSYMMAX,NPAT,2,NSPINMAX),QINT(NSYMMAX,NPAT)
     &    ,V(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX)
     &    ,ROCOR(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX)
     &    ,RO(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX)
     &    ,ROVALDS(3,NSYMMAX,NPAT,NSPINMAX)
	DIMENSION H(NSORTMAX),R(0:NRADMAX,NSORTMAX)
     &    ,WEIGHT(0:NRADMAX,NSORTMAX),DR(0:NRADMAX,NSORTMAX)
     &    ,SMT(NSORTMAX),RL(0:NRADMAX,0:LMAXV,NSORTMAX)
     &    ,Z(NSORTMAX),ZCOR(NSORTMAX),SPLIT(NSORTMAX)
     &    ,VSPH(0:NRADMAX,NSORTMAX,NSPINMAX)
	LOGICAL SYM(LMMAXV,NPAT)
	CHARACTER TXTEL(NSORTMAX)*10
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT!!! from init
	COMMON /POTCOM/ SWZ,SMT,VSPH,V,VDS                  !!! for bands
	COMMON /DENS/   RO,ROVALDS,ROCOR                    !!! from rofull
	COMMON /RADMESH/NRAD,H,R,DR,WEIGHT,RL               !!! from init
	COMMON /SYMMLM/ SYM,LMSYM                           !!! from symmlm
	COMMON /MULTRO/ Z,ZCOR,TCH,AMTOT,QASA,QINT          !!! from mult
	COMMON /SPIN/   NSPIN,SPLIT,ISPL                    !!! from init
	COMMON /EXCH/   IXC                                 !!! from init
	COMMON /UNIT/   IUN                                 !!! from init
	COMMON /TXTEL/  TXTEL                               !!! from init
	DATA PI/3.141592653589793D0/
	SQPI4=2.D0*SQRT(PI)
C  **** CALCULATE COULOMB CONTRIBUTION TO THE POTENTIAL **** 
	DO 80 IATOM=1,NATOM                 !!! over all atoms in cell
	ISORT=IS(IATOM)
	DO 70 ISPIN=1,NSPIN                 !!! over spins
C  DO OVER SPHERICAL HARMONICS EXPANSIONS
	DO 60 L=0,ILSV(ISORT)               !!! over l
	DO 50 M=-L,L                        !!! over m
	LM=L*(L+1)+M+1
	ISYM=LMSYM(LM,IATOM)
	SL=SMT(ISORT)**L
	IF(SYM(LM,IATOM))THEN               !!! for only non-zero components
	DO 10 IRAD=0,NRAD(ISORT)            !!! over radial mesh
	V(IRAD,ISYM,IATOM,ISPIN)=(0.D0,0.D0)
  10	CONTINUE                            !!! over radial mesh
	DO 20 ID=1,3
	VDS(ID,ISYM,IATOM,ISPIN)=(0.D0,0.D0)
  20	CONTINUE
C   COULOMB CONTRIBUTION  (EXTERNAL PART)
	DO 30 IRAD=0,NRAD(ISORT)            !!! over radial mesh
	V(IRAD,ISYM,IATOM,ISPIN)=V(IRAD,ISYM,IATOM,ISPIN)+2.D0*
     &  (QASA(ISYM,IATOM)+QINT(ISYM,IATOM))*RL(IRAD,L,ISORT)/SL
  30	CONTINUE                            !!! over radial mesh
C   COULOMB CONTRIBUTION  (INTERNAL PART)
	CALL POISS1(VC1,VC2,L,ISYM,IATOM)   !!! solve the Poisson equation
	PL=2.D0/(2.D0*L+1.D0)
	DO 40 IRAD=0,NRAD(ISORT)            !!! over radial mesh
	V(IRAD,ISYM,IATOM,ISPIN)=V(IRAD,ISYM,IATOM,ISPIN)+
     &  PL*(VC1(IRAD)+VC2(IRAD))
  40	CONTINUE                            !!! over radial mesh
	ENDIF                               !!! for only non-zero components
  50 	CONTINUE                            !!! over m
  60	CONTINUE                            !!! over l
  70	CONTINUE                            !!! over spins
  80	CONTINUE                            !!! over all atoms in cell
	END







	SUBROUTINE VCINT
***************************************************************
*   Calculate Coulomb potential in the interstitial region by *
*   the solution of the Poisson equation.                     *
*   Written by S.Savrasov (P.N.Lebedev Physical Institute)    *
***************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,IS(NPAT),NHSORT(NSORTMAX),LMSYM(LMMAXV,NPAT),NRAD(NSORTMAX)
     &    ,ISPL(NSORTMAX),NSHE(NSORTMAX),NPOL(0:NSORTMAX)
	COMPLEX*16 ROINT(0:NSHEMAX,NSYMMAX,NPAT,NSPINMAX)
     &    ,ROVALDS(3,NSYMMAX,NPAT,NSPINMAX),QASA(NSYMMAX,NPAT)
     &    ,AMTOT(NSYMMAX,NPAT,NSPINMAX),QINT(NSYMMAX,NPAT)
     &    ,TCH(NSYMMAX,NPAT,2,NSPINMAX),VDS(3,NSYMMAX,NPAT,NSPINMAX)
     &    ,RO   (0:NRADMAX,NSYMMAX,NPAT,NSPINMAX),ROTOT(0:NSHEMAX)
     &    ,ROCOR(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX),RODS(3),TMP
     &    ,V    (0:NRADMAX,NSYMMAX,NPAT,NSPINMAX),VCDS(3,NSYMMAX)
     &    ,VINT (0:NSHEMAX,NSYMMAX,NPAT,NSPINMAX)
	DIMENSION SMT(NSORTMAX),RINT(0:NSHEMAX,NSORTMAX),SROU(NSORTMAX)
     &   ,Z(NSORTMAX),ZCOR(NSORTMAX),SPLIT(NSORTMAX)
     &   ,VSPH(0:NRADMAX,NSORTMAX,NSPINMAX)
	LOGICAL SYM(LMMAXV,NPAT)
	CHARACTER TXTEL(NSORTMAX)*10
	COMMON /CONTROL/MAN,LMTO,NLR,NINT                   !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT!!! from init
	COMMON /POTCOM/ SWZ,SMT,VSPH,V,VDS                  !!! from init
	COMMON /DENS/   RO,ROVALDS,ROCOR,ROINT              !!! from rofull
	COMMON /VINT/   VINT                                !!! from vint
	COMMON /VZERO/  VMT0,VMT,VSF0,VSF,VAV               !!! from vzero
	COMMON /INTMESH/NSHE,NPOL,SROU,RINT                 !!! from init
	COMMON /RADMESH/NRAD                                !!! from radmsh
	COMMON /SYMMLM/ SYM,LMSYM                           !!! from symmlm
	COMMON /MULTRO/ Z,ZCOR,TCH,AMTOT,QASA,QINT          !!! from mult
	COMMON /SPIN/   NSPIN,SPLIT,ISPL                    !!! from init
	COMMON /EXCH/   IXC                                 !!! from init
	COMMON /UNIT/   IUN                                 !!! from init
	COMMON /TXTEL/  TXTEL                               !!! from init
	DATA PI/3.141592653589793D0/
	SQPI4=2.D0*SQRT(PI)
	IF(NINT.EQ.0)RETURN
C  **** CALCULATE COULOMB CONTRIBUTION BY SOLVING POISSON EQUATION ****
	DO 50 IATOM=1,NATOM                   !!! over atoms
	ISORT=IS(IATOM)
	ST=SMT(ISORT)
	DO 40 ISPIN=1,NSPIN                   !!! over spins
C  DO OVER SPHERICAL HARMONICS EXPANSION
	DO 30 L=0,ILSV(ISORT)                 !!! over l
	DO 20 M=-L,L                          !!! over m
	LM=L*(L+1)+M+1
	IF(SYM(LM,IATOM))THEN
	ISYM=LMSYM(LM,IATOM)
C  CALCULATE POTENTIAL DERIVATIVES AT THE SPHERE BOUNDARY
	TMP=(AMTOT(ISYM,IATOM,1)-TCH(ISYM,IATOM,2,1)+
     &  AMTOT(ISYM,IATOM,NSPIN)-TCH(ISYM,IATOM,2,NSPIN))/
     &  2.D0*DFLOAT(NSPIN)
	VCDS(1,ISYM)=2.D0*SQPI4*TMP/ST/(2.D0*L+1.D0)+
     &  2.D0*(QASA(ISYM,IATOM)+QINT(ISYM,IATOM))
	VCDS(2,ISYM)=-2.D0*SQPI4*TMP*(L+1.D0)/ST/ST/(2.D0*L+1.D0)+
     &  2.D0*L*(QASA(ISYM,IATOM)+QINT(ISYM,IATOM))/ST
	VCDS(3,ISYM)=2.D0*SQPI4*TMP*(L+1.D0)*(L+2.D0)/ST/ST/ST/
     &  (2.D0*L+1.D0)+2.D0*L*(L+1.D0)*(QASA(ISYM,IATOM)+
     &  QINT(ISYM,IATOM))/ST/ST-8.D0*PI*
     &  (ROVALDS(1,ISYM,IATOM,1)+ROVALDS(1,ISYM,IATOM,NSPIN))/
     &  2.D0*DFLOAT(NSPIN)
	RODS(1)=(ROVALDS(1,ISYM,IATOM,1)+
     &  ROVALDS(1,ISYM,IATOM,NSPIN))/2.D0*DFLOAT(NSPIN)
	RODS(2)=(ROVALDS(2,ISYM,IATOM,1)+
     &  ROVALDS(2,ISYM,IATOM,NSPIN))/2.D0*DFLOAT(NSPIN)
	RODS(3)=(ROVALDS(3,ISYM,IATOM,1)+
     &  ROVALDS(3,ISYM,IATOM,NSPIN))/2.D0*DFLOAT(NSPIN)
	DO 10 ISHE=0,NSHE(ISORT)+1
	ROTOT(ISHE)=(ROINT(ISHE,ISYM,IATOM,1)+
     &  ROINT(ISHE,ISYM,IATOM,NSPIN))/2.D0*DFLOAT(NSPIN)
   10 	CONTINUE
C  SOLVE POISSON EQUATION IN THE INTERSTITIAL REGION
	CALL POISS2(VINT(0,ISYM,IATOM,ISPIN),VCDS(1,ISYM),L,NSHE(ISORT),
     &  RINT(0,ISORT),ROTOT(0),RODS(1))
	ENDIF
   20	CONTINUE                               !!! over m
   30	CONTINUE                               !!! over l
   40	CONTINUE                               !!! over spins
   50	CONTINUE                               !!! over atoms
	END


	SUBROUTINE POISS1(VC1,VC2,L,ISYM,IATOM)
*************************************************************
* The solution of the Poisson equation whithin MT-spheres.  * 
*************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX),IS(NPAT)
     &   ,NRAD(NSORTMAX)
	COMPLEX*16 WORK1,WORK2,VC1,VC2,RO,ROTOT(0:NRADMAX)
	DIMENSION RO(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX)
     &   ,DR(0:NRADMAX,NSORTMAX),H(NSORTMAX),WORK2(0:NRADMAX)
     &   ,VC1(0:NRADMAX),VC2(0:NRADMAX),R(0:NRADMAX,NSORTMAX)
     &   ,WEIGHT(0:NRADMAX,NSORTMAX),WORK1(0:NRADMAX)
     &   ,RL(0:NRADMAX,0:LMAXV,NSORTMAX)
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM     !!! from init
	COMMON /DENS/   RO                                !!! from ro_full
	COMMON /RADMESH/NRAD,H,R,DR,WEIGHT,RL             !!! from radmsh
	COMMON /SPIN/   NSPIN                             !!! from init
C   INITIATION
	ISORT=IS(IATOM)
	DO 1 IRAD=0,NRAD(ISORT)
	ROTOT(IRAD)=(RO(IRAD,ISYM,IATOM,1)+RO(IRAD,ISYM,IATOM,NSPIN))/
     &  2.D0*DFLOAT(NSPIN)
    1	CONTINUE
C   SOLUTION OF THE POISSON EQUATION
	DO 10 IRAD=0,NRAD(ISORT)
	WORK1(IRAD)=ROTOT(IRAD)*WEIGHT(IRAD,ISORT)*RL(IRAD,L,ISORT)
  10	CONTINUE
	CALL CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
	VC1(0)=0.0
	DO 20 IRAD=1,NRAD(ISORT)
	VC1(IRAD)=WORK2(IRAD)
	DO 15 L1=1,L+1
	VC1(IRAD)=VC1(IRAD)/R(IRAD,ISORT)
  15	CONTINUE
  20	CONTINUE
	WORK1(0)=0.0
	DO 30 IRAD=1,NRAD(ISORT)
	WORK1(IRAD)=ROTOT(IRAD)*WEIGHT(IRAD,ISORT)
	DO 25 L1=1,L+1
	WORK1(IRAD)=WORK1(IRAD)/R(IRAD,ISORT)
  25	CONTINUE
  30	CONTINUE
	IF(L.LE.1)THEN
	CALL CQD(H(ISORT),WORK1(0),WORK2(0),NRAD(ISORT)+1)
	ELSE
	CALL CQD(H(ISORT),WORK1(2),WORK2(2),NRAD(ISORT)-1)
	WORK2(1)=-(WORK1(1)+WORK1(2))*0.5D0*H(ISORT)
	ENDIF
	VC2(0)=0.0
	DO 40 IRAD=1,NRAD(ISORT)
	VC2(IRAD)=(WORK2(NRAD(ISORT))-WORK2(IRAD))*RL(IRAD,L,ISORT)
  40	CONTINUE
	IF(L.EQ.0)VC2(0)=WORK2(NRAD(ISORT))
	END


	SUBROUTINE POISS2(VINT,VCDS,L,NSHE,RINT,ROINT,ROVALDS)
****************************************************************************
*    The solution of the Poisson equation in the interstitial region       *
*    Written by S.Savrasov (P.N.Lebedev Physical Institute)                *
****************************************************************************
	IMPLICIT REAL*8 (A-C,E-H,O-Z)
	IMPLICIT COMPLEX*16 (D)
	INCLUDE 'PARAM.DAT'
	COMPLEX*16 ROVALDS(3),VCDS(3),PP(0:NSHEMAX),QQ(0:NSHEMAX)
     &  	  ,VINT(0:NSHEMAX),ROINT(0:NSHEMAX),TMP
	DIMENSION RINT(0:NSHEMAX)
	DATA PI/3.141592653589793D0/
	SQPI4=2.D0*SQRT(PI)
C  SET BOUNDARY POINTS
	ST=RINT(0)
	S1=RINT(1)
	SI=RINT(NSHE)
	SE=RINT(NSHE+1)
	AT=0.5D0*(SE+ST)
	BT=0.5D0*(SE-ST)
C  SET FUNCTIONS IN THE INITIAL POINTS BY TEILOR SERIES
	PP(0)=ST*VCDS(1)
	DPDR=VCDS(1)+ST*VCDS(2)
	QQ(0)=DPDR-(L+1.D0)/ST*PP(0)
	DQDR=-8.D0*PI*ST*ROVALDS(1)-(L+1.D0)/ST*QQ(0)
	D2PDR2=DQDR-(L+1.D0)/ST/ST*PP(0)+(L+1.D0)/ST*DPDR
	D2QDR2=-8.D0*PI*ROVALDS(1)-8.D0*PI*ROVALDS(2)*ST
     &   +(L+1.D0)/ST/ST*QQ(0)-(L+1.D0)/ST*DQDR
C t	D3PDR3=D2QDR2+2.D0*(L+1.D0)/ST/ST/ST*PP(0)-2.D0*(L+1.D0)/ST/ST*DPDR
C h	1 +(L+1.D0)/ST*D2PDR2
C i	D3QDR3=-16.D0*PI*ROVALDS(2)-8.D0*PI*ROVALDS(3)*ST
C r	1 -2.D0*(L+1.D0)/ST/ST/ST*QQ(0)+2.D0*(L+1.D0)/ST/ST*DQDR-(L+1.D0)/ST
C d	1 *D2QDR2
	PP(1)=PP(0)+(S1-ST)*DPDR+0.5D0*(S1-ST)**2*D2PDR2
C	1 +(1.D0/6.D0)*(S1-ST)**3*D3PDR3
	QQ(1)=QQ(0)+(S1-ST)*DQDR+0.5D0*(S1-ST)**2*D2QDR2
C	1 +(1.D0/6.D0)*(S1-ST)**3*D3QDR3
C  RUNGE-KUTTA LOOP
	DO 10 IRAD=1,NSHE-1                      !!! over radial mesh
	WE1=BT*PI/NSHE*SIN(PI*(2.D0*IRAD-1.D0)/2.D0/NSHE)
	WE2=BT*PI/NSHE*SIN(PI*(2.D0*IRAD     )/2.D0/NSHE)
	WE3=BT*PI/NSHE*SIN(PI*(2.D0*IRAD+1.D0)/2.D0/NSHE)
	RR1=AT-BT*COS(PI*(2.D0*IRAD-1.D0)/2.D0/NSHE)
	RR2=AT-BT*COS(PI*(2.D0*IRAD     )/2.D0/NSHE)
	RR3=AT-BT*COS(PI*(2.D0*IRAD+1.D0)/2.D0/NSHE)
	DRO1=ROINT(IRAD)
	IF(IRAD.NE.NSHE-1)DRO2=(9.D0*(ROINT(IRAD)+ROINT(IRAD+1))
     &   -ROINT(IRAD-1)-ROINT(IRAD+2))/16.D0
	IF(IRAD.EQ.NSHE-1)DRO2=(ROINT(IRAD)+ROINT(IRAD+1))/2.D0
	DRO3=ROINT(IRAD+1)
	DK1=WE1*(QQ(IRAD)+(L+1.D0)/RR1*PP(IRAD))
	DM1=WE1*(-8.D0*PI*RR1*DRO1-(L+1.D0)/RR1*QQ(IRAD))
	DK2=WE2*((QQ(IRAD)+DM1/2.D0)+(L+1.D0)/RR2*(PP(IRAD)+DK1/2.D0))
	DM2=WE2*(-8.D0*PI*RR2*DRO2-(L+1.D0)/RR2*(QQ(IRAD)+DM1/2.D0))
	DK3=WE2*((QQ(IRAD)+DM2/2.D0)+(L+1.D0)/RR2*(PP(IRAD)+DK2/2.D0))
	DM3=WE2*(-8.D0*PI*RR2*DRO2-(L+1.D0)/RR2*(QQ(IRAD)+DM2/2.D0))
	DK4=WE3*((QQ(IRAD)+DM3)+(L+1.D0)/RR3*(PP(IRAD)+DK3))
	DM4=WE3*(-8.D0*PI*RR3*DRO3-(L+1.D0)/RR3*(QQ(IRAD)+DM3))
	PP(IRAD+1)=PP(IRAD)+(DK1+2.D0*DK2+2.D0*DK3+DK4)/6.D0
	QQ(IRAD+1)=QQ(IRAD)+(DM1+2.D0*DM2+2.D0*DM3+DM4)/6.D0
  10	CONTINUE                            !!! over radial mesh
C  SET END POINTS BY TEILOR SERIES
	DPDR=QQ(NSHE)+(L+1.D0)/SI*PP(NSHE)
	DQDR=-8.D0*PI*SI*ROINT(NSHE)-(L+1.D0)/SI*QQ(NSHE)
	D2PDR2=DQDR-(L+1.D0)/SI/SI*PP(NSHE)+(L+1.D0)/SI*DPDR
	PP(NSHE+1)=PP(NSHE)+(SE-SI)*DPDR+0.5D0*(SE-SI)**2*D2PDR2
	QQ(NSHE+1)=QQ(NSHE)+(SE-SI)*DQDR
C  RETURN COULOMB CONTRIBUTION
	DO 20 IRAD=0,NSHE+1                 !!! over radial mesh
	VINT(IRAD)=PP(IRAD)/RINT(IRAD)
  20	CONTINUE                            !!! over radial mesh
	END
