	SUBROUTINE VXINT(KEY)
************************************************************
*  The calculation of the exchange-correlation potential   *
*  in the int.r. using direct spherical-harminic expansion.* 
*  Key=1 - potential, =2 - energy density                  *
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	PARAMETER (NTHEMAX=4*LMAXV+6)
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,IS(NPAT),NHSORT(NSORTMAX),LMSYM(LMMAXV,NPAT)
     &    ,NSHE(NSORTMAX),NPOL(0:NSORTMAX)
	COMPLEX*16 VINT(0:NSHEMAX,NSYMMAX,NPAT,NSPINMAX)
     &    ,RO(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX),ROTOT(NSPINMAX)
     &    ,ROCOR(0:NRADMAX,NSYMMAX,NPAT,NSPINMAX),YLMI(LMMAXV)
     &    ,ROINT(0:NSHEMAX,NSYMMAX,NPAT,NSPINMAX)
     &    ,VDS(3,NSYMMAX,NPAT,NSPINMAX),DIM,RHOL,RHOM
     &    ,ROVALDS(3,NSYMMAX,NPAT,NSPINMAX),YLM(LMMAXV)
	COMPLEX*16 FUN(0:NSHEMAX,LMMAXV)
     &    ,G1RO(0:NSHEMAX,LMMAXV,NSPINMAX,NGGAMAX)
     &    ,G2RO(0:NSHEMAX,LMMAXV,NSPINMAX,NGGAMAX,NGGAMAX)
     &    ,GR1UP(-1:1),GR2UP(-1:1,-1:1),G1TOT(NSPINMAX,-1:1)
     &    ,GR1DN(-1:1),GR2DN(-1:1,-1:1),G2TOT(NSPINMAX,-1:1,-1:1)
	DIMENSION Z(NSORTMAX),SMT(NSORTMAX),SROU(NSORTMAX)
     &    ,ZL(NTHEMAX,2),WL(NTHEMAX,2),RINT(0:NSHEMAX,NSORTMAX)
     &    ,ZCOR(NSORTMAX)
	LOGICAL SYM(LMMAXV,NPAT)
	CHARACTER TXTEL(NSORTMAX)*10
C Controls:
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT!!! from readini
	COMMON /SPIN/   NSPIN                               !!! from readini
	COMMON /EXCH/   IXC                                 !!! from readini
C Inputs:
	COMMON /POTCOM/ SWZ,SMT                             !!! from readini
	COMMON /SYMMLM/ SYM,LMSYM                           !!! from sym
	COMMON /MULTRO/ Z,ZCOR                              !!! from readini
C Potential:
	COMMON /VINT/   VINT                                !!! from vxint
C Density:
	COMMON /DENS/   RO,ROVALDS,ROCOR,ROINT              !!! from rofull
C Temporary storage:
        COMMON /STORE2/ FUN,G1RO                            !!! tmp.storage
        COMMON /STORE1/ G2RO                                !!! tmp.storage
C Interstital mesh:
	COMMON /INTMESH/NSHE,NPOL,SROU,RINT                 !!! from intmesh
C Outputs:
	COMMON /UNIT/   IUN                                 !!! from readini
	COMMON /TXTEL/  TXTEL                               !!! from readini
	DATA PI/3.141592653589793D0/
        SQPI4=2.D0*SQRT(PI)
        SFACT=0.5D0*DBLE(NSPIN)
C Set keys for LDA and GGA
        ILDA=MOD(IXC,10)     !!! LDA key
        IGGA=(IXC-ILDA)/10   !!! GGA key
        DO 1000 IATOM=1,NATOM               !!! over all atoms in cell
        ISORT=IS(IATOM)
C Set gradients to zero
        DO MY=-1,1
        GR1UP(MY)=(0.D0,0.D0)
        GR1DN(MY)=(0.D0,0.D0)
        DO MY1=-1,1
        GR2UP(MY,MY1)=(0.D0,0.D0)
        GR2DN(MY,MY1)=(0.D0,0.D0)
        ENDDO
        ENDDO
        ALRUP=0.D0
        ALRDN=0.D0
C  **** COMPUTE DENSITY GRADIENTS FOR GGA ****
        IF(IGGA.NE.0)THEN
        DO ISPIN=1,NSPIN                    !!! over spins
        DO L=0,ILSV(ISORT)
        DO M=-L,L
        LM=L*(L+1)+M+1
        ISYM=LMSYM(LM,IATOM)
        DO IRAD=0,NSHE(ISORT)+1
        FUN(IRAD,LM)=(0.D0,0.D0)
        IF(SYM(LM,IATOM))
     &  FUN(IRAD,LM)=ROINT(IRAD,ISYM,IATOM,ISPIN)
        ENDDO
        ENDDO
        ENDDO
        DO MY=-1,1                          !!! over directions
C Nabla_mu(Rho)
        CALL GRADFINT(FUN(0,1),G1RO(0,1,ISPIN,MY+2),MY,ILSV(ISORT),
     &  NSHE(ISORT),RINT(0,ISORT),SMT(ISORT),SROU(ISORT))
        DO MY1=-1,1                         !!! over directions
C Nabla_mu*Nabla_mu'(Rho)
        CALL GRADFINT(G1RO(0,1,ISPIN,MY+2),G2RO(0,1,ISPIN,MY+2,MY1+2),
     &  MY1,ILSV(ISORT),NSHE(ISORT),RINT(0,ISORT),SMT(ISORT),
     &  SROU(ISORT))
        ENDDO                               !!! over directions
        ENDDO                               !!! over directions
        ENDDO                               !!! over spins
        ENDIF
C  **** CALCULATE EXCHANGE-CORRELATION BY DIRECT EXPANSION ****
        IF(ABS(Z(ISORT)).GE.1.D-05)RCUT2=0.3D0*Z(ISORT)**(1.D0/3.D0)
        IF(ABS(Z(ISORT)).LE.1.D-05)RCUT2=0.0D0
        NTHETA=2*ILSV(ISORT)+3
        IF(IGGA.EQ.0)NTWO=1 ! do not increase mesh in LDA
        IF(IGGA.NE.0)NTWO=2 ! increase mesh twice for GGA
        CALL MKLEGW(     NTHETA,ZL(1,1),WL(1,1),0)
        CALL MKLEGW(NTWO*NTHETA,ZL(1,2),WL(1,2),0)
	DO 400 IRAD=0,NSHE(ISORT)+1         !!! over radial mesh
        IF(RINT(IRAD,ISORT).LE.RCUT2)MTWO=1
        IF(RINT(IRAD,ISORT).GT.RCUT2)MTWO=NTWO
        DO 300 ITHETA=1,NTHETA*MTWO         !!! over theta
        NPHI=NTHETA*MTWO
        ZCOORD=ZL(ITHETA,MTWO)
        STHETA=SQRT(1.D0-ZCOORD*ZCOORD)
        DPHI=2.D0*PI/DBLE(NPHI)
        WGTL=DPHI*WL(ITHETA,MTWO)
        DO 200 IPHI=1,NPHI                  !!! over phi
        PHI=DBLE(IPHI-1)*DPHI
        XCOORD=COS(PHI)*STHETA
        YCOORD=SIN(PHI)*STHETA
        CALL SPHHARM(XCOORD,YCOORD,ZCOORD,ILSV(ISORT),YLM)
        DIM=(0.D0,-1.D0)
        DO L=0,ILSV(ISORT)
        DIM=DIM*(0.D0,1.D0)
        DO M=-L,L
        LM=L*(L+1)+M+1
        YLMI(LM)=YLM(LM)*DIM
        ENDDO
        ENDDO
C  SET UP TOTAL DENSITY AT THE POINT "R,THETA,PHI"
	DO ISPIN=1,NSPIN                    !!! over spins 
	ROTOT(ISPIN)=(0.D0,0.D0)
	DO L=0,ILSV(ISORT)	            !!! over l 
	DO M=-L,L                           !!! over m 
	LM=L*(L+1)+M+1
	IF(SYM(LM,IATOM))THEN
	ISYM=LMSYM(LM,IATOM)
	ROTOT(ISPIN)=ROTOT(ISPIN)+
     &  ROINT(IRAD,ISYM,IATOM,ISPIN)*YLMI(LM)
	ENDIF
        ENDDO                               !!! over m
        ENDDO                               !!! over l
        ENDDO                               !!! over spins 
C  SET UP DENSITY GRADIENT AT THE POINT "R,THETA,PHI"
        IF(IGGA.NE.0)THEN
        DO MY=-1,1                          !!! over directions
        DO ISPIN=1,NSPIN                    !!! over spins
        G1TOT(ISPIN,MY   )=(0.D0,0.D0)
        G2TOT(ISPIN,MY,-1)=(0.D0,0.D0)
        G2TOT(ISPIN,MY, 0)=(0.D0,0.D0)
        G2TOT(ISPIN,MY,+1)=(0.D0,0.D0)
        DO L=0,ILSV(ISORT)                  !!! over l
        DO M=-L,L                           !!! over m
        LM=L*(L+1)+M+1
        G1TOT(ISPIN,MY   )=G1TOT(ISPIN,MY   )+
     &  YLMI(LM)*G1RO(IRAD,LM,ISPIN,MY+2   )
        G2TOT(ISPIN,MY,-1)=G2TOT(ISPIN,MY,-1)+
     &  YLMI(LM)*G2RO(IRAD,LM,ISPIN,MY+2,-1+2)
        G2TOT(ISPIN,MY, 0)=G2TOT(ISPIN,MY, 0)+
     &  YLMI(LM)*G2RO(IRAD,LM,ISPIN,MY+2, 0+2)
        G2TOT(ISPIN,MY,+1)=G2TOT(ISPIN,MY,+1)+
     &  YLMI(LM)*G2RO(IRAD,LM,ISPIN,MY+2,+1+2)
        ENDDO                               !!! over m
        ENDDO                               !!! over l
        ENDDO                               !!! over spins
        ENDDO                               !!! over directions
        ENDIF
C  FIND CONTRIBUTION TO EXCHANGE-CORRELATION POTENTIAL FROM "R,THETA,PHI"
C  Spin densities
        ROUP=DREAL(ROTOT(1    ))*SFACT
        RODN=DREAL(ROTOT(NSPIN))*SFACT
C  Spin gradients
        IF(IGGA.NE.0)THEN
        ALRUP=0.D0
        ALRDN=0.D0
        DO MY=-1,1
        GR1UP(MY)=G1TOT(1    ,MY)*SFACT
        GR1DN(MY)=G1TOT(NSPIN,MY)*SFACT
        DO MY1=-1,1
        GR2UP(MY,MY1)=G2TOT(1    ,MY,MY1)*SFACT
        GR2DN(MY,MY1)=G2TOT(NSPIN,MY,MY1)*SFACT
        ENDDO
        ALRUP=ALRUP+(-1)**MY*GR2UP(MY,-MY)
        ALRDN=ALRDN+(-1)**MY*GR2DN(MY,-MY)
        ENDDO
        ENDIF
        CALL EXCVXC(ROUP,RODN,GR1UP,GR1DN,GR2UP,GR2DN,ALRUP,ALRDN,
     &       IXC,KEY,NSPIN,EXCUP,EXCDN,VXCUP,VXCDN)
        DO ISPIN=1,NSPIN                    !!! over spins
        IF(ISPIN.EQ.1.AND.KEY.EQ.1)XC=VXCUP
        IF(ISPIN.EQ.2.AND.KEY.EQ.1)XC=VXCDN
        IF(ISPIN.EQ.1.AND.KEY.EQ.2)XC=EXCUP
        IF(ISPIN.EQ.2.AND.KEY.EQ.2)XC=EXCDN
        RHOL=WGTL*XC
	DO L=0,ILSV(ISORT)	            !!! over l 
	DO M=-L,L                           !!! over m 
	LM=L*(L+1)+M+1
	IF(SYM(LM,IATOM))THEN
	ISYM=LMSYM(LM,IATOM)
	VINT(IRAD,ISYM,IATOM,ISPIN)=VINT(IRAD,ISYM,IATOM,ISPIN)+
     &	CONJG(YLMI(LM))*RHOL
	ENDIF
        ENDDO                               !!! over m
        ENDDO                               !!! over l
        ENDDO                               !!! over spins
 200    CONTINUE                            !!! over phi
 300    CONTINUE                            !!! over theta
 400    CONTINUE                            !!! over radial points
1000	CONTINUE                            !!! over atoms
	END
